'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  $RCSfile: calculation.inc,v $
'*
'*  $Revision: 1.2 $
'*
'*  last change: $Author: pj $ $Date: 2005/05/26 17:21:43 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/***********************************************************************
'*
'* owner : peter.junge@Sun.COM
'*
'* short description : clipboard special test with calculations
'*
'************************************************************************
'*
' #1 calculation_none
' #1 calculation_add
' #1 calculation_substract
' #1 calculation_multiply
' #1 calculation_devide
'*
'\***********************************************************************


sub calculation

Printlog Chr(13) + "--------- calculation operation ---------"

        call calculation_none
        call calculation_add
        call calculation_substract
        call calculation_multiply
        call calculation_devide

end sub

testcase calculation_none
'/// This test checks the operation functions from the paste special dialog in calc
'/// First we open the file (gTesttoolPath & "calc/special/input/clipboardtest.sxc")
   call hDateiOeffnen File
   sleep 3
'/// Then we goto the second sheet...
   call fCalcSelectSheet("PasteSpecial")
'/// + select the cellrange "A11:C12"
   call cBereichmarkieren("A11:C12")
   sleep 3
'/// + copy it and paste it into the other cellrange with the operation option
'/// + 'none'
   EditCopy
   Kontext "DocumentCalc"
   DocumentCalc.TypeKeys "<MOD1 HOME>"
   EditPasteSpecialCalc
   sleep 5
   Kontext "InhalteEinfuegenCalc"
   if NOT Keine.isChecked then Keine.Check
   InhalteEinfuegenCalc.OK
   Kontext "Active"
   if Active.exists then Active.YES
   printlog "Check, if the cell values from range 'A1:C2' are correct"
'/// Now check, if the cellcontents from cellrange 'A1:C2' are correct
   'checkCellValue("A1", "1")
   checkCellValue("A2", "2")
   checkCellValue("B1", "2")
   checkCellValue("B2", "3")
   checkCellValue("C1", "3")
   checkCellValue("C2", "4")
   sleep 15
   call hCloseDocument

endcase

testcase calculation_add
'/// Do the same as in tescase 'calculation_none' described, but with the
'/// + operation option 'add'
   call hDateiOeffnen File
   sleep 3
   call fCalcSelectSheet("PasteSpecial")
   call cBereichmarkieren("A11:C12")
   sleep 3
   EditCopy
   Kontext "DocumentCalc"
   DocumentCalc.TypeKeys "<MOD1 HOME>"
   EditPasteSpecialCalc
   sleep 5
   Kontext "InhalteEinfuegenCalc"
   if NOT Addieren.isChecked then Addieren.Check
   InhalteEinfuegenCalc.OK
   Kontext "Active"
   if Active.exists then Active.YES
   printlog "Check, if the cell values from range 'A1:C2' are correct"
   'checkCellValue("A1", "2")
   checkCellValue("A2", "4")
   checkCellValue("B1", "4")
   checkCellValue("B2", "6")
   checkCellValue("C1", "6")
   checkCellValue("C2", "8")
   sleep 15
   call hCloseDocument

endcase

testcase calculation_substract
'/// Do the same as in tescase 'calculation_none' described, but with the
'/// + operation option 'substract'
   call hDateiOeffnen File
   sleep 3
   call fCalcSelectSheet("PasteSpecial")
   call cBereichmarkieren("A11:C12")
   sleep 3
   EditCopy
   Kontext "DocumentCalc"
   DocumentCalc.TypeKeys "<MOD1 HOME>"
   EditPasteSpecialCalc
   sleep 5
   Kontext "InhalteEinfuegenCalc"
   if NOT Subtrahieren.isChecked then Subtrahieren.Check
   InhalteEinfuegenCalc.OK
   Kontext "Active"
   if Active.exists then Active.YES
   printlog "Check, if the cell values from range 'A1:C2' are correct"
   'checkCellValue("A1", "0")
   checkCellValue("A2", "0")
   checkCellValue("B1", "0")
   checkCellValue("B2", "0")
   checkCellValue("C1", "0")
   checkCellValue("C2", "0")
   sleep 15
   call hCloseDocument

endcase

testcase calculation_multiply
'/// Do the same as in tescase 'calculation_none' described, but with the
'/// + operation option 'multiply'
   call hDateiOeffnen File
   sleep 3
   call fCalcSelectSheet("PasteSpecial")
   call cBereichmarkieren("A11:C12")
   sleep 3
   EditCopy
   Kontext "DocumentCalc"
   DocumentCalc.TypeKeys "<MOD1 HOME>"
   EditPasteSpecialCalc
   sleep 5
   Kontext "InhalteEinfuegenCalc"
   if NOT Multiplizieren.isChecked then Multiplizieren.Check
   InhalteEinfuegenCalc.OK
   Kontext "Active"
   if Active.exists then Active.YES
   printlog "Check, if the cell values from range 'A1:C2' are correct"
   'checkCellValue("A1", "1")
   checkCellValue("A2", "4")
   checkCellValue("B1", "4")
   checkCellValue("B2", "9")
   checkCellValue("C1", "9")
   checkCellValue("C2", "16")
   sleep 15
   call hCloseDocument

endcase

testcase calculation_devide
'/// Do the same as in tescase 'calculation_none' described, but with the
'/// + operation option 'devide'
   call hDateiOeffnen File
   sleep 3
   call fCalcSelectSheet("PasteSpecial")
   call cBereichmarkieren("A11:C12")
   sleep 3
   EditCopy
   Kontext "DocumentCalc"
   DocumentCalc.TypeKeys "<MOD1 HOME>"
   EditPasteSpecialCalc
   sleep 5
   Kontext "InhalteEinfuegenCalc"
   if NOT Dividieren.isChecked then Dividieren.Check
   InhalteEinfuegenCalc.OK
   Kontext "Active"
   if Active.exists then Active.YES
   printlog "Check, if the cell values from range 'A1:C2' are correct"
   'checkCellValue("A1", "1")
   checkCellValue("A2", "1")
   checkCellValue("B1", "1")
   checkCellValue("B2", "1")
   checkCellValue("C1", "1")
   checkCellValue("C2", "1")
   sleep 15
   call hCloseDocument

endcase
