'encoding UTF-8  Do not remove or change this line!
'*******************************************************************************
'*
'*  $RCSfile: f_basic_modulehide.inc,v $
'*
'*  $Revision: 1.6 $
'*
'*  last change: $Author: jsk $ $Date: 2005/06/23 13:39:47 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/******************************************************************************
'*
'*  owner : joerg.skottke@sun.com
'*
'*  short description : Verify that hiding modules works
'*
'*******************************************************************************
'**
' #1 tBasicIdeModuleHide ' Verify that hiding modules works
'**
'\******************************************************************************

testcase tBasicIdeModuleHide

    '///<h1>Hiding modules (make them invisible)</h1>
    '///<ul>

    dim rc as integer
    dim cDefaultTabName as string
    dim brc as boolean 
    gApplication = "Writer"
    call hNewDocument()
    
    '///<li>Create a new BASIC module for the current (writer) document</li>
    brc = hOpenBasicOrganizerFromDoc()
    brc = hCreateModuleForDoc()
    
    '///<li>Write a macro (one that is unique to all modules)</li>
    rc = hInsertMacro( 1 )
    if ( rc = 0 ) then
       printlog( " * macro has been written successfully" )
    else
       warnlog( "Failed to insert macro" )
    endif

    '///<li>Hide the module using the Tab-Bar's context menu</li>
    rc = hHideModule()
    if ( rc > 0 ) then
        warnlog( "Some unexpected error occurred while trying to hide the module" )
    endif

    '///<li>Verify if the module is really hidden.</li>
    try
        ' hTestMacro is expected to fail, so we jump to the catch statement
        rc = hTestMacro( 1 )
        if ( rc = 0 ) then
            warnlog( "For some reason the original module is still visible" )
        else
            warnlog( "There should not be any editingwindow visible" )
        endif
    catch
        printlog( " * unable to locate editwindow -> no module visible." )
    endcatch
    
    '///<li>Open the BASIC organizer and select the hidden module</li> 
    if ( hOpenBasicOrganizer( 1 ) ) then
    
        modulliste.typekeys( "<END><RIGHT><DOWN><RIGHT><DOWN>" )
        sleep( 1 )
        '///<li>Click 'Edit' to open the module in the IDE</li>
        try
            bearbeiten.click()
        catch
            warnlog( "#i35097# Crash when editing last module" )
        endcatch
        
         
        '///<li>Verify that the correct module is visible</li>
        rc = hTestMacro( 1 )
        if ( rc = 0 ) then
            printlog( " * the correct macro-module is open. Good." )
        else
            warnlog( "The open macro-module is not the one that was expected" )
        endif
         
        '///<li>Close IDE and document</li>
        hCloseBasicIDE()
    
        call hCloseDocument()      
         
    else
    
        warnlog( "restarting the office to recover from errors" )
        call exitRestartTheOffice()
        
    endif
    
    '///</ul>
    
endcase
