'encoding UTF-8  Do not remove or change this line!
'*******************************************************************************
'*
'*  $RCSfile: f_scripting_addpkg.inc,v $
'*
'*  $Revision: 1.7 $
'*
'*  last change: $Author: jsk $ $Date: 2005/07/29 12:25:46 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/******************************************************************************
'*
'*  owner : joerg.skottke@sun.com
'*
'*  short description : Deploy, execute and delete uno-package
'*
'*******************************************************************************
'**
' #1 tDeployScript ' Deploy, execute and delete uno-package
'**
'\******************************************************************************

testcase tDeployScript

    '///<h1>Import a UNO package containing a script via Package-Manager UI</h1>
    
    ' Text to identify the document we work with. 
    ' NOTE: Capitalise.bsh changes the case of a string rather than capitalising 
    ' it.
    dim cText as string
        cText = "Testdoc for Capitalise.bsh"
        
    ' The path to the package that will be installed 
    dim cPackagePath as string
        cPackagePath = "framework\basic\input\pkgmgr\capitalise.uno.pkg"
        cPackagePath = convertpath( gTesttoolpath & cPackagePath )
        
    dim cPackageName as string
    dim bStatus as boolean
        
    '///<ul>
    
    gApplication = "WRITER"
    
    '///<li>Open a new document</li>
    printlog( "Open an new document" )
    call hNewDocument()
    
    '///<li>Write some text to the document</li>
    printlog( "Write a string to the document (mixed- or lowercase)" ) 
    kontext "DocumentWriter"
    DocumentWriter.TypeKeys( cText )    
    
    '///<li>Add the package and get the name of the first node below "My Macros"</li>
    cPackageName = hAddPackage( cPackagePath , true )
    
    '///<li>Verify that the package at the first node is the correct one</li>
    printlog( "Verify that the package is the correct one" )
    if ( cPackageName <> "capitalise.uno.pkg" ) then
        warnlog( "Since the package is not in place, the test ends here." )
        call hCloseDocument()
        goto endsub
    endif
    
    '///<li>Verify that we still have the focus on the correct document</li>
    ' NOTE: Autocorrection uppercases the first letter, so capitalise.bsh will
    '       actually LOWERCASE the string!!!!
    bStatus = hIdentifyDocument( cText , true )
    kontext "DocumentWriter"
    
    '///<li>Open the 'Run Macro' dialog</li>
    printlog( "Open the 'Run Macro' dialog" )
    ToolsMacrosRunMacro
    sleep( 3 )
    
    '///<li>Browse through 'My Macros' and find the Capitalise Macro</li> 
    kontext "ScriptSelector"
    hSelectTopNode( LibraryTreeList )
    hExpandNode( LibraryTreeList , 0 )
    hSelectNodeByName( LibraryTreeList , "capitalise.uno.pkg" )
    hExpandNode( LibraryTreeList , 0 )
    hSelectNodeByName( LibraryTreeList , "Capitalise" )
    
    printlog( "Found: " & hGetNodeName( ScriptList , 1 ) )
    
    '///<li>execute the macro</li>
    printlog( "Execute macro" )
    ScriptSelector.ok()
    sleep( 2 )
    
    '///<li>handle unexpected errormessage</li>
    kontext "active"
    if ( active.exists() ) then
        warnlog( "#i41066# Unexpected active: " & active.gettext() )
	active.ok()
    endif
    
    '///<li>Verify that the text has indeed been changed (lowercased)</li>
    bStatus = hIdentifyDocument( lcase( cText ) , false )
    
    ' errormessage in case the macro did not give the expected result 
    if ( not bStatus ) then
        warnlog( "The macro was not executed" )
    endif
    
    '///<li>remove the package</li>
    ' this is the generic (preferred) function. Does not work for PkgMgr,
    ' the pkgmgr uses multiselection by default.
    ' bStatus = hRemovePackageGeneric( "capitalise.uno.pkg" , true  )
    ' alternative method using arrowkeys to navigate
    ToolsPackageManager
    hRemovePackage( "capitalise.uno.pkg" )
    
    '///<li>Close the current document</li>
    printlog( "Close the document" )
    call hCloseDocument()

    '///</ul>
    
endcase
