'encoding UTF-8  Do not remove or change this line!
'*******************************************************************************
'*
'*  $RCSfile: f_scripting_organizers.inc,v $
'*
'*  $Revision: 1.2 $
'*
'*  last change: $Author: jsk $ $Date: 2005/06/23 13:42:37 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/******************************************************************************
'*
'*  owner : joerg.skottke@sun.com
'*
'*  short description : Test scripting-organizers / document-attached scripts
'*
'*******************************************************************************
'**
' #1 tScriptingOrganizers ' Test scripting-organizers / document-attached scripts
'**
'\******************************************************************************

testcase tScriptingOrganizers( iDialog as integer )

    ' make sure we have a valid parameter
    ' 1 = BeanShell (.bsh)
    ' 2 = JavaScript (.js)
    if ( ( iDialog < 1 ) or ( iDialog > 2 ) ) then
        warnlog( "Invalid parameter passed to function: " & iDialog )
        goto endsub
    endif

    '///<H1>Test scripting-organizers</H1>
    '///<ul>
    
    dim cFileName as string
        cFileName = "sftest" & hGetSuffix()
        
    dim cFilePath as string
        cFilePath= gOfficePath & "user\work\" & cFileName
        cFilePath= convertpath( cFilePath )
        
    dim iPos as integer  ' position of the workdocument in treelist
    dim brc as boolean   ' boolean return code used to determine the status
    
    dim cLibName as string
        cLibName = "TTLib"
    dim cModName as string
        cModName = "TTMod"
    dim cScriptName as string
    
    ' Define a name for the script depending on which dialog we want to test
    select case iDialog
    case 1 : cScriptName = cModName & ".bsh"
    case 2 : cScriptName = cModName & ".js"
    end select
      
    ' this is the position of the document in the scriptorganizer-treeleist
    ' it should always be the last in the list, it is expected at pos. 4
    ' 1. My Macros, 2. OpenOffice.org Macros, 3. Untitled1, 4. cFileName
    dim iDocumentPosition as integer
        iDocumentPosition = 4 
    
    '///<li>Delete the workfile in case it has been left over by prior run</li>
    brc = hDeleteFile( cFilePath)
    
    '///<li>Open a new document</li>
    printlog( "New document" )
    call hNewDocument()
    
    '///<li>Modify the document</li>
    printlog( "Modify the document" )
    call hChangeDoc()
    
    '///<li>Save the document (Save As)</li>
    printlog( "Save the document" )
    hSpeichernUnterKill( cFilePath )
    
    '///<li>Open the ScriptOrganizer</li>
    printlog( "Open the ScriptOrganizer, recover on failure" )
    brc = hOpenScriptOrganizer( iDialog )
    if ( not brc ) then
        warnlog( "Could not open the script Organizer, aborting" )
        call hCloseDocument()
        goto endsub
    endif
    
    '///<li>Find the current document in the treelist</li>
    brc = hLocateScriptingObject( iDocumentPosition , cFileName )
    if ( not brc ) then
        warnlog( "The document is not listed in the Treelist, aborting test" )
        kontext "ScriptOrganizer"
        ScriptOrganizer.cancel()
        call hCloseDocument()
        goto endsub
    endif
    
    '///<li>Create a new library and rename it afterwards</li>
    printlog( "Create a new library" )
    brc = hNewScriptingObject( "dummy" , 1 )
    printlog( "Rename it" )
    brc = hNewScriptingObject( cLibName , 2 )
    
    '///<li>Create a new script and rename it afterwards</li>
    printlog( "Create a new script" ) 
    brc = hNewScriptingObject( "dummy" , 1 )
    printlog( "Rename it" )
    brc = hNewScriptingObject( cModName , 2 )
    
    '///<li>Exit all dialogs</li>
    printlog( "Cancel the ScriptOrganizer" )
    kontext "ScriptOrganizer"
    ScriptOrganizer.cancel()
    
    '///<li>Save the file</li>
    printlog( "Save the file" )
    FileSave
    
    '///<li>Close the document</li>
    printlog( "Close the document" )
    call hCloseDocument()   
    
    '///<li>Reload the document. Special: Expect Macro-Warning</li>
    printlog( "Reload the document. Special: Expect Macro-Warning" )
    brc = hLoadFile( cFilePath, true , 1 )

    '///<li>Open the ScriptOrganizer, delete all scripts/libraries</li>
    printlog( "Open the ScriptOrganizer, delete all scripts/libraries" )
    brc = hOpenScriptOrganizer( iDialog )
    brc = hDeleteScript( cScriptName , true )
    brc = hDeleteScript( cLibName , true )
    brc = hDeleteScript( cFileName , false )
        
    '///<li>Exit all dialogs</li>
    printlog( "Cancel the ScriptOrganizer" )
    kontext "ScriptOrganizer"
    ScriptOrganizer.cancel()
    
    '///<li>Save the file</li>
    printlog( "Save the file" )
    FileSave
    
    '///<li>Close the document</li>
    printlog( "Close the document" )
    call hCloseDocument()   
    
    '///<li>Reload the document. Special: No Macro-Warning expected</li>
    printlog( "Reload the document. Special: No Macro-Warning expected" )
    qaerrorlog( "#i50530# Macros not completely removed from doc when deleted" )
    brc = hLoadFile( cFilePath, true , 0 )
    
    '///<li>Open the ScriptOrganizer, look for the library</li>
    printlog( "Open the ScriptOrganizer, look for the library" )
    brc = hOpenScriptOrganizer( iDialog )
    
    '///<li>Verify that all libraries/scripts have been removed</li>
    printlog( "Verify that all libraries/scripts have been removed" )
    iPos = hSelectNodeByName( ScriptTreeList , cName , true )
    if ( iPos <> -1 ) then
        warnlog( "The Library was not removed from the file" )
    endif
            
    '///<li>Test Exit: Cleanup - close all dialogs</li>
    kontext "ScriptOrganizer"
    ScriptOrganizer.cancel()
    
    '///<li>Close the document</li>
    call hCloseDocument()
    
    '///<li>Delete the workfile</li>
    brc = hDeleteFile( cFilePath)
    if ( not brc ) then
        warnlog( "Could not delete: " & cFilePath & " - do so manually!" )
    endif
    
    '///</ul>

endcase

