'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  $RCSfile: extras.inc,v $
'*
'*  $Revision: 1.15 $
'*
'*  last change: $Author: jsk $ $Date: 2005/07/29 10:36:13 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/***********************************************************************
'*
'* owner : joerg.skottke@sun.com
'*
'* short description : Perform standard operations on all samples/templates etc.
'*
'************************************************************************
'*
' #1 tShowAllObjectsAsPreview    ' show all templates/samples in preview window in the dialog
' #1 tModifyObjects              ' Work with samples and templates
' #1 tOpenObjectsWithFileDialog  ' open templates/samples via file open dialog
' #1 hApplyBlackList             ' Identify files not to be loaded
'*
'\***********************************************************************

testcase tShowAllObjectsAsPreview( cCategory )

   dim iObjectFolder as Integer   ' the current folder in loops
   dim iObjectFolders as integer  ' the number of template/sample-folders
   
   dim iObject as Integer         ' the current template/sample within loops
   dim iObjectCount( 20 ) as integer  ' number of templates/samples in the folders
   
  
   printlog( "" )
   
   '///<h3>Show documents in the preview pane of the teplates-dialog</h3>
   '///<ul>
   '///<li>Open File->New->Templates and documents</li>
   FileNewFromTemplate
   
   ' find the category we want to work with (TEMPLATES/SAMPLES...)
   hSelectCategory( cCategory )
   
   ' Count the folders in the root of cCategory
   iObjectFolders = FileList.getItemCount()
   
   ' Now go through every folder and count the number of objects
   for iObject = 1 to iObjectFolders
   
      ' grab a folder below cCategory and open it
      hSelectFileFolder( iObject , true )
      
      ' get the number of items
      iObjectCount( iObject ) = FileList.getItemCount()
      
      ' step up one level to the root of cCategory
      UpOneLevel.click()
      
   next iObject
   
   Kontext "TemplateAndDocuments"
   '///<li>Click the preview button</li>
   preview.click()

   printlog( "" )
   printlog( "Displaying documents in preview pane" )
   printlog( "" )


   
   '///<li>Step through all folders and templates/samples</li>
   for iObjectFolder = 1 to iObjectFolders

        printlog( "Restart The application" )
        Kontext "TemplateAndDocuments"
        TemplateAndDocuments.cancel()
        call exitRestartTheOffice()
        FileNewFromTemplate
        kontext "TemplateAndDocuments"
      
    
      '///<ol>
      '///<li>Select the category (samples, templates ...)</li>
      hSelectCategory( cCategory )
   
      '///<li>Select the current folder</li>
      hSelectFileFolder( iObjectFolder , false )

      for iObject = 1 to iObjectCount( iObjectFolder ) 
      
          printlog( "Object-Folder: " & iObjectFolder & " Entry: " & iObject )
      
          ' To skip a specified document add it to extras_tools.inc
          if ( skiplist( iObjectFolder, iObject , cCategory ) ) then 
             goto skiptest
          endif 
   
          '///<li>Select the desired template</li>
          hSelectDocumentObject( iObject , 0 )
          
          '///<li>Wait for the preview to be loaded and displayed</li>
          'Problem: Cannot verify the content of preview window.
          sleep( 5 )
          
          skiptest: 
          
          '///<li>Next document</li>

      next iObject
          
      '///</ol>
      
   next iObjectFolder
   
   '///</ul>
   Kontext "TemplateAndDocuments"
   TemplateAndDocuments.cancel()
   
   
endcase   

'*******************************************************************************

testcase tModifyObjects( iMode as integer , cCategory as string )

   dim iObjectFolder as Integer
   dim iObjectFolders as integer
   
   dim iObject as Integer
   
   dim iObjectCount( 20 ) as integer
   
   dim iResetOffice as integer 
       iResetOffice = 1
       
   dim sFile as string   
   
  
   printlog( "" )
   
   '///<h1>Open all Objects, save, close, reload, save and close them</h1>
   '///<ul>
   '///<li>Open File->New->Templates and documents</li>
   FileNewFromTemplate
   
   ' select the category in the template dialog (left pane)
   hSelectCategory( cCategory )
   
   ' Get the number of folders in the root of cCategory
   iObjectFolders = FileList.getItemCount()
   
   ' get the number of all objects below cCategory and its subfolders
   for iObject = 1 to iObjectFolders
   
      ' select and open a folder
      hSelectFileFolder( iObject , true )
      
      ' count the items in the list
      iObjectCount( iObject ) = FileList.getItemCount()
      
      ' move back up to the root of cCategory
      UpOneLevel.click()
      
   next iObject
   
   Kontext "TemplateAndDocuments"
   '///<li>Click the document-info button, do not load the preview</li>
   docinfo.click()

   ' close the templates and samples dialog
   TemplateAndDocuments.cancel()
   
   call exitRestartTheOffice
   
   printlog( "" )
   printlog( "Starting to load/save/close/reload/close all Objects" )
   printlog( "" )
   
   
   
   '///<li>Step through all folders and Objects</li>
   for iObjectFolder = 1 to iObjectFolders
   
      for iObject = 1 to iObjectCount( iObjectFolder ) 
      
          ' To skip a specified document add it to extras_tools.inc
          if ( skiplist( iObjectFolder, iObject , cCategory ) ) then 
             exit for
          endif
          
          gApplication = "WRITER"         
          
          ' we need a mechanism to restart the office after about every 15 
          ' documents because the application becomes unstable after loading
          ' too many templates in a row. However, this is a bug that
          ' should be addressed sometime, this will not appear under normal
          ' circumstances.
          if ( iResetOffice = 15 ) then
              printlog( "Restarting the office" )
              call exitRestartTheOffice()
              iResetOffice = 1
          endif
   
          '///<ol>
          FileNewFromTemplate
      
          '///<li>Select the desired-category: Templates/Samples ...</li>
          hSelectCategory( cCategory )
      
          '///<li>Select the current folder</li>
          hSelectFileFolder( iObjectFolder , false )
          
          '///<li>Select the desired Object</li>
          hSelectDocumentObject( iObject , iMode )
          hGetApplicationFromDoc()
          hCloseNavigator()
          
          '///<li>Save the file, close it and verify that it is closed</li>
          ' Build the filename
          sFile = gOfficePath & "user/work/" & cCategory 
          sFile = sFile & iObjectFolder & "_" & iObject & hGetSuffix()
          sFile = convertpath( sFile )

          hSaveFile( sFile, true, false )
          call hCloseDocument()
          hCheckDocCount( 1 , true )
          
          '///<li>Load the file, close it again an verify that it is closed</li>
          hLoadFile( sFile, false, 1 )
          hCloseNavigator()
          call hCloseDocument()
          hCheckDocCount( 1 , true )
          
          '///<li>Next document</li>
          '///</ol>
          
          iResetOffice = iResetOffice + 1
          
          hDeleteFile( sFile )
      
      next iObject
      
   next iObjectFolder
   
   '///</ul>
   
endcase   
   
'-------------------------------------------------------------------------

testcase tOpenObjectsWithFileDialog( cCategory as string )

    '///<h1>open all templates with file-open-dialog</h1>
    '///<b>get all templates out of ..\share\template\-directory</b>
    '///<ul>
    '///<li>open all files with file-open-dialog</li>
    '///<li>save, close, reopen it, close it again</li>
    '///</ul>

    dim lsFile ( 1000 ) as String ' list of all files below samples or templates
    dim sRootPath as String       ' rootpath, depends on cCategory
    dim sFileIn as String         ' file to open
    dim sFileOut as string        ' file to save, reload, delete
    dim sExtension as String      ' filter: determines whether to test the file
    
    dim iCurrentTemplate as Integer ' increment: current template from lsFile()
    dim iCounterToBreak as Integer  ' increment: after 10 files: restart
    
    dim bSkipFile as boolean      ' turns true if file is to be skipped
    
    const CFN = "tOpenObjectsWithFileDialog::"


    ' the path where the samples/templates are located, verify function params
    select case cCategory
    case "SAMPLES"    : sRootPath = gNetzOfficePath & "share\samples"
    case "TEMPLATES"  : sRootPath = gNetzOfficePath & "share\template"
    case default
        warnlog( CFN & "Invalid category passed to function" )
        goto endsub
    end select
   
    sRootPath = convertpath( sRootPath )
   
    ' get the complete list of all files below templates/samples
    GetAllFileList ( sRootPath, "*.*", lsFile() )
   
    ' unfortunately we coannot load all samples/templates in a row, the office
    ' freeezes at some point. So we do a restart every ten files.
    iCounterToBreak = 0
   
    ' go through the list of samples/templates and do things
    for iCurrentTemplate = 2 to ListCount ( lsFile() )
   
        iCounterToBreak = iCounterToBreak + 1
      
        if ( iCounterToBreak = 10 ) then
            printlog "exit and restart StarOffice"
            iCounterToBreak = 0
            call ExitRestartTheOffice
        end if
      
        ' sFileIn holds the file we currently work with
        sFileIn = lsFile( iCurrentTemplate )
        
        ' compare the filename against the blacklist. TRUE on match
        bSkipFile = hApplyBlackList( sFileIn )
        
        ' if the file does not belong to the blacklist, we do the test on it
        if ( not bSkipFile ) then

            ' some output to the log an load the object, close navigator 
            printlog( "" )
            hLoadFile( sFileIn , false , 0 ) 
            hHandleInitialDialogs()
            hCloseNavigator()

            ' set gApplication for the current document 
            hGetApplicationFromDoc()
        
            ' Build the filename
            sFileOut = gOfficePath & "user/work/" & cCategory & "_"  
            sFileOut = sFileOut & iCurrentTemplate & hGetSuffix()
            sFileOut = convertpath( sFileOut ) 
          
            ' Save the file, close it and verify that it is closed 
            ' Do not use autoextension
            hSaveFile( sFileOut, true, false )
            call hCloseDocument()
            hCheckDocCount( 1 , true )
          
            ' Load the file, close the navigator if present
            hLoadFile( sFileOut, false, 1 )
            hCloseNavigator()

            ' Close the file, verify that only one document remains open
            call hCloseDocument()
            hCheckDocCount( 1 , true )     
      
            ' Delete the file
            hDeleteFile( sFileOut )
        
        endif         
      
    next iCurrentTemplate
   
endcase

'*******************************************************************************

function hApplyBlackList( sFileName as string ) as boolean

    '///<h1>Function to identify blacklisted files that will not be tested</h1>

    dim sExtension as string
    const CFN = "hApplyBlackList::"
    
    hApplyBlackList() = false
    
    ' There is another file called idxexample.sxw which we do not want to 
    ' load either
    if ( instr( sFileName , "idxexample.sxw" ) > 0 ) then
        printlog( CFN & "Skipping idxexample.sxw" )
        hApplyBlackList() = true
        exit function
    endif

    if ( instr( sFileName , ".table" ) ) then
        printlog( "" )
        printlog( CFN & "Skipping .table" )
        hApplyBlackList() = true
        exit function
    endif
    
    sExtension = right ( sFileName, 3 )        

    ' Test the filename to find out whether we have a graphics file (bmp,
    ' gif or jpg) or the translation table (suffix: .table). If this is
    ' the case, we don't perform the test
    if ( sExtension = "bmp" OR _
        sExtension = "gif" OR _
        sExtension = "jpg" ) then
        printlog( CFN & "Skipping bmp, gif or jpg graphic" )
        hApplyBlackList() = true
        exit function
    endif
    
end function
        



