'encoding UTF-8  Do not remove or change this line!
'*******************************************************************************
'*
'*  $RCSfile: extras_autotext.inc,v $
'*
'*  $Revision: 1.1 $
'*
'*  last change: $Author: jsk $ $Date: 2005/05/17 12:19:36 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/******************************************************************************
'*
'*  owner : joerg.skottke@sun.co
'*
'*  short description : Test the autotext feature
'*
'*******************************************************************************
'**
' #1 tCheck_Autotexts ' Test the autotext feature
'**
'\******************************************************************************

testcase tCheck_Autotexts

    Dim i, j, Zaehler, iMax as Integer
    Dim lsListe  (1000) as String
    Dim sListenDatei, sListenEintrag as String
    Dim Bereiche(15) as String
    
    '///<h1>This test checks all names of autotext-dialog ( edit / autotext )</h1>
    '///<i>edit / autotext</i>
    '///<i>check for each group the entries</i>
    '///<ul>
    '///<li>- the lists for comparison are : [TesttoolPath]\setup\allinst\input\formats\autotext\atext_[languageID].txt</li>
    '///<li>- if the comparison-file does not exists, it will be created automatically</li>
    ListAllDelete ( lsListe () )
    Zaehler = 0
    sListenDatei = ConvertPath ( gTesttoolPath + "setup\allinst\input\formats\autotext\atext_" + siSprache +".txt"
    printlog "check all autotext-entries"
    Call  hNewDocument
    printlog "- open a new writer-document"
    printlog "- edit / autotext"
    printlog "  check each entry with a comparison-list"
    EditAutotext

    kontext "autotext"
    Vorschau_anzeigen.Uncheck
    Liste.Select 1

    for j=1 to 15
        sleep( 1 )
        Liste.TypeKeys "-"
        Liste.TypeKeys "<Down>"
    next j

    iMax = Liste.GetItemCount

    for i = 1 to iMax
        Liste.Select 1

        for j=1 to iMax
            sleep( 1 )
            Bereiche(j) = Liste.GetSelText
            Liste.TypeKeys "-"
            Liste.TypeKeys "<Down>"
        next j

        Liste.Select i
        Liste.TypeKeys "+"

        for j = 1 to ( Liste.GetItemCount - iMax )
            Liste.Select j+i
            sListenEintrag = Bereiche(i) + ":" + NameText.GetText + ":" + Kuerzel.GetText
            ListAppend ( lsListe(), sListenEintrag )
        next j

    next i
    '///</ul>

    CompareAutoText ( lsListe() )
    '///<h3>all autotexts are inserted</h3>
    '///<ul>
    '///<li>- edit / autotext</li>
    '///<li>- select one autotext after the other and press for each insert</li>
    '///<li>- check if the autotext in correct inserted</li>
    printlog "  - insert all entries and check if something is inserted"

    for i = 1 to iMax
        Liste.Select 1

        for j=1 to iMax
            Liste.TypeKeys "-"
            Liste.TypeKeys "<Down>"
            wait 500
        next j

        Liste.Select i
        Liste.TypeKeys "+"

        for j = 1 to ( Liste.GetItemCount-iMax )
            Liste.Select j+i

            try
                AutoText.OK
                Sleep (5)

                kontext "active"

                If Active.Exists then
                    printlog Active.GetText
                    Active.OK

                    kontext "macrobar"

                    if MacroBar.Exists then
                        Warnlog "Macro-error at autotext " + i + " " + j + "!"
                        FileClose
                    endif

                endif


                kontext "documentwriter"
                documentWriter.TypeKeys( "<MOD1 HOME>" )
                documentWriter.TypeKeys( "<MOD1 SHIFT END>" )
                EditCopy
                if GetClipboard = "" then
                    Warnlog "Perhaps no text is inserted. Variant: "+ i + "  " + j
                endif
            catch

                if ( (iSprache = 82) AND (i = 1) AND (j = 4) ) then
                    qaerrorlog "At "+ i + " " + j +" it gives a problem."
                    printlog ("Probably Bugid: #110949" )
                else
                    Warnlog "Autotext "+ i + " " + j +" failed."
                endif

            endcatch


            kontext "documentwriter"
            DocumentWriter.TypeKeys "<Delete>"
            EditAutotext

            kontext "autotext"
        next j

    next i

    AutoText.Close
    
    '///</ul>
    Call hCloseDocument()
    
endcase
