'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  $RCSfile: extras_tools.inc,v $
'*
'*  $Revision: 1.10 $
'*
'*  last change: $Author: jsk $ $Date: 2005/06/23 13:47:15 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/***********************************************************************
'*
'* owner : joerg.skottke@sun.com
'*
'* short description : Tools to handle templates and samples
'*
'************************************************************************
'*
' #0 hSelectCategory          ' selects a category on template dialog
' #0 hSelectFileFolder        ' selects and opens a specified folder
' #0 hSelectDocumentObject    ' opens/edits a sample or template
' #0 skiplist                 ' a convenient way to skip non-working documents
'*
'\***********************************************************************

function hSelectCategory( cCategory as string ) as boolean

   ' selects a category in the templates dialog. Keystrokes are
   ' used for navigation (browsebox is kinda tricky)

   Kontext "TemplateAndDocuments"
   
   Category.typeKeys( "<HOME>" )
   wait( 500 )
   
   if ( UCASE( cCategory ) = "NEWDOCUMENTS" ) then
    
      ' do nothing, the selection should be on this item
   
   elseif ( UCASE( cCategory ) = "TEMPLATES" ) then
   
      Category.typeKeys( "<DOWN>" )
      
   elseif ( UCASE( cCategory ) = "MYDOCUMENTS" ) then
   
      Category.typeKeys( "<DOWN>" )
      Category.typeKeys( "<DOWN>" )
      
   elseif ( UCASE( cCategory ) = "SAMPLES" ) then
   
      Category.typeKeys( "<DOWN>" )
      Category.typeKeys( "<DOWN>" )
      Category.typeKeys( "<DOWN>" )
      
   endif
   
   hSelectCategory() = true
   
end function
   
'***************************************************************************

function hSelectFileFolder( iFolder as integer , _
                  optional bVerbose as boolean  ) as integer

   ' selects a filefolder by name and prints/returns its name or
   ' an empty string in case of an error
   
   dim iItems as integer
   dim cFolder as string
   
   Kontext "TemplateAndDocuments"
   
   FileList.select( iFolder )
   cFolder = FileList.getText()
   
   FileList.typeKeys( "<return>" )
   wait( 500 )
   
   iItems = FileList.getItemCount()
   
   if ( bVerbose ) then 
      printlog( " * " & cFolder & " contains " & iItems & " items." )
   endif
   
   hSelectFileFolder() = iItems

end function
   
'*******************************************************************************

function hGetFileFolderName( iFolder as integer ) as string

    Kontext "TemplateAndDocuments"

    FileList.select( iFolder )
    wait( 100 )
    
    hGetFileFolderName() = FileList.getText()
    wait( 100 )
    
end function

'*******************************************************************************

function hSelectDocumentObject( iTitle as integer , _
                                 iMode as integer ) as string

   ' selects a template, opens it and returns the name

   dim cTitle as string
   dim brc as boolean

   Kontext "TemplateAndDocuments"

   wait( 100 ) 
   FileList.Select( iTitle )
   cTitle = FileList.getText()

   printlog( " * current title: " & cTitle )

   select case iMode
   
      case 0 ' do not load the document
      
      case 1 ' open new document based on the template
         
         FileList.typeKeys( "<return>" )
         brc = IsItLoaded()   
         
         if ( brc ) then
             hHandleActivesOnLoad( 2, false )
             hHandleInitialDialogs()
         else
             warnlog( "<IsItLoaded> returned <false>" )
         endif    
         
      case 2 ' edit the template

         edit.click()
         brc = IsItLoaded()   
         
         if ( brc ) then
             hHandleInitialDialogs()
         else
             warnlog( "<IsItLoaded> returned <false>" )
         endif    

         
   end select

   if ( brc ) then
       hSelectDocumentObject() = cTitle
   else 
       hSelectDocumentObject() = ""
   endif
   
end function   
   
'*******************************************************************************

function skiplist( iFolder as integer, _
                   iObject as integer, _
                   cCategory as string ) as boolean
                   
   ' add all templates/samples known to fail here. Only works for english
   ' office-versions.
           
   skiplist() = false
  
   '<INSERT CONDITIONS HERE>
   
end function   
