'*************************************************************************
'*
'*  $RCSfile: filedlg_attributes.bas,v $
'*
'*  $Revision: 1.2 $
'*
'*  last change: $Author: jsk $ $Date: 2004/03/22 09:52:59 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/******************************************************************************
' **
' ** owner : joerg.skottke@sun.com
' **
' ** short description : check the internal file dialog (Load/Save files w. special attributes)
' **
'\******************************************************************************

sub main

   ' NOTE: The test can only complete correctly if some of the working
   '       directories have special attributes/accessrights
   ' chmod -R 000 /.../framework/filedlg/input/noentry
   ' chmod -R 555 /.../framework/filedlg/input/readentry
   ' chmod 444 /.../framework/filedlg/input/readonly/*.*

   use "framework\filedlg\inc\filedlg_tools.inc"
   use "framework\filedlg\inc\filedlg2.inc"
   use "framework\filedlg\inc\filedlg3.inc"
   use "framework\filedlg\inc\filedlg8.inc"

   PrintLog Chr(13) + "Test of the FileOpen-Dialog (Load/Save files w. special attributes)"
   Call hStatusIn ( "framework", "filedlg_attributes.bas", "Test the StarOffice/Suite own filedialog (fileattributes)" )

    call hSetUNIXAttributes ' tries to set the attributes for the directories/files
                            ' used in tFileSpecialLoad and tFileSpecialSave
                            ' This works on Sol/Lin only (permissions required)

    tOnlyRead             ' load files with the 'only read'-flag in our file-open-dialog
                          '  (all documenttypes of StarOffice)
    tReadOnly             ' load read-only files (all documenttypes of StarOffice)
    tOnlyReadReadOnly     ' load read-only files with 'only read'-flag in the file-open-dialog

    tFileSpecialLoad      ' load non existed files, load file from readonly directory
                          '  and file out of no entry directory
    tFileSpecialSave      ' save a file in a non-existed dir, save a file in a dir
                          '  without any rights for the user

   Call hStatusOut

end sub

' ****************************************

sub LoadIncludeFiles

   use "global\system\inc\master.inc"
   use "global\system\inc\gvariabl.inc"
   gApplication = "WRITER"
   Call GetUseFiles

end sub
