'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  $RCSfile: filedlg_filenames2.bas,v $
'*
'*  $Revision: 1.3 $
'*
'*  last change: $Author: jsk $ $Date: 2004/09/10 09:44:48 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/******************************************************************************
' **
' ** owner : joerg.skottke@sun.com
' **
' ** short description : check special filenames and destinations
' **
'\******************************************************************************

sub main

   use "framework\filedlg\inc\filename_tools.inc"
   use "framework\filedlg\inc\filename1.inc"
   use "framework\tools\inc\docfuncs.inc"
   
   dim iCounter    as integer ' increment
   dim iFileCount  as integer ' Number of files in the current workdirectory
   dim cCurrentApp as string  ' the active application before start of this test

   call hStatusIn ( "framework", "filedlg_filenames2.bas", "check exotic filenames" )

   dim starttime
       starttime = now()

   cCurrentApp = gApplication()

   iFileCount = hgetFileCount() ' get the number of files in the current workdir

   ' check saving files to reserved names on Windows in the main
   ' applications. All operations here are expected to fail for Windows
   ' On UNIX those limitations don't exist, so these files are expected
   ' to be saved/loaded and deleted correctly.

   for iCounter = 2 to 2
      if ( gPlatGroup = "w95" ) then
         printlog( " " + CHR$(13) + hNumericDoctype( iCounter ) )
         call tSaveReservedNamesWin()  ' reserved names like printerports etc.
      else
         printlog( " " + CHR$(13) + hNumericDoctype( iCounter ) )
         call tSaveReservedNamesUNIX() ' should not be identified as such
      end if
   next iCounter

   ' restore old settings
   gApplication = cCurrentApp
   call ExitRestartTheOffice()

   ' Check if all workfiles have been deleted (if not this might be a bug!)
   if ( hGetFileCount() > iFileCount ) then
      qaerrorlog( "Not all workfiles have been deleted. Please check manually." )
      endif

   ' time it took the test to complete / database
   printlog Chr(13) + "End : " + WieLange ( starttime )
   call hStatusOut()

end sub

' ****************************************

sub LoadIncludeFiles

   use "global\system\inc\master.inc"
   use "global\system\inc\gvariabl.inc"
   gApplication = "WRITER"
   Call GetUseFiles

end sub
