'encoding UTF-8  Do not remove or change this line!
'*******************************************************************************
'*
'*  $RCSfile: ftpserver2.inc,v $
'*
'*  $Revision: 1.1 $
'*
'*  last change: $Author: jsk $ $Date: 2003/09/29 11:25:45 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/******************************************************************************
'*
'* owner : joerg.skottke@sun.com
'*
'* short description : check the internal file dialog ( extended tests )
'*
'*******************************************************************************
'**
' #1 tFTPServerDirectories1   ' Create/delete a directory via FTP (case 1)
' #1 tFTPServerDirectories2   ' Create/delete a directory via FTP (case 2)
'**
'\******************************************************************************

testcase tFTPServerDirectories1( cFTPServer as string )

   ' The application can create/delete files and folders via FTP.

   'This test checks if
   '- a directory can be created via FTP
   '- a file can be written to a directory via FTP
   '- a file can be deleted from within a directory via FTP
   '- a directory can be deleted via FTP

   'This test should work on any ftp-server
   
   '///Test creating directories via FTP 
   printlog( CHR$(13) + "Testing FTP-Server: " + cFTPServer )

   const WORKDIR = "ftpdlg1"
   dim workfile as string
      
   dim cNewDir as string
       cNewDir = cFTPServer + WORKDIR + "/"
   dim cFullPath as string

   '///+Open a new document
   printlog( CHR$(13) + " - Open a new document" )
   call hNewDocument
   
   ' Append a suffix depending on gApplication
   workfile = hAppendSuffix( "ftpdlg1" )
   
   '///+Disable the proxies in Tools->Options
   call DisableProxies()

   '///+Create a directory
   call FTPCreateDirectoryExpectSuccess( cFTPServer , WORKDIR )
   
   '///+Try to save a file to the new directory
   cFullPath =  cNewDir + workfile 
   call FTPSaveFileExpectSuccess( cFullPath )
   
   '///+Try to delete the file again ( the clean way )
   call FTPDeleteFileExpectSuccess( cNewDir , workfile )
   
   '///+Delete the directory
   call FTPDeleteFileExpectSuccess( cFTPServer , WORKDIR )

   '///+Enable the proxies in Tools->Options
   call EnableProxies()

   '///+Close the document
   printlog( " - Close the document" )
   call hCloseDocument
   
   printlog( "" )
   
endcase

'*******************************************************************************

testcase tFTPServerDirectories2( cFTPServer as string )

   'The application cannot delete directories on FTP-Servers that contain files.

   'This test checks if
   '- a directory can be created via FTP
   '- a file can be written to a directory via FTP
   '- a non-empty directory can be deleted via FTP
   '- a file can be deleted from within a directory via FTP
   '- a directory can be deleted via FTP
   
   'This test should work on any ftp-server

   '///Test FTP Server.
   printlog( CHR$(13) + "Testing FTP-Server: " + cFTPServer )

   const WORKDIR  = "ftpdlg2"
   dim workfile as string
       workfile = "ftpdlg2"
   dim cNewDir as string
       cNewDir = cFTPServer + WORKDIR + "/"
   dim cFullPath as string
   
   '///+Open a new document
   printlog( CHR$(13) + " - Open a new document" )
   call hNewDocument
   
   ' Append a suffix depending on gApplication
   workfile = hAppendSuffix( "ftpdlg2" )
   
   '///+Disable the proxies in Tools->Options
   call DisableProxies()

   '///+Create a directory
   call FTPCreateDirectoryExpectSuccess( cFTPServer , WORKDIR )
   
   '///+Try to save a file to the new directory
   cFullPath = cNewDir + workfile 
   call FTPSaveFileExpectSuccess( cFullPath )
   
   '///+Delete the directory without removing the containing file
   call FTPDeleteFileExpectFailure( cFTPServer , WORKDIR )

   '///+Try to delete the file (this should work)
   call FTPDeleteFileExpectSuccess( cNewDir , workfile )

   '///+Delete the directory 
   call FTPDeleteFileExpectSuccess( cFTPServer , WORKDIR )
   
   '///+Enable the proxies in Tools->Options
   call EnableProxies()

   '///+Close the document
   printlog( " - Close the document" )
   call hCloseDocument
   
   printlog( "" )
   
endcase

'*******************************************************************************

testcase tFTPServerDirectories3( cFTPServer as string )

   'This test checks if
   '- a weird-named directory can be created via FTP
   '- a file can be written to a directory via FTP
   '- a file can be deleted from within a directory via FTP
   '- a directory can be deleted via FTP
   
   'This test should work on any ftp-server

   '///Test FTP Server.
   printlog( CHR$(13) + "Testing FTP-Server: " + cFTPServer )

   const WORKDIR  = "diröäüß test%20A"
   const WORKFILE = "workfile"
   
   dim cNewDir as string
       cNewDir = cFTPServer + WORKDIR + "/"
   dim cFullPath as string

   '///+Disable the proxies in Tools->Options
   call DisableProxies()

   '///+Create a directory
   call FTPCreateDirectoryExpectSuccess( cFTPServer , WORKDIR )
   
   '///+Try to save a file to the new directory
   cFullPath = cNewDir + WORKFILE 
   call FTPSaveFileExpectSuccess( cFullPath )
   
   '///+Try to delete the file again
   call FTPDeleteFileExpectSuccess( cNewDir , WORKFILE )
   
   '///+Delete the directory
   call FTPDeleteFileExpectSuccess( cFTPServer , WORKDIR )

   '///+Enable the proxies in Tools->Options
   call EnableProxies()   
   
endcase

'*******************************************************************************

