'encoding UTF-8  Do not remove or change this line!
'*******************************************************************************
'*
'*  $RCSfile: install_sysintgr.inc,v $
'*
'*  $Revision: 1.2 $
'*
'*  last change: $Author: jsk $ $Date: 2004/03/09 14:46:15 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/******************************************************************************
'*
'* owner : joerg.skottke@sun.com
'*
'* short description :
'*
'*******************************************************************************
' **
' #1 tCheckSystemIntegration ' checks if the startmenu-entries have been written
' **
'\******************************************************************************

testcase tCheckSystemIntegration

   dim sSysintOS as string
   dim sProductName as string
   dim sProductVersion as string
   dim sStartMenuDir as string
   dim sIntegrationPath as string
   dim sInstallationType as string
   dim slCurFiles( 10 ) as string
   dim slRefFiles( 10 ) as string

   sProductName      = hQueryInstallParams( "ProductKey" )
   sInstallationType = hQueryInstallParams( "InstallMode" )

   printlog( " " )
   printlog( " * Productname .....: " & sProductName )
   printlog( " * Installation Type: " & sInstallationType )


   if ( gPlatGroup = "w95" ) then

      sSysintOS         = "windows"
      sStartMenuDir     = sProductName

      ' get the path to the links in the startmenu
      sIntegrationPath = hGetIntegrationPath( sInstallationType, sStartMenuDir )

      ' get the files list from the startmenu
      hGetCurFileList( sIntegrationPath , slCurFiles() )

      ' get the refernce file containing the files-list
      if( hGetRefFileList( slRefFiles() ) = true ) then
         printlog( " * Checking links..." )
         gCompare2Lists( slRefFiles() , slCurFiles() )  ' compare
      else
         printlog( " * Creating the reference-file." )
         hPutRefFileList( slCurFiles() )                ' create
      endif

   else

      ' no integration for unixes yet -
      printlog( " * Systemintegration currently not supported on this platform")
      printlog( "   Note that the icons for the systemintegration are tested" )
      printlog( "   by the installation test." )

   endif

endcase

'*******************************************************************************

function hGetCurFileList( sPath as string,  lsList() as string ) as integer

   dim iEntries as integer
   dim i as integer

   fileopen

   Kontext "OeffnenDLG"

   dateiname.settext( sPath )

   oeffnen.click()

   iEntries = dateiauswahl.getitemcount()

   dateiauswahl.typekeys( "<DOWN><UP>" )

   listappend( lsList() , dateiauswahl.getseltext() )

   for i = 1 to ( iEntries - 1 )

      dateiauswahl.typekeys( "<DOWN>" )
      listappend( lsList() , dateiauswahl.getseltext() )

   next i

   oeffnendlg.cancel()

   hGetCurFileList() = listcount( lsList() )

end function

'*******************************************************************************

function hGetRefFileList( lsList() as string ) as boolean

   dim sPath as string

   sPath = TESTHOME & "\sysintgr\" & hGetOSString() & "\"
   sPath = sPath & hGetLangAsString( iSprache ) & ".ref"
   sPath = convertpath( sPath )

   if ( app.dir( sPath ) <> "" ) then
      listread( lsList() , sPath , "utf8" )
      hGetRefFileList() = true
   else
      warnlog( "The reference-file does not exist." )
      hGetRefFileList() = false
   endif

end function

'*******************************************************************************

function hPutRefFileList( lsList() as string ) as boolean

   dim sPath as string

   sPath = TESTHOME & "\sysintgr\" & hGetOSString() & "\"
   sPath = sPath & hGetLangAsString( iSprache ) & ".ref"
   sPath = convertpath( sPath )

   if ( app.dir( sPath ) = "" ) then
      listwrite( lsList() , sPath , "utf8" )
      hPutRefFileList() = true
   else
      warnlog( "For some reason the file could not be created." )
      hPutRefFileList() = false
   endif

end function

'*******************************************************************************

function hGetLangAsString( iLang as integer ) as string

   select case iLang

      case 1,2,3,4,5,6,7,8,9 : hGetLangAsString() = "0" & iLang
      case else              : hGetLangAsString() = iLang

   end select

end function

'*******************************************************************************

function hGetIntegrationPath( sInstallationType as string, _
                              sStartMenuDir as string ) as string

   ' this function creates the path to the startmenu/programs folder.
   ' currently only two installation-types (network, standalone) are supported.
   ' TODO: Find a new location from where to retrieve the integration type,
   ' bootstrap.ini does not hold this information anymore.

   dim sIntegrationPath as string

   select case sInstallationType

      case "STANDALONE"

         warnlog( "The installation type 'STANDALONE' is no longer supported" )

      case "NETWORK"

         sIntegrationPath = hGetSysIntegrationPath( "ALL_USERS" )
         sIntegrationPath = sIntegrationPath & "\" & sStartMenuDir
         printlog( " * Startmenu at....: " & sIntegrationPath )

      case "STANDALONE"

         sIntegrationPath = hGetSysIntegrationPath( "USER" )
         sIntegrationPath = sIntegrationPath & "\" & sStartMenuDir
         printlog( "* Startmenu at.....: " & sIntegrationPath )

      case "NO_INTEGR"

         printlog( "No system Integration specified." )

      case else

         sIntegrationPath = hGetSysIntegrationPath( "USER" )
         sIntegrationPath = sIntegrationPath & "\" & sStartMenuDir
         qaerrorlog( "Startmenu at.....: " & sIntegrationPath )

   end select

   hGetIntegrationPath() = sIntegrationPath

end function
