'encoding UTF-8  Do not remove or change this line!
'*******************************************************************************
'*
'*  $RCSfile: arrayfuncs.inc,v $
'*
'*  $Revision: 1.3 $
'*
'*  last change: $Author: jsk $ $Date: 2004/06/10 11:12:42 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/******************************************************************************
'*
'* owner : joerg.skottke@sun.com
'*
'* short description : misc functions for simpler listhandling. uses t_lists.inc
'*
'*******************************************************************************
' **
' #0 listdebug
' #0 initlistdebug
' #0 listmoveitem
' #0 listclearpattern
' #0 listconvertpath
' #0 listprint
' **
'\******************************************************************************

function listdebug( lsList() as string , cComment as string ) as integer

   ' This function writes the content of one list plus a comment out to a file.
   ' It is required that the global variables
   ' LDN = ListDebugName (char) = the basename of the debugfiles
   ' LDC = ListDebugCounter (int) = a number added to the filename
   ' are defined.

   dim cFile as string

       LDC = LDC + 1
       cFile = LDN & LDC & ".log"

   dim sList( 5 ) as string
   sList( 0 ) = "5"
   sList( 1 ) = ""
   sList( 2 ) = "---------------------------------------------------------------"
   sList( 3 ) = cComment & " - Listsize: " & listcount( lsList() )
   sList( 4 ) = "---------------------------------------------------------------"
   sList( 5 ) = ""

   ListWrite( sList() , cFile , "utf8" )
   ListWriteAppend( lsList() , cFile , "utf8" )

end function

'*******************************************************************************

function initlistdebug( cComment as string ) as integer

   ' This function is just a helper that prints out some text to a file and
   ' provides the index of the current debug session.

   dim cFile as string
       cFile = LDN & ".log"

   dim sList( 5 ) as string
   sList( 0 ) = "5"
   sList( 1 ) = ""
   sList( 2 ) = "==============================================================="
   sList( 3 ) = cComment & " ---- Debug-Offset is at: " & LDC
   sList( 4 ) = "==============================================================="
   sList( 5 ) = ""

   ListWrite( sList() , cFile , "utf8" )

   printlog( "" )
   printlog( " *** Debug is enabled ***" )
   printlog( "" )

end function

'*******************************************************************************

function listmoveitem( source() as string, _
                       target() as string, _
                       itemid as integer ) as integer

  ' This function takes one item from one list and copies it to another
  ' and removes the original entry. The new size of the original list is
  ' returned.

   listappend( target() , source( itemid ) )
   listdelete( source() , itemid )
   listmoveitem() = listcount( source() )

end function

'*******************************************************************************

function listclearpattern( lsList() as string, _
                           cPattern as string ) as integer

   ' This function searches a list for the occurrence of a special pattern.
   ' If the pattern is found, the entries are deleted, the new size of the
   ' array is returned.

   dim iCurItem as integer
       iCurItem = 1

   do while ( iCurItem <= listcount( lsList() ) )

      if ( instr( lsList( iCurItem ) , cPattern ) <> 0 ) then
         listdelete( lsList() , iCurItem )
      else
         iCurItem = iCurItem + 1
      end if

   loop

   listclearpattern() = listcount( lsList() )

end function

'*******************************************************************************

function listclearblank( lsList() as string ) as integer

   ' This function searches a list for blank lines and removes them

   dim iCurItem as integer
       iCurItem = 1

   do while ( iCurItem <= listcount( lsList() ) )
      if ( len( lsList( iCurItem ) )  = 0 ) then
         listdelete( lsList() , iCurItem )
      else
         iCurItem = iCurItem + 1
      endif

   loop

   listclearblank() = listcount( lsList() )

end function

'*******************************************************************************

function listconvertpath( lsList() as string ) as integer

   ' Does a convertpath() on each item in a list

   dim i as integer

   for i = 1 to listcount( lsList() )
      lsList( i ) = convertpath( lsList( i ) )
   next i

   listconvertpath() = listcount( lsList() )

end function

'*******************************************************************************

function listprint( lsList() as string ) as integer

   ' This function prints a list into the logfile in a special format

   dim i as integer

   for i = 1 to listcount( lsList() )
      printlog( "      * " & lsList( i ) )
   next i

   listprint() = listcount( lsList() )

end function

'*******************************************************************************

function hgetStartOfSection( lsList() as string , _
                             _section as string ) as integer

   ' this function takes a list and looks for a string of the type [_section].
   ' the position of this successful hit is returned.

   dim iThisString as integer
   dim cThisString as string
   dim iListSize as integer
   dim cSection as string

   iThisString = 0
   cSection = lcase ( "[" & _section & "]" )
   iListSize = listcount( lsList() )

   do while ( iThisString <= iListSize )
      iThisString = iThisString + 1
      cThisString = lcase( lsList( iThisString ) )
      if ( instr( cThisString , cSection ) ) then
         hGetStartOfSection() = iThisString + 1
         iThisString = iListSize + 5
      endif
   loop

   if ( iThisString = ( iListSize + 1 ) ) then
      warnlog( "Missing or empty section at end of list" )
   endif

end function

'*******************************************************************************

function hGetEndOfSection( lsList() as string , _
                           iOffset as integer ) as integer


   dim iThisString as integer
   dim cThisString as string
   dim iListSize as integer

   iThisString = iOffset
   iListSize = listcount( lsList() )

   do while ( iThisString <= iListSize )
      cThisString = lsList( iThisString )
      if ( ( instr( cThisString , "[" ) > 0 ) and  _
           ( instr( cThisString , "]" ) > 0 ) )then
         hGetEndOfSection() = iThisString - 1
         iThisString = iListSize + 5
      else
         iThisString = iThisString + 1
      endif
   loop

   if ( iThisString = ( iListSize + 1 ) ) then
      hGetEndOfSection() = iListSize
   endif

end function

'*******************************************************************************

function hGetSection( lsList() as string , _
                      iSectionBegin as integer , _
                      iSectionEnd as integer ) as integer

   dim iArraySize as integer
   dim iThisString as integer

   iArraySize = ubound( lsList() )

   dim lsTempList( iArraySize ) as string
   listcopy( lsList() , lsTempList() )
   listalldelete( lsList() )

   for iThisString = iSectionBegin to iSectionEnd

      listappend( lsList() , lsTempList( iThisString ) )

   next iThisString

   hGetSection() = listcount( lsList() )

end function

'*******************************************************************************

function listInsertSection( lsList() as string, _
                            cSection as string ) as integer
                            
   dim iPos as integer
   dim sSectionString as string

   iPos = listcount( lsList() )

   if ( iPos > 2 ) then
      listappend( lsList() , "" )
   end if                            
   
   sSectionString = "[" & cSection & "]"
   
   listappend( lsList() , sSectionString
   
   listInsertSection() = listcount( lsList() )

end function   
