'encoding UTF-8  Do not remove or change this line!
'*******************************************************************************
'*
'*  $RCSfile: basicide_tools.inc,v $
'*
'*  $Revision: 1.13 $
'*
'*  last change: $Author: jsk $ $Date: 2005/08/02 07:09:16 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/******************************************************************************
' **
' ** owner : joerg.skottke@sun.com
' **
' ** short description : tools for the property-browser test
' **
'*******************************************************************************
' **
' #1 hShowMacroControls ' tears off the ToolsCollectionBar
' #1 hGetBasicWorkFile  ' builds and returns the name of a workfile
' #1 hCreateBasicDialog ' Starts form the BASIC-IDE and creates a new dialog
' #1 hOpenBasicIde      ' Opens the BASIC-IDE from a plain document
' #1 hCloseBasicIde     ' Closes the BASIC-IDE (two attempts before fail)
' #1 hReopenBasicDialog ' Finds an existing BASIC-Dialog-Tab starting from a plain doc
' #1 hFindFirstDialog   ' Find the first dialog 
' #1 hSelectDialogPane  ' select the dialog pane in the dialogwindow
' #1 hCloseCollectionBar' close the ToolsCollectionBar if open
' #1 hInsertMacro       ' Insert a macro into the basic edit-window
' #1 hDeleteMacro       ' Delete all text from the basic edit-window
' #1 hIsEditWindowEmpty ' Find out whether there is text in the EditWindow or not
' #1 hTestMacro         ' Verify we have the correct module/tab open
' #1 hRenameTab         ' rename the tab in BASIC IDE
' #1 hGetTabNameFromOrganizer ' Get the tab-name using the Organizer
' #1 hNewDialog         ' create a new dialog
' #1 hNewModule         ' create a new module
' #1 hHideModule        ' hide the Basic module using the Organizer
' #1 hInitFormControls  ' Execute all functions to get to the formcontrols
' **
'\******************************************************************************

function hShowMacroControls() as boolean

    '///<h1>Tear off the ToolsCollectionBar from the MacroBar</h1>
    '///On success the function returns TRUE else FALSE.
   
    dim iWait as integer
    dim brc as boolean

    Kontext "MacroBar"
    printlog( "Verify that the MacroBar is available" )
    brc = false
    for iWait = 1 to 5
   
        if ( MacroBar.exists() ) then
            printlog( "Macrobar is available after " & iWait & " seconds." )
            brc = true
            exit for
        else
            sleep( 1 )
        endif
        
    next iWait
    
    if ( not brc ) then
        warnlog( "The Macrobar is not available" )
        hShowMacroControls() = false
        exit function
    endif
    
    Kontext "MacroBar"
    printlog( "Try to access the ToolsCollectionBar (to tear off the float)" )
    brc = false
    for iWait = 1 to 3 
    
        if ( controls.isEnabled() ) then
            printlog( "ToolsCollectionBar is open after " & iWait & " seconds." )
            controls.click()
            controls.tearOff()
            brc = true
            exit for
        else
            sleep( 1 )
        endif
        
    next iWait
    
    if ( not brc ) then
        warnlog( "The Controls-button could not be accessed" )
        hShowMacroControls() = false
        exit function
    endif    
    
    Kontext "ToolsCollectionBar"
    ToolsCollectionBar.Move ( 50 , 50 )
    hShowMacroControls() = true    
        
end function

'*******************************************************************************

function hGetBasicWorkFile( cMajor as string ) as string

   '///<h1>This function returns a workfile-name dependent on gApplication.</h1>
   ' Note: Assigns order of doctypes as hNumericDocType does.

   dim sFile as string
   dim cApplication
   
   sFile = gOfficePath & "user\work\"

   cApplication = ucase( gApplication ) 
   select case ( cApplication )
      case "WRITER"    : sFile = sFile & "w_basic" & hGetSuffix( cMajor )
      case "CALC"      : sFile = sFile & "c_basic" & hGetSuffix( cMajor )
      case "IMPRESS"   : sFile = sFile & "i_basic" & hGetSuffix( cMajor )
      case "DRAW"      : sFile = sFile & "d_basic" & hGetSuffix( cMajor )
      case "MATH"      : sFile = sFile & "f_basic" & hGetSuffix( cMajor )
      case "MASTERDOC" : sFile = sFile & "m_basic" & hGetSuffix( cMajor )
      case "HTML"      : sFile = sFile & "h_basic" & hGetSuffix( cMajor )
   end select

   hGetBasicWorkFile() = convertpath( sFile )

end function

'*******************************************************************************

function hCreateBasicDialog() as boolean

    '///<h1>Starting from Basic-IDE this function creates a new dialog</h1>

    ' Note: Open a new document and use 'createNewModuleForDoc' in advance

    Kontext "BasicIDE"
    BasicIde.maximize()

    Tabbar.OpenContextMenu
    sleep( 1 )
   
    hMenuSelectNr( 1 )
    sleep( 1 )
   
    hMenuSelectNr( 2 )

    if ( not DialogWindow.Exists ( 2 ) ) then
        warnlog "No dialog window is shown!"
        hCreateBasicDialog() = false
    else 
        hCreateBasicDialog() = true
    endif

end function

'*******************************************************************************

function hOpenBasicIDE() as boolean

   ' This is a single call to open the BASIC-IDE (existing module)

   hSelectTheLastModule( true )
   Bearbeiten.click()
   
   sleep( 2 )
   kontext "BasicIde"
   BasicIde.maximize()
   if ( BasicIde.exists() ) then
       hOpenBasicIDE() = true
   else
       hOpenBasicIDE() = false
   endif

end function

'*******************************************************************************

function hCloseBasicIDE() as boolean

    '///<h1>Function to close the BASIC-IDE in two different ways</h1>
    '///This function tries to close the BASIC-IDE and warns on trouble
    '///Two methods are used:
    '///<ol>
    '///<li>Via file-menu</li>
    '///<li>Via slot FileClose</li>
    '///</ol>
    
    printlog( "Trying to close BASIC-IDE" )
    
    ' first attempt: Use menu
    Kontext "BasicIde"
    if ( BasicIDE.exists() ) then
    
        printlog( "File->Close via menu" )
        BasicIDE.useMenu()

        hMenuSelectNr( 1 )
        sleep( 1 )

        hMenuSelectNr( 5 )
        sleep( 2 )

    endif
    
    ' second attempt: FileClose
    kontext "BasicIde"
    if ( BasicIDE.exists() ) then
    
        printlog( "FileClose" )
        FileClose
        
    endif
    
    try
        kontext "BasicIde"
        FileClose
        printlog( "Forcing FileClose" )
    catch
    endcatch
    
    ' Verify the result
    kontext "BasicIde"
    if ( BasicIde.exists() ) then
        warnlog( "Unable to close the Basic-Ide" )
        hCloseBasicIde() = false
    else
        hCloseBasicIDE() = true
    endif

end function

'*******************************************************************************

function hReOpenBasicDialog() as boolean

    '///<h1>Function to open BASIC-IDE after loading a workfile</h1>
    '///This is a shortcut that might leave the test in an undefined state
    
    dim brc as boolean

    ' open the macro diaolog, select the last module
    brc = hSelectTheLastModule( true )
    if ( not brc ) then
        warnlog( "Could not open the last module for editing." )
        hReOpenBasicDialog() = false
        exit function
    endif

    ' edit the module
    Bearbeiten.Click()

    ' find the dialog window.
    kontext "BasicIDE"
    BasicIde.maximize()

    brc = hFindFirstDialog() 
    if ( not brc ) then
        warnlog( "Could not find any dialog" )
        hReOpenBasicDialog() = false
    else
        hReOpenBasicDialog() = true
    endif

end function

'*******************************************************************************

function hFindFirstDialog() as boolean

    '///<h1>This function finds the first dialog in the BASIC-IDE</h1>
    '///If a dialog was found it returns TRUE, else FALSE

    kontext "BasicIde"
    BasicIde.maximize()
    dim iPosOverTabbar as integer

    hFindFirstDialog() = false

    ' move over the tabbar and click until a dialog opens (hopefully)
    for iPosOverTabbar = 1 to 20

        Tabbar.MouseDown ( 5 * iPosOverTabbar , 50 )
        Tabbar.MouseUp   ( 5 * iPosOverTabbar , 50 )

        if ( DialogWindow.Exists() ) then
            hFindFirstDialog() = true
            exit for
        endif

    next iPosOverTabbar

end function

'*******************************************************************************

function hSelectDialogPane() as boolean

    dim brc as boolean
    hSelectDialogPane() = true
    
    brc = hCloseCollectionBar()
    if ( not brc ) then
        warnlog( "Could not close ToolsCollectionBar" )
        hSelectDialogPane() = false
        exit function
    endif

    kontext "BasicIDE"
    
    DialogWindow.mouseDown( 10 , 10 )
    DialogWindow.mouseMove( 90 , 90 )
    DialogWindow.mouseUp( 90 , 90 )

end function

'*******************************************************************************

function hCloseCollectionBar() as boolean

    kontext "ToolsCollectionBar"
    if ( ToolsCollectionBar.exists() ) then
        printlog( "Closing ToolsCollectionBar" )
        ToolsCollectionBar.close()
    endif
    
    kontext "ToolsCollectionBar"
    if ( ToolsCollectionBar.exists() ) then
        hCloseCollectionBar() = false
    else
        hCloseCollectionBar() = true
    endif    
    
end function

'*******************************************************************************

function hInsertMacro( _id as integer ) as integer

    '///<h1>Function to insert a macro into the basic ide</h1>
    '///Uses accelerators.

    ' Validate function parameter, rc = -1 on error
    if ( ( _id < 1 ) or ( _id > 2 ) ) then
         warnlog( "hInsertMacro::Macro Index not defined: " & _id )
         hinsertMacro() = -1
         exit function
    endif

    dim brc as boolean ' returncode 
    
    kontext "basicide"
    
    ' Common for all actions is that we delete the existing macro before
    ' inserting the new one. This fails if the accelerator for SelectAll
    ' is incorrect, we try to recover using an alternative method (once).
    ' If this still fails, we return 1 as errorcode and exit the function
    brc = hDeleteMacro()
    if ( not brc ) then
        warnlog( "hInsertMacro::Could not delete content of EditWindow" )
        hInsertMacro() = 1
        exit function
    endif
        

    select case _id
    case 1 :
        ' this is a working macro that contains no errors
        EditWindow.TypeKeys( "'# TTMacro1: This is a short testscript for automated testing!<return><return>" )
        EditWindow.TypeKeys( "sub main<return><return>" )
        EditWindow.TypeKeys( "print " & Chr (34) + "hallo" & Chr (34) )
        EditWindow.TypeKeys( "<Return><Return>" )
        EditWindow.TypeKeys( "<Home>end sub<return>" )
        hInsertMacro() = 0
    case 2 :
        EditWindow.TypeKeys( cAccelerator )
        EditWindow.TypeKeys( "<Delete>" )
        EditWindow.TypeKeys( "'# TTMacro2: a second module for automated testing!" )
        EditWindow.TypeKeys( "<Return><Return>" )
        hInsertMacro() = 0
    end select

   
    
end function

'*******************************************************************************

function hDeleteMacro() as boolean

    '///<h1>Function to delete all text in the Basic EditWindow</h1>

    ' Verify all prerequisites are met (BasicIDE must be open)
    kontext "BasicIDE"
    if ( not BasicIde.exists() ) then
        warnlog( "hDeleteMacro::BasicIDE is not visible/active. Aborting" )
        hDeleteMacro() = false
        exit function
    endif

    dim brc as boolean
    
    ' get the languagespecific accelerator for "Edit->Select All" 
    dim cAccelerator as string
        cAccelerator = hGetAccel( "SelectAll" )
    
    printlog( "hDeleteMacro::Using Accel: " & cAccelerator )

    ' Common for all actions is that we delete the existing macro before
    ' inserting the new one. This fails if the accelerator for SelectAll
    ' is incorrect, we try to recover by doing this manually then.
    EditWindow.TypeKeys( cAccelerator )
    EditWindow.TypeKeys( "<Delete>" )

    ' Verify that the EditWindow is empty, if not use a method that
    ' should work for all languages/locales
    brc = hIsEditWindowEmpty()
    if ( not brc ) then
        qaerrorlog( "#i52430# hDeleteMacro::Accelerator " & cAccelerator & " failed" )
        printlog( "hDeleteMacro::Trying alternative method" )
        EditWindow.TypeKeys( "<Mod1 Home>" )
        EditWindow.TypeKeys( "<Mod1 Shift End>" )
        EditWindow.TypeKeys( "<Delete>" )
        brc = hIsEditWindowEmpty()
    endif

    hDeleteMacro() = brc

end function

'*******************************************************************************

function hIsEditWindowEmpty() as boolean

    '///<h1>Tiny function to test if the Basic-EditWindow is empty</h1>
    kontext "BasicIDE"
    if ( not BasicIDE.exists() ) then
        warnlog( "hIsEditWindowEmpty::BasicIde is not open/visible" )
        hIsEditWindowEmpty() = false
        exit function
    endif

    ' Verify that the EditWindow is empty. EditCopy is disabled when empty
    EditWindow.TypeKeys( "<Mod1 Home>" )
    EditWindow.TypeKeys( "<Mod1 Shift End>" )
    try
        EditCopy
    catch
        setClipboard( "" )
    endcatch

    if ( getClipBoardText() <> "" ) then
        hIsEditWindowEmpty() = false
        printlog( "hIsEditWindowEmpty::no" )
    else
        hIsEditWindowEmpty() = true
        printlog( "hIsEditWindowEmpty::yes" )
    endif

end function

'*******************************************************************************

function hTestMacro( _id as integer ) as integer

    kontext "basicide"
    hTestMacro() = 0

    select case _id
    case 1 :
        EditWindow.TypeKeys( "<Up>", 20 )
        EditWindow.TypeKeys( "<Home><Shift End>" )
        if ( Instr ( GetClipboardText, "TTMacro1" ) <> 0 ) then
            htestMacro() = 1
        endif
    case 2 :
        EditWindow.TypeKeys( "<Up>", 20 )
        EditWindow.TypeKeys( "<Home><Shift End>" )
        if ( Instr ( GetClipboardText, "TTMacro2" ) <> 0 ) then
            htestMacro() = 2
        endif
    end select
    
end function

'*******************************************************************************

function hRenameTab( cTabName as string ) as integer

    ' this function opens the context menu of the tabbar, selects 'rename' 
    ' for the current tab and overwrites the (selected) text.
    
    dim cString as string
    dim iWait as integer

    cString = "<HOME><SHIFT END>" & cTabName & "<RETURN>" 
    
    try
        kontext "basicide"
        Tabbar.OpenContextMenu
        hMenuSelectNr( 3 )
        sleep( 2 )
        kontext "basicide"
        Tabbar.TypeKeys( cString , true )
        hRenameTab() = 0
    catch
        hRenameTab() = 2
    endcatch
    
    kontext "active"
    for iWait = 1 to 3
        sleep( 1 )
        if ( active.exists() ) then
            hRenameTab() = 1
            exit for
        endif
    next iWait
 
    
end function

'*******************************************************************************

function hGetTabNameFromOrganizer() as string

    if ( hOpenBasicOrganizer( 1 ) ) then

        hGetTabNameFromOrganizer() = Modulliste.GetSelText()
        TabModule.Close()
        
    else
    
        warnlog( "The macro organizer doesn't appear to be open. " )
        
    endif
   
end function

'*******************************************************************************

function hNewDialog() as boolean

    kontext "basicide"
    Tabbar.OpenContextMenu
    hMenuSelectNr( 1 )
    sleep( 1 )
    hMenuSelectNr( 2 )
    sleep( 2 )
    
    if ( DialogWindow.Exists() ) then 
        hNewDialog() = true 
    else
        hNewDialog() = false
    endif

end function

'*******************************************************************************

function hNewModule() as boolean

    kontext "basicide"
    Tabbar.OpenContextMenu
    hMenuSelectNr( 1 )
    sleep( 1 )
    hMenuSelectNr( 1 )
    sleep( 2 )
    
    if ( EditWindow.Exists() ) then 
        hNewModule() = true 
    else
        hNewModule() = false
    endif

end function        

'*******************************************************************************

function hHideModule( ) as integer

   kontext "basicide"
   
   try
       tabbar.openContextMenu
       hMenuSelectNr( 4 )
       sleep( 1 )
       hHideModule() = 0
   catch
       hHideModule() = 1 
   endcatch
   
end function   

'*******************************************************************************

function hInitFormControls( cModule as string ) as boolean

    '///<h1>Do everything necessary to get to the formcontrols</h1>
    '///<ol>
    '///<li>Open the Basic Organizer</li>
    '///<li>Create a new module for the current document</li>
    '///<li>Open a new basic dialog</li>
    '///<li>Open the Macro controls float</li>
    '///</ol>
    '///The function returns false on failure and resets everything
    
    const CFN = "hInitFormControls::"    
    
    if ( cModule = "" ) then
        warnlog( CFN & "Invalid parameter passed to function" )
        hInitFormControls() = false
        exit function
    endif        
    
    ' some multi-purpose return code 
    dim brc as boolean 
    
    ' open the Basic Organizer. On failure: Abort function gracefully
    brc = hOpenBasicOrganizerFromDoc()
    if ( not brc ) then
        warnlog( CFN & "Could not open the Basic Organizer, aborting" )
        hInitFormControls() = false
        exit function
    endif

    ' create a new module. On failure: Abort function gracefully
    brc = hCreateModuleForDoc( cModule )
    if ( not brc ) then
        warnlog( CFN & "The Basic-IDE is not open, aborting" )
        hInitFormControls() = false
        exit function
    endif

    ' create a new dialog. On failure: Abort function gracefully
    brc = hCreateBasicDialog()
    if ( not brc ) then
        warnlog( "Could not create Basic-Dialog" )
        hCloseBasicIde()
        hInitFormControls() = false
        exit function
    endif    
    
    ' open the macro controls float. On failure: Abort function gracefully
    brc = hShowMacroControls()
    if ( not brc ) then
        warnlog( CFN & "Could not tear off the macro controls float" )
        hCloseBasicIde()
        hInitFormControls() = false
        exit function            
    endif
    
    
    hInitFormControls() = true
    
end function
