'encoding UTF-8  Do not remove or change this line!
'*******************************************************************************
'*
'*  $RCSfile: basicorganizer_tools.inc,v $
'*
'*  $Revision: 1.5 $
'*
'*  last change: $Author: jsk $ $Date: 2005/06/23 13:48:57 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'/******************************************************************************
' **
' ** owner : joerg.skottke@sun.com
' **
' ** short description : tools for tools/macro test
' **
'*******************************************************************************
' **
' #1 hSelectTheLastModule ' selects the last basic module (documentbasic)
' #1 hCreateModuleForDoc  ' creates a new module for the current document
' #1 hOpenBasicOrganizer  ' opens the organizer for libraries,modules,dialogs
' **
'\******************************************************************************

function hSelectTheLastModule( bEditEnabled as Boolean ) as boolean

    dim iRepeat as integer
    dim sInterim as String
    dim brc as boolean   
        brc = false

    ' tools / macro and select the last entry for the new document
    ' now it is an UNO-Slot, the normal slot can still be called in Math,
    ' but it should be disabled

    ' NOTE: The parameter bEditEnabled is a randomizer. It's completely 
    '       useless. I left it there to not break compatibility with
    '       the othe rfunctions that call hSelectTheLastModule.
    
    Kontext "DocumentWriter"
    ' UNO slot of the macro dialog
    ToolsMacro_uno

    Kontext "Makro"
    if ( not Makro.exists() ) then
        warnlog( "Macro organizer is not open" )
        hSelectTheLastModule() = false
        exit function
    endif
    
    Call DialogTest ( Makro )

    Kontext "Macro"
    MakroAus.TypeKeys( "<PageUp>", 10 )
    MakroAus.TypeKeys( "-" )
    MakroAus.TypeKeys( "<Down>" )
    sInterim = MakroAus.GetSelText()

    for iRepeat = 1 to 20
    
        MakroAus.TypeKeys( "-" )
        MakroAus.TypeKeys( "<Down>" )

        if ( MakroAus.GetSelText() = sInterim ) then
            exit for
        endif

    next iRepeat

    MakroAus.TypeKeys( "+" )
    MakroAus.TypeKeys( "<Down>" )
    MakroAus.TypeKeys( "+" )
    MakroAus.TypeKeys( "<PageDown>", 3 )

    ' if we expect an existing module that can be edited, we go in here
    ' and try to find anything that can be edited. Oh my, i've got to rewrite
    ' this. A pain in the ass. :(
    if ( bEditEnabled ) then

        for iRepeat = 1 to 20

            if ( Bearbeiten.IsEnabled() ) then
                brc = true
                exit for
            else
                printlog( "Trying to find a Module that can be edited" )
                MakroAus.TypeKeys( "<Up>" )
                brc = false
            endif

        next iRepeat
        
    else
    
        ' This is the usual usage of this function: To go down to a Library
        ' (the last Lib always belongs to a document) and we check that we 
        ' can create a new module. If this is the case, true is returned.
        kontext "Macro"
        if ( Neu.isEnabled() ) then
            brc = true
        else
            brc = false
        endif

    endif
    
    if ( brc ) then
        printlog( "Selecting the last module succeeded" )
    else
        warnlog( "Selecting the last module failed" )
    endif 
    
    hSelectTheLastModule() = brc

end function

'*******************************************************************************

function hCreateModuleForDoc( optional cName as string ) as boolean

    '///<h1>This function creates a new basic-module for the current document"</h1>
    '///<ul>
    '///<li>Select the last module (it should belong to the current document)</li>
    '///<li>Click the New-Button, name the module</li>
    '///<li>Wait for the BASIC_IDE to open</li>
    '///</ul>

    dim iWait as integer   ' how long we had to wait for the IDE to open
    dim iPos as integer
    dim brc as boolean     ' boolean returncode, a temporary variable
        brc = false

    ' make sure that we have a name for the module
    if ( isMissing( cName ) ) Then
        cName = "TTModule"
    endif

    printlog( "hCreateModuleForDoc::Selecting last module in treelist" )
    kontext "Makro"
    iPos = hSelectTheLastNode( MakroAus )
    
    
    if ( Neu.isEnabled() ) then
        printlog( "hCreateModuleForDoc::New-button is enabled" )
    else
        warnlog( "hCreateModuleForDoc::New-button is disabled" )
        hCreateModuleForDoc() = false
        exit function
    endif
    
    Neu.Click()
    
    Kontext "NeuesModul"
    printlog( "name the module: " & cName )
    Modulname.SetText( cName )
    NeuesModul.OK()
    
    printlog( "wait for the BASIC-IDE to open" )
    brc = false
    for iWait = 1 to 10 
    
        sleep( 1 )
        
        kontext "BasicIDE"
        if ( BasicIDE.exists() ) then
            printlog( "BASIC-IDE open after " & iwait & " seconds." )
            brc = true
            exit for
        endif
        
    next iWait
    
    hCreateModuleForDoc() = brc

end function

'*******************************************************************************

function hOpenBasicOrganizer( _tab as integer ) as boolean

    ' This function opens a specified tab on the BASIC Organizer from the
    ' BASIC-IDE
    ' NOTE: This is the organizer for libraries, modules and dialogs,
    '       not the one to run or assign macros!

    dim iMenuSize as integer
    hOpenBasicOrganizer() = false
    
    kontext "basicide"
    Tabbar.OpenContextMenu
    
    iMenuSize = hMenuItemgetCount()
    if ( iMenuSize = 2 ) then
        printlog( " * short context menu (no edit-window)" )
        hMenuSelectNr( 2 )
    else
        printlog( " * long context menu (edit-window/dialog visible)" )
        hMenuSelectNr( 5 )
    endif
    
    sleep( 1 )

    select case _tab
    case 1 : 
        kontext
        Active.SetPage TabModule
        kontext "tabmodule"
        if ( TabModule.exists() ) then
            hOpenBasicOrganizer() = true
        endif
        
    case 2 : 
        kontext
        Active.setPage TabDialogs
        kontext "tabdialogs"
        if ( TabDialogs.exists() ) then
            hOpenBasicOrganizer() = true
        endif
    case 3 :
        kontext
        Active.setPage TabBibliotheken
        kontext "tabbibliotheken"
        if ( TabBibliotheken.exists() ) then
            hOpenBasicOrganizer() = true
        endif
    end select
    
end function

'*******************************************************************************

function hOpenBasicOrganizerFromDoc() as boolean

    ToolsMacro_uno
    kontext "Makro"
    if ( not Makro.exists() ) then
        warnlog( "hOpenBasicOrganizerFromDoc::Could not open Macro Organizer" )
        hOpenBasicOrganizerFromDoc() = false
        exit function
    endif
    
    call dialogtest( Makro )
    
    printlog( "hOpenBasicOrganizerFromDoc::Basic Organizer is open" )
    hOpenBasicOrganizerFromDoc() = true
    kontext "Makro"
    
end function
