'encoding UTF-8  Do not remove or change this line!
'*******************************************************************************
'*
'*  $RCSfile: langswitch.inc,v $
'*
'*  $Revision: 1.3 $
'*
'*  last change: $Author: jsk $ $Date: 2005/04/19 15:00:52 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/******************************************************************************
'*
'*  owner : joerg.skottke@sun.com
'*
'*  short description : Tools for switching UI-languages
'*
'*******************************************************************************
'**
' #1 hSwitchToLanguage ' Tools for switching UI-languages
'**
'\******************************************************************************

function hSwitchToLanguage( cLanguage as string , _
                            clLangList() as string ) as integer

    ' this is needed to identify a language in the current l10n
    dim cLangScheme( 100 ) as string
    
    ' transform the language string to numeric value (just a precaution)
    dim iLangCast as integer
    
   

    ' cast string to int (string = "01" -> int = 1)
    iLangCast = val( cLanguage )

    ' switch UI-Language, re-casting int to string
    hSetUILanguage( clLangList() , iLangCast )
    
    hSwitchToLanguage = iSprache
        
end function

'*******************************************************************************

function hSaveLangScheme( cSavePath as string , iLang as integer )
    
    dim iLanguages as integer
    dim iCurrentEntry as integer
    dim cUILangList( 30 ) as string
    dim sFileName as string
                                        
    ToolsOptions
    
    hToolsOptions( "LANGUAGESETTINGS" , "LANGUAGES" )
    
    iLanguages = UILanguage.getItemCount()
    cUILangList( 0 ) = iLanguages
    
    for iCurrentEntry = 1 to iLanguages
    
        UILanguage.select( iCurrentEntry )
        cUILangList( iCurrentEntry ) = UILanguage.getSelText()
    
        printlog( iCurrentEntry & ". : " & cUILangList( iCurrentEntry ) )
        
    next iCurrentEntry
    
    kontext "OptionenDlg"
    OptionenDlg.cancel()
    
    sFileName = cSavePath & "\uilang" & iLang & ".txt"
    sFileName = convertpath( sFileName )
    printlog( "Write UI-Language-Names to " & sFileName )
    listwrite( cUILangList() , sFileName , "UTF8" ) 
                                        
end function

'*******************************************************************************

function hSaveLangStrings( cSavePath as string , iLang as integer )

    dim sFileName as string
    dim cUIStringList( 3 ) as string
        cUIStringList( 0 ) = "3"
    
    hGetLangStrings( cUIStringList() )
    
    sFileName = cSavePath & "\uistrings" & iLang & ".txt"
    sFileName = convertpath( sFileName )
    printlog( "Write UI-Strings-list to " & sFileName )
    listwrite( cUIStringList() , sFileName , "UTF8" )     
    
end function

'*******************************************************************************

function hLoadLangScheme( clLangScheme() as string , _
                               iLanguage as integer ) as integer
                               
    ' this function reads the languages dependent names of the currently
    ' active UI-Language. (e.g. English UI = German (Germany), German UI=
    ' Deutsch (Deutschland) etc. )
    ' If no reference file exists, the routine defaults to en_US and warns.
    ' usually iLanguage = iSprache
    
    ' this is where the input files are located
    dim cLoadPath as string
        cLoadPath = "framework\install\input\langswitch" 
        cLoadPath = convertpath( gTesttoolPath & cLoadPath )  
    
    ' the file to read
    dim cFile as string
    cFile = cLoadPath & "\uilang" & iLanguage & ".txt"
    cFile = convertpath( cFile )

    ' check if file exists, else use default (en_US)
    if ( dir( cFile ) = "" ) then
        cFile = cLoadPath & "\uilang1.txt"
        cFile = convertpath( cFile )
        warnlog( "Non-localized language-strings in UI-Language selection," & _
                 " using default (en_US)" )
    endif
    
    printlog( "Loading language-scheme from " & cFile )

    ' read in the file (identical to listread ( array, file , "UTF8" ))
    hGetDatafileSection( cFile , clLangScheme() , "" , "" , "" )
    
    listprint( clLangScheme() , "clLangScheme in langswitch.inc::hLoadLangScheme" )

    ' return the length of the list 
    hLoadLangScheme() = listcount( clLangScheme )

end function

'*******************************************************************************

function hLoadLangStrings( cRefStrings() as string , _
                               cLoadPath as string , _
                               iLanguage as integer ) as integer
                      
    ' the file to read
    dim cFile as string
    cFile = cLoadPath & "\uistrings" & iLanguage & ".txt"
    cFile = convertpath( cFile )
    
    ' check if file exists, else use default (en_US)
    if ( dir( cFile ) = "" ) then
        cFile = cLoadPath & "\uistrings1.txt"
        cFile = convertpath( cFile )
        warnlog( "Non-localized strings in UI, using default (en_US)" )
    endif
    
    printlog( "Loading UI-Strings from " & cFile )

    ' read in the file (identical to listread ( array, file , "UTF8" ))
    hGetDatafileSection( cFile , cRefStrings() , "" , "" , "" )

    ' return the length of the list 
    hLoadLangStrings() = listcount( cRefStrings() )

end function                      

'******************************************************************************

function hSetUILanguage( clLangScheme() as string, cLanguage as string ) 

    ' this function switches the UI language to a given value. 

    dim cUILanguageName as string
    
    listprint( clLangScheme() , "Langscheme in hSetUILanguage" )

    cUILanguageName = hGetValueForKeyAsString( clLangScheme() , cLanguage )
    printlog( "Setting UI-Language: " & cUILanguageName )

    ' open tools/options
    ToolsOptions
    hToolsOptions( "LANGUAGESETTINGS" , "LANGUAGES" )

    ' select the language
    UIlanguage.select( cUILanguageName )

    ' close options-dialog
    kontext "OptionenDlg"
    OptionenDlg.OK()

    ' there should be a messagebox unless we re-select the current language
    kontext "active"
    if ( active.exists( 1 ) ) then
        active.ok()
    else
        ' if we set the current language as new, there will be no warning.
        if ( iSprache <> val( cLanguage ) ) then
	        warnlog( "Missing warning for UI-Language-Switch" )
	    endif
    endif

    printlog( "Restarting the Office to enable the changes." )
    call exitRestartTheOffice()

end function

'******************************************************************************

function hGetLangStrings( teststring() )

    ' this tiny function gathers three strings from different areas of the
    ' office for comparision.
    
    printlog( "Gathering strings for comparision" )
    
    ' initialize the arry so it can be used by list-functions
    teststring( 0 ) = "3"

    'get the first string (Tools/Options/Office/General/Reset Help agent)
    teststring( 1 ) = hGetTestString1()
    'printlog( " - String (Fixed text): " & teststring( 1 ) )

    ' get the second string (from style-listbox)
    teststring( 2 ) = hGetTestString2()
    'printlog( " - String (Style-Name): " & teststring( 2 ) )

    ' get the third string (Name of 'File' menu)
    teststring( 3 ) = hGetTestString3()
    'printlog( " - String (Menuitem)..: " & teststring( 3 ) )

end function

'******************************************************************************

function hGetTestString1() as string


    ToolsOptions

    hToolsOptions( "STAROFFICE" , "GENERAL" )
   
    'printlog( "Retrieving UI-String: Fixed Text from Tools/Options" )
    hGetTestString1() = TabSonstigesAllgemein.GetFixedText( 2 )

    kontext "OptionenDlg"
    OptionenDlg.cancel()

end function 

'******************************************************************************

function hGetTestString2() as string

    ' this tiny function gets the text from the Style-Combobox on the 
    ' TableObjectBar

    kontext "TableObjectBar"
    
    'printlog( "Retrieving UI-String: Style Combobox on TableObjectBar" )
    hGetTestString2() = vorlage2.getSelText()

end function

'*******************************************************************************

function hGetTestString3() as string

    ' this small function grabs the localized name of the "File" menuitem
    
    kontext "DocumentWriter"
    
    'printlog( "Retrieving UI-String: Name of 'File'-menu" )
    call hUseMenu()
    hGetTestString3() = MenuGetItemText( 1 )

end function
