'encoding UTF-8  Do not remove or change this line!
'*******************************************************************************
'*
'*  $RCSfile: listbox.inc,v $
'*
'*  $Revision: 1.3 $
'*
'*  last change: $Author: jsk $ $Date: 2005/01/05 14:40:06 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/******************************************************************************
'*
'* owner : joerg.skottke@sun.com
'*
'* short description :
'*
'*******************************************************************************
' **
' #1 checkListBox   ' compares an index to one provided in a reference-file
' #1 setListBox     ' selects an index provided by a reference file
' **
'\******************************************************************************

function checkListBox( _file as string , _
                        sKey as string , _
                     control as object ) as boolean

   dim controltext as string  ' current state
   dim _controltext as string ' reference

   if ( sKey = "*" ) then sKey = control.name()

   sKey = lcase( sKey )

   if ( control.exists() = true and control.IsVisible = true ) then

      _controltext = lcase( hGetFileData( _file , skey ) )
      controltext = control.getSelIndex()
      keycompare( controltext , _controltext , sKey )
      checkListBox() = control.isEnabled()

   else

      warnlog( "Control <" & sKey & "> could not be accessed." )

   endif

end function

'*******************************************************************************

function setListBox( _file as string , _
                      sKey as string , _
                   control as object , _
         optional bverbose as boolean  ) as integer

   dim _controltext as string ' reference

   ' if name of the control is '*' get the name from the control itself
   if ( ismissing( bverbose ) ) then bverbose = true
   if ( sKey = "*" ) then sKey = control.name()

   ' change the key to lowercase
   sKey = lcase( sKey )

   if ( control.exists() = true and control.IsVisible = true ) then

      _controltext = hGetFileData( _file , sKey )
      control.select( val( _controltext ) )
      setListBox() = control.getselindex()
      if ( bverbose = true ) then printlog( "     * " & sKey )

   else

      warnlog( "Control <" & sKey & "> is not accessible." )

   endif

end function
