'encoding UTF-8  Do not remove or change this line!
'*******************************************************************************
'*
'*  $RCSfile: pathlist.inc,v $
'*
'*  $Revision: 1.1 $
'*
'*  last change: $Author: jsk $ $Date: 2004/02/06 10:52:59 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/******************************************************************************
'*
'* owner : joerg.skottke@sun.com
'*
'* short description :
'*
'*******************************************************************************
' **
' #1 checkPathItem
' #1 getPathString
' #1 getPathStringFromDialog
' **
'\******************************************************************************

function checkPathItem( _file as string , sKey as string ) as boolean

   dim _sRefpath as string
   dim sRefpath as string

   sKey = lcase( sKey )

   sRefpath = getPathString( sKey )
   _sRefpath = hGetFileData( _file , sKey )

   checkPathItem() = keycompare( sRefpath , _sRefpath , sKey )

end function

'*******************************************************************************

function getPathString( sKey as string ) as string

   dim iCurrentPath as integer

   kontext "TabPfade"

   ' select the first item in the list
   typ.typekeys( "<Down>" )
   typ.typekeys( "<Home>" )

   ' run through the list until the key is found.
   for iCurrentPath = 1 to typ.getItemCount()

      if ( lcase( typ.getSelText() ) = sKey ) then

         bearbeiten.click()
         getPathString = getPathStringFromDialog()
         exit function

      else

         typ.typekeys( "<Down>" )

      endif

   next iCurrentPath

   getPathString() = "Error. Key not found in pathlist"

end function

'*******************************************************************************

function getPathStringFromDialog() as string

   ' we have two different path selection dialogs. One supports exactly one
   ' path (FileOpen dialog) and the other allows multiple paths.
   ' PfadeAuswaehlen does not append a trailing / so this has to be done
   ' manually. (sigh)

   dim sPath as string

   kontext "PfadeAuswaehlen"
   if ( PfadeAuswaehlen.exists( 2 )) then

      getPathStringFromDialog() = pfade.getItemText(1) + gPathSigne()
      PfadeAuswaehlen.cancel()

   endif

   kontext "OeffnenDlg"
   if ( OeffnenDlg.exists( 2 ) ) then

      getPathStringFromDialog() = Pfad.getSelText()
      OeffnenDlg.cancel()

   endif

   kontext "TabPfade"

end function
