'encoding UTF-8  Do not remove or change this line!
'*******************************************************************************
'*
'*  $RCSfile: scriptingtools.inc,v $
'*
'*  $Revision: 1.10 $
'*
'*  last change: $Author: jsk $ $Date: 2005/05/24 09:46:16 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/******************************************************************************
'*
'* owner : joerg.skottke@sun.com
'*
'* short description :
'*
'*******************************************************************************
' **
' #1 hGetNodeCount
' #1 hSelectTopNode
' #1 hGetNodeName
' #1 hExpandNode
' #1 hExpandAllNodes
' #1 hGetVisibleNodeNames
' #1 hAddPackage           ' Adds a package using the package manager-ui
' #1 hRemovePackageGeneric ' Removes or disables a package in pkgmgr-ui
' #1 hRemovePackage        ' deprecated. Removes a package. Circumvents multiselection in pkgmgr-ui
' **
'\******************************************************************************

function hGetNodeCount( _control as object ) as integer

   hGetNodeCount() = _control.getItemCount()
   
end function

'*******************************************************************************

function hSelectTopNode( _control as object ) as boolean

   _control.typekeys( "<HOME>" )
   
   if ( _control.getSelIndex() = 1 ) then
   
      hSelectTopNode() = true
      
   else 
   
      hSelectTopNode() = false
      
   endif
   
end function

'*******************************************************************************

function hGetNodeName( _control as object , _id as integer ) as string

   _control.select( _id )
   hGetNodeName() = _control.getSelText()
   
end function

'*******************************************************************************

function hExpandNode( _control as object, node as integer ) as boolean

   dim iOldNodeCount as integer
   dim iNewNodeCOunt as integer
   
   iOldNodeCount = hGetNodeCount( _control )

   ' 0 = currently selected node, else open node 'node' (absolute)
   if ( node > 0 ) then
       _control.select( node )
   endif
   _control.typekeys( "<RIGHT>" )
   
   iNewNodeCount = hGetNodeCount( _control )
   
   if ( iNewNodeCount > iOldNodeCount ) then
   
      hExpandNode() = true
      
   else
   
      hExpandNode() = false
      
   endif
   
end function

'*******************************************************************************

function hExpandAllNodes( _control as object ) as integer

   dim iNode as integer
   dim iNodeCount as integer
   
   iNode = 0
   iNodeCount = 1000

   hSelectTopNode( _control )
   
   do while ( iNode < iNodeCount )
   
      iNode = iNode + 1
      hExpandNode( _control , iNode )
      iNodeCount = hGetNodeCount( _control )
      
   loop
       
   hExpandAllNodes() =  iNodeCount
      
end function

'*******************************************************************************

function hGetVisibleNodeNames( _control as object , _
                               lsList() as string ) as integer
            
   ' Get the list of all visible (expanded) nodes and store it
   ' in lsList(). if _id > ubound lsList() an error is given and lsList remains
   ' empty, thus returning "0"
                               
   dim iNodeCount as integer
   dim iThisNode as integer

   iNodeCount = hGetNodeCount( _control )
   
    if ( iNodeCount > ubound( lsList() ) ) then
        warnlog( "Array to small to hold: " & iNodeCount & " items" )
    else
        hSelectTopNode( _control )
   
        for iThisNode = 1 to iNodeCount

            listappend( lsList() , hGetNodeName( _control , iThisNode )

        next iThisNode
        
    endif
   
    hGetVisibleNodeNames() = listcount( lsList() )

end function  

'*******************************************************************************

function hSelectNode( _control as object , _id as integer ) as string

    if ( _id <= hGetNodeCount( _control ) ) then
        _control.select( _id )
        hSelectNode() = hGetNodeName( _control , _id )
    else
        warnlog( "Selected ID of node is too large" )
        hSelectNode() = ""
    endif

end function

'*******************************************************************************

function hSelectNodeByName( _control as object , _
                            _name as string , _
                            optional _automatic ) as integer

    dim iThisNode as integer
    dim iNodeCount as integer    
    dim bBreak as boolean

    bBreak = false
    iThisNode = 0
    
    ' use _automatic = true if you don't know at which node 
    ' the requested item is. This is much slower than specifying
    ' the location of the object directly
    if ( ismissing( _automatic ) ) then _automatic = false
    if ( _automatic ) then
        hExpandAllNodes( _control )
        hSelectTopNode( _control )
    endif
   
   ' find out how many objects are in the listbox
   iNodeCount = hGetNodeCount( _control )
                               
   ' Now find the first node that matches the given _name
   do while ( bBreak = false )
   
      iThisNode = iThisNode + 1
      
      if ( iThisNode > iNodeCount ) then 
         hSelectNodeByName() = 1
         bBreak = true
      else
         _control.select( iThisNode )
      endif
      
      if ( _name = _control.getText() ) then
         hSelectNodeByName() = iThisNode
         bBreak = true
      endif         
      
   loop
   
end function
                         
'*******************************************************************************

function hInsertMacro( _id as integer ) as integer

    ' this function inserts a macro into the editor of the BASIC ide.
    
    
    kontext "basicide"

    select case _id
    case 1 :
        ' this is a working macro that contains no errors
        EditWindow.TypeKeys( "<Mod1 a>" )
        EditWindow.TypeKeys( "<Delete>" )
        EditWindow.TypeKeys( "'# TTMacro1: This is a short testscript for automated testing!<return><return>" )
        EditWindow.TypeKeys( "sub main<return><return>" )
        EditWindow.TypeKeys( "print " & Chr (34) + "hallo" & Chr (34) )
        EditWindow.TypeKeys( "<Return><Return>" )
        EditWindow.TypeKeys( "<Home>end sub<return>" )
        hInsertMacro() = 0
    case 2 :
        EditWindow.TypeKeys( "<Mod1 a>" )
        EditWindow.TypeKeys( "<Delete>" )
        EditWindow.TypeKeys( "'# TTMacro2: a second module for automated testing!" )
        EditWindow.TypeKeys( "<Return><Return>" )
        hInsertMacro() = 0
    case else :
        warnlog( "The requested macro is not defined yet" )
        hinsertMacro() = 1
    end select
   
    
end function

'*******************************************************************************

function hTestMacro( _id as integer ) as integer

    kontext "basicide"
    hTestMacro() = 0

    select case _id
    case 1 :
        EditWindow.TypeKeys( "<Up>", 20 )
        EditWindow.TypeKeys( "<Home><Shift End>" )
        if ( Instr ( GetClipboardText, "TTMacro1" ) <> 0 ) then
            htestMacro() = 1
        endif
    case 2 :
        EditWindow.TypeKeys( "<Up>", 20 )
        EditWindow.TypeKeys( "<Home><Shift End>" )
        if ( Instr ( GetClipboardText, "TTMacro2" ) <> 0 ) then
            htestMacro() = 2
        endif
        
    case else :
    
        htestMacro() = 3
    end select
    
end function

'*******************************************************************************

function hRenameTab( cTabName as string ) as integer

    ' this function opens the context menu of the tabbar, selects 'rename' 
    ' for the current tab and overwrites the (selected) text.
    
    dim cString as string

    cString = "<HOME><SHIFT END>" & cTabName & "<RETURN>" 
    
    try
        kontext "basicide"
        Tabbar.OpenContextMenu
        hMenuSelectNr( 3 )
        sleep( 2 )
        kontext "basicide"
        Tabbar.TypeKeys( cString , true )
        hRenameTab() = 0
    catch
        hRenameTab() = 2
    endcatch
    
    sleep( 1 )
    
    kontext "active"
    if ( active.exists( 1 ) ) then
       hRenametab() = 1 
    endif
    
end function

'*******************************************************************************

function hGetTabNameFromOrganizer() as string

    if ( hOpenBasicOrganizer( 1 ) ) then

        hGetTabNameFromOrganizer() = Modulliste.GetSelText()
        TabModule.Close()
        
    else
    
        warnlog( "The macro organizer doesn't appear to be open. " )
        
    endif
   
end function

'*******************************************************************************

function hNewDialog() as boolean

    kontext "basicide"
    Tabbar.OpenContextMenu
    hMenuSelectNr( 1 )
    sleep( 1 )
    hMenuSelectNr( 2 )
    sleep( 2 )
    
    if ( DialogWindow.Exists() ) then 
        hNewDialog() = true 
    else
        hNewDialog() = false
    endif

end function

'*******************************************************************************

function hNewModule() as boolean

    kontext "basicide"
    Tabbar.OpenContextMenu
    hMenuSelectNr( 1 )
    sleep( 1 )
    hMenuSelectNr( 1 )
    sleep( 2 )
    
    if ( EditWindow.Exists() ) then 
        hNewModule() = true 
    else
        hNewModule() = false
    endif

end function        

'*******************************************************************************

function hHideModule( ) as integer

   kontext "basicide"
   
   try
       tabbar.openContextMenu
       hMenuSelectNr( 4 )
       sleep( 1 )
       hHideModule() = 0
   catch
       hHideModule() = 1 
   endcatch
   
end function   

'*******************************************************************************

function hOpenBasicOrganizer( _tab as integer ) as boolean

    ' This function opens a specified tab on the BASIC Organizer from the
    ' BASIC-IDE

    dim iMenuSize as integer
    hOpenBasicOrganizer() = false
    
    kontext "basicide"
    Tabbar.OpenContextMenu
    
    iMenuSize = hMenuItemgetCount()
    if ( iMenuSize = 2 ) then
        printlog( " * short context menu (no edit-window)" )
        hMenuSelectNr( 2 )
    else
        printlog( " * long context menu (edit-window/dialog visible)" )
        hMenuSelectNr( 5 )
    endif
    
    sleep( 1 )

    select case _tab
    case 1 : 
        kontext
        Active.SetPage TabModule
        kontext "tabmodule"
        if ( TabModule.exists() ) then
            hOpenBasicOrganizer() = true
        endif
        
    case 2 : 
        kontext
        Active.setPage TabDialogs
        kontext "tabdialogs"
        if ( TabDialogs.exists() ) then
            hOpenBasicOrganizer() = true
        endif
    case 3 :
        kontext
        Active.setPage TabBibliotheken
        kontext "tabbibliotheken"
        if ( TabBibliotheken.exists() ) then
            hOpenBasicOrganizer() = true
        endif
    end select
    
end function

'*******************************************************************************

function hSetMacroSecurity( ilevel ) as integer

    ' this function changes the macro security level from 0 (Low) to 
    ' 3 (Very high) and returns the prior state.
    ' a window document needs to be open.
    
    ToolsOptions
    
    hToolsOptions( "Staroffice" , "Security" )
    
    Kontext "TabSecurity"
    MacroSecurity.click()
    sleep( 1 )
    
    Kontext
    active.setpage TabSecurityLevel
    
    Kontext "TabSecurityLevel"
    sleep( 1 )
    
    ' get the current state and assign as function returnvalue
    if ( veryhigh.ischecked() ) then
        hSetMacroSecurity() = 3
        wait( 500 )
    elseif( high.ischecked() ) then
        hSetMacroSecurity() = 2
        wait( 500 )
    elseif( medium.ischecked() ) then
        hSetMacroSecurity() = 1
        wait( 500 )
    elseif( low.ischecked() ) then
        hSetMacroSecurity() = 0
        wait( 500 )
    else
        warnlog( "What?" )
    endif
    
    ' set the new security level
    select case iLevel
    case 0 : 
        low.check()
        printlog( " * setting macro security level to low" )
    case 1 : 
        medium.check()
        printlog( " * setting macro security level to medium" )
    case 2 : 
        high.check()
        printlog( " * setting macro security level to high" )
    case 3 : 
        veryhigh.check()
        printlog( " * setting macro security level to very high" )
    end select
    wait( 500 )
    
    TabSecurityLevel.ok()
    sleep( 1 )
    
    exitToolsOptions( false )
    
end function

'*******************************************************************************

function hAddPackage( cFile as string, optional bClose as boolean ) as string

    '///<h1>Add a package to "My Macros" using the Package-Manager-UI</h1>
    '///<ul>
    
    dim iWait as integer ' increment-variable 
    dim cPkgName as string
    
    ' Do not close the Dialog by default
    if ( ismissing( bClose ) ) then bClose = false
    
    '///<li>Open the Package-Manager UI</li>
    printlog( "Open the Package-Manager-UI" )
    ToolsPackageManager
    
    '///<li>Make sure the first item in thelist is selected</li>
    printlog( "Select the first item" )
    kontext "packagemanager"
    BrowsePackages.select( 1 )
    BrowsePackages.typeKeys( "<UP>" )
    
    '///<li>Click the 'Add' button</li>
    printlog( "Click the 'Add' button" )
    Add.click()
    sleep( 1 )

    '///<li>Insert the full path to the package</li>
    kontext "generalfiledialog"
    Dateiname.setText( cFile )
    sleep( 1 )
    
    '///<li>Click the Open-Button</li>
    printlog( "Click the 'Open' button" )
    oeffnen.click()
    
    '///<li>Wait for the package to be added, this may take a few seconds</li>
    printlog( "Importing package, allowing 15 seconds for that" )
    for iWait = 1 to 15 
        try
            ' handle errors such as "package already installed"
            printlog( "Look for any messagebox" )
            kontext "active" 
            if ( active.exists() ) then
                warnlog( "Unexpected Active: " & active.gettext() )
                active.ok()
            endif
            
            ' try to access the treelist. If this works, the dialog has the focus
            printlog( "Walk upwards in the packages-list" )
            kontext "packagemanager"
            BrowsePackages.typeKeys( "<UP>" )
            iWait = 16
            printlog( "Importing package has finished." )
        catch
            printlog( "Importing package: Waiting another second to complete" )
            sleep( 1 )
        endcatch
    next iWait
    
    kontext "packagemanager"
    wait( 100 )
    
    '///<li>check whether the package has been added or not</li>
    printlog( "Select the first node below 'My Macros'" )
    BrowsePackages.TypeKeys( "<RIGHT>" )
    wait( 100 )
    BrowsePackages.TypeKeys( "<DOWN>" )
    wait( 100 )
    
    cPkgName = BrowsePackages.getText() 
    printlog( "Name of the package: " & cPkgName )
    hAddPackage() = cPkgName
    
    ' the package should be enabled by default. if this is not the case,
    ' try to set it enabled and warn. 
    if ( enable.isEnabled() ) then  
        enable.click()
	warnlog( "Apparently the package was installed with the DISABLED " & _
	         "attribute by default. This should not happen" )
    endif
        		 

    
    '///<li>Optional: Close the Package Manager if needed</li>
    if ( bClose ) then
        try
            sleep( 1 )
            kontext "packagemanager"
            
            sleep( 1 )
            kontext "packageManager"
            printlog( "Close the Package Manager" )
            if ( packagemanager.exists() ) then
                packagemanager.close()
                sleep( 2 )
            else
                warnlog( "Focus is NOT on packagemanager" )
            endif
        catch
            warnlog( "Closing packagemanager-UI failed, cannot recover" )
            call exitRestartTheOffice()
        endcatch
    endif
    
    '///</ul>
     
end function

'*******************************************************************************

function hRemovePackageGeneric( cName as string, bDel as boolean)

    ' This function either disables or completely uninstalls a package using the
    ' Package-Manager-UI. bDel = true means the package is to be uninstalled.
    '///<h1>Remove a package using the Package-Manager-UI</h1>
    '///<ul>
    
    dim iPos as integer

    '///<li>Open the Package-Manager UI</li>
    printlog( "Open the Package-Manager-UI" )
    ToolsPackageManager
    
    '///<li>Select the package</li>
    printlog( "Select the the package" )
    kontext "packagemanager"
    hSelectTopNode( BrowsePackages )
    hExpandNode( BrowsePackages , 0 )
    iPos = hSelectNodeByName( BrowsePackages , cName )
    printlog( "******* " & iPos )
    
    '///<li>Disbale or uninstall the package</li>
    '///<li> verify that the node does no longer exist/is disabled</li>
    try
        if ( bDel ) then
            printlog( "Press the remove-button" )
        
            remove.click()
            sleep( 5 )
        
            hSelectNode( BrowsePackages , iPos )
            if ( BrowsePackages.getSelText() <> cName ) then
                printlog( "Package has been removed" )
            else
                warnlog( "Package is still installed" )
            endif

        else
            printlog( "Press the disable-button" )
            disable.click()
            sleep( 1 )
            ' there is currently no way to verify that disabling really worked.
        endif
    catch
        warnlog( "The requested function is unavailable" )
    endcatch
    
    '///<li>Close the Package-Manager-UI</li>
    kontext "packagemanager"
    PackageManager.close()
    
    '///</ul>

end function    

'*******************************************************************************

function hRemovePackage( cName as string )

    ' this function is deprecated. It is only used to remove the first package
    ' listed in the user-section of the package manager. 

    'set kontext to the PackageManager

    kontext "packagemanager"
    'enter the treelistbox to select the package which shall be removed
    BrowsePackages.select(1)
    wait( 500 )
    BrowsePackages.typeKeys( "<UP>" )
    wait( 500 )
    BrowsePackages.typeKeys( "<RIGHT>" )
    wait( 500 )
    BrowsePackages.typeKeys( "<DOWN>" )
    sleep( 5 )         'the added package should now be selected...
    'removing the package

    if ( BrowsePackages.getText() = cName ) then
        printlog( " * Removing package" )
        remove.click()
    else
        warnlog( "An unknown package is selected for deletion, aborting" )
    endif
    
    sleep( 1 )
    kontext "PackageManager"
    try
        PackageManager.close()
    catch
        warnlog( "Crash when closing PackageManager" )
    endcatch
    
    
end function

    
