'encoding UTF-8  Do not remove or change this line!
'*******************************************************************************
'*
'*  $RCSfile: f_updt_basicorganizer.inc,v $
'*
'*  $Revision: 1.2 $
'*
'*  last change: $Author: jsk $ $Date: 2005/06/15 08:35:44 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/******************************************************************************
'*
'*  owner : joerg.skottke@sun.com
'*
'*  short description : Update test for the Basic Organizer dialog
'*
'*******************************************************************************
'**
' #1 tUpdtBasicOrganizer ' Open the Basic Organizer and all its dialogs
'**
'\******************************************************************************

testcase tUpdtBasicOrganizer

    '///<H1>Open the Basic Organizer and all its dialogs</H1>
    '///<ul>

    '///<li>Open a new document</li>
    printlog( "Open a new document" )
    call hNewDocument()

    '///<li>Open the Basic Macro-Organizer</li>
    printlog( "Open the Basic Macro Organizer" )
    ToolsMacro_uno

    kontext "Makro"
    if ( not makro.exists() ) then
        warnlog( "Macro Organizer is not open, aborting test" )
        call hCloseDocument()
        goto endsub
    else
        printlog( "Successfully opened the MacroOrganizer" )
    endif

    '///<li>Open the Libraries/Modules/Dialogs-Organizer</li>
    kontext "Makro"
    printlog( "Click <Organizer> to open the library/modules organizer" )
    if ( Verwalten.isEnabled() ) then
        Verwalten.click()
    else
        warnlog( "Cannot click the <Organize...> button" )
    endif
    
    ' Try to recover from previous error
    Kontext "TabModule"
    if ( not TabModule.exists() ) then
        printlog( "TabModule is not open, the test cannot continue" )
        kontext "Makro"
        Makro.cancel()
        call hCloseDocument()
        goto endsub
    endif
        
    '///<li>Open all dialogs on the Modules-Page</li>
    kontext 
    active.setPage TabModule

    kontext "TabModule"
    printlog( "Modules Tab" )
    call DialogTest( TabModule )

    Modulliste.typeKeys( "<HOME>" )
    try
        printlog( "New Modules-dialog" )
        NeuesModul.click()
        kontext "NeuesModul"
        call DialogTest( NeuesModul )
        NeuesModul.cancel()
    catch
        warnlog( "There is a problem accessing the NewModule-dialog" )
    endcatch

    '///<li>Open all dialogs on the Dialogs-Page</li>
    kontext
    active.setPage( TabDialogs )

    Kontext "TabDialogs"
    printlog( "Dialogs Tab" )
    call DialogTest( TabDialogs )

    ModuleList.typeKeys( "<HOME>" )

    try
        printlog( "New Libraries-dialog" )
        NewDialog.click()
        kontext "NeuerDialog"
        call DialogTest( NeuerDialog )
        NeuerDialog.cancel()
    catch
        warnlog( "There is a problem accessing the NewModule-dialog" )
    endcatch

    '///<li>Open all dialogs on the Libraries-Page</li>
    Kontext
    active.setPage( TabBibliotheken )

    Kontext "TabBibliotheken"
    printlog( "Libraries Tab" )
    call DialogTest( TabBibliotheken )

    Bibliotheksliste.typeKeys( "<HOME>" )

    kontext "TabBibliotheken" 

    try
        printlog( "New Library dialog" )
        Neu.click()
        kontext "NeueBibliothek"
        call DialogTest( NeueBibliothek )
        NeueBibliothek.ok()
    catch
        warnlog( "There is a problem accessing the New Libraries dialog" )
    endcatch

    kontext "TabBibliotheken" 

    try
        printlog( "Password-Dialog" )
        passwort.click()
        kontext "PasswdDlg"
        PasswdDlg.cancel()
    catch
        warnlog( "There is a problem accessing the Passwords-dialog" )
    endcatch

    kontext "TabBibliotheken" 
    
    try
        printlog( "Delete" )
        Loeschen.click()
        Kontext "Active"
        Active.yes()
    catch
        warnlog( "Could not delete the library" )
    endcatch
    
    Kontext "TabBibliotheken"

    try
        printlog( "Append a new library" )
        Hinzufuegen.click()
        kontext "OeffnenDlg"
        call DialogTest( OeffnenDlg )
        OeffnenDlg.cancel()
    catch
        warnlog( "There is a problem appending a new library" )
    endcatch

    Kontext "TabBibliotheken"

    '///<li>Close the Library/Modules/Dialogs-Organizer</li>
    printlog( "Cancel library/modules/dialogs organizer" )
    TabBibliotheken.cancel()

    '///<li>Close the Macro-Organizer</li>
    printlog( "Cancel Macro Organizer" )
    Kontext "Makro"
    Makro.cancel()
    
    '///<li>Close the document</li>
    printlog( "Close the document" )
    call hCloseDocument()

    '///</ul>

endcase

