'encoding UTF-8  Do not remove or change this line!
'*******************************************************************************
'*
'*  $RCSfile: f_updt_namescheck.inc,v $
'*
'*  $Revision: 1.2 $
'*
'*  last change: $Author: jsk $ $Date: 2004/11/29 15:02:06 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): ______________________________________'*
'*
'/******************************************************************************
'*
'*  owner : joerg.skottke@sun.com
'*
'*  short description : Compare the names of templates and samples with a reference list
'*
'*******************************************************************************
'**
' #1 tNamesCheck ' Compare the names of templates and samples with a reference list
'**
'\******************************************************************************



testcase tNamesCheck( cCategory )

    dim iObjectFolder as Integer   ' the current folder in loops
    dim iObjectFolders as integer  ' the number of template/sample-folders
    dim iObject as Integer         ' the current template/sample within loops
    dim iObjectCount( 20 ) as integer  ' number of templates/samples in the folders
    dim cObjectName as string      ' the name of the current object (e.g. Template)
    dim cObjectNameList( 200 ) as string ' List of object names
    dim cReferenceList( 200 ) as string  ' Reference list of object names
    dim cFolder as string   ' name of a folder (req. for reference list)
    dim cRefFile as string  ' Name and location of the reference file
    
    printlog( "" )
    printlog( "Category: " & cCategory )
    printlog( "" )
    
    '///<h3>Show documents in the preview pane of the teplates-dialog</h3>
    '///<ul>
    '///<li>Open File->New->Templates and documents</li>
    FileNewFromTemplate

    kontext "active"
    if ( active.exists( 2 ) ) then
        warnlog( "Unexpected messagebox: " & active.gettext() )
        active.ok()
        sleep( 2 )
    end if

    ' select the requested category
    hSelectCategory( cCategory )
    ' get the number of FOLDERS in the category (not for NEWDOCUMENTS)
    ' For "NEWDOCUMENTS" the number of folders is 1, set directly below "else"

    if ( cCategory <> "NEWDOCUMENTS" ) then
        iObjectFolders = FileList.getItemCount()

        for iObject = 1 to iObjectFolders
            hSelectFileFolder( iObject , true )
            iObjectCount( iObject ) = FileList.getItemCount()
            UpOneLevel.click()
        next iObject

    else
        iObject = 1
        iObjectCount( iObject ) = FileList.getItemCount()
        iObjectFolders = 1
    endif

    kontext "templateanddocuments"
    '///<li>Step through all folders and templates/samples</li>

    for iObjectFolder = 1 to iObjectFolders
    
        '///<ol>
        '///<li>Select the category (samples, templates ...)</li>
	
        hSelectCategory( cCategory )
	
        '///<li>Select the current folder</li>
        ' select a folder to look in. for NEWDOCUMENTS we are already there so
        ' this stepped is skipped.

        if ( cCategory <> "NEWDOCUMENTS" ) then
            cFolder = hGetFileFolderName( iObjectFolder )
            hSelectFileFolder( iObjectFolder , false )
        end if

        ' Now run through all objects in the filelist, get the names for each one

        for iObject = 1 to iObjectCount( iObjectFolder )
            '///<li>Select the desired template</li>
            cObjectName = cFolder & ":" & hSelectDocumentObject( iObject , 0 )
            listappend( cObjectNameList() , cObjectName )
            wait( 100 )
            '///<li>Next document</li>
        next iObject

        '///</ol>
    next iObjectFolder

    '///</ul>

    kontext "templateanddocuments"
    TemplateAndDocuments.cancel()
    
    ' get the path to the reference file.
    cRefFile = hGetRefFilePath( cCategory , "TESTTOOL" )
    
    ' check if the reference file exists, if not: Warn and create them LOCALLY
    if ( app.dir( cRefFile ) <> "" ) then
    
        ' read the reference list
        listread( cReferenceList() , cRefFile , "UTF8" )
	
        ' compare the current list to the reference and complain about differences
        printlog( "" )
        printlog( " * Comparing lists ..." )
        printlog( "" )
        gCompare2Lists( cObjectNameList() , cReferenceList() )
    else
    
        ' we end here in case that the file has not been found
        warnlog( "The reference list (" & cRefFile & ") could not be found." )
	
        ' Change the output path to the local work directory, assuming it exists
        cRefFile = hGetRefFilePath( cCategory , "LOCAL" )
	
        ' write the reference list
        listwrite( cObjectNameList() , cRefFile , "UTF8" )
	
        ' warn again and give instructions on how to proceed (manual action req.)
        warnlog( "The file has been written to the local workdirectory." )
        printlog( "Please verify the content and copy it to " & hGetRefFilePath( cCategory , "TESTTOOL" )
    end if

endcase

'*******************************************************************************
