'encoding UTF-8  Do not remove or change this line!
'*******************************************************************************
'*
'*  $RCSfile: f_updt_pkgmgr.inc,v $
'*
'*  $Revision: 1.7 $
'*
'*  last change: $Author: jsk $ $Date: 2005/03/14 10:27:49 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): ______________________________________
'*
'*
'/******************************************************************************
'*
'* owner : joerg.skottke@sun.com
'*
'* short description :
'*
'*******************************************************************************
' **
' #1 tUpdt_packagemanager         'update test for the package manager
' **
'\******************************************************************************



testcase tUpdt_packagemanager

    '///<h3>add, disable, re-enable, export and remove the specified package</h3>
    '///<ul>
    
    dim sPackage as String
        sPackage = "framework\update\input\basic\Basic_Addon.zip"
        sPackage = convertpath( gTesttoolpath & sPackage )
        
    printlog( "" )
    printlog( "add, disable, re-enable, export and remove a Package" )
    printlog( "" )
    
    '///<li>Open the Package-Manager-UI</li>
    ToolsPackageManager
    call dialogtest( PackageManager )
    
    '///<li>Add a Package</li>
    '///<li>Check if the package is liste in the treelist</li>
    hAddPackage( sPackage )
    
    '///<li>Check if disable/enable of the Package works</li>
    checkEnableDisable()
    
    '///<li>Browse through the package to see if all components are present:</li>
    '///<ul>
    '///<li>Addons.xcu</li>
    '///<li>MyLib</li>
    '///</ul>
    browsePackage()
    
    '///<li>Export the package to a new name and delete the exported package</li>
    exportPackage()
    
    '///<li>Remove the Package from the Treelist in the Package-Manager-UI</li>
    '///<li>Close the Package-Manager-UI</li>
    hRemovePackage( "Basic_Addon.zip" )
    
    '///</ul>

endcase

'*******************************************************************************

sub checkEnableDisable

    printlog( " * Checking if disabling and enabling a package works")
    'set kontext to PackageManager

    kontext "packagemanager"
    'check, if the installed package is not enabled ==> it should be enabled!

    if ( enable.isEnabled() and not disable.isEnabled() ) then
        'in this case the installed package is not enabled!
        warnlog( "UI does not reflect the expected package status" )
    endif

    'disable the package
    Disable.click()
    sleep(4)
    'check if disabling worked: ==> Enable should be active,
    '                               Disable should be inactive

    if ( enable.isEnabled() and not disable.isEnabled() ) then
        'in this case the package is disabled
        printlog( "   * Disabling the package..." )
    else
        warnlog( "Disable is inactive -> the package cannot be disabled" )
    endif

    're-enable the package
    Enable.click()
    sleep(4)
    'check if re-enabling worked: ==> Enable should be inactive,
    '                                 Disable should be active

    if ( disable.isEnabled() and not enable.isEnabled() ) then
        'in this case the package is enabled
        printlog( "   * Enabling the package..." )
    else
        warnlog( "Enable is inactive -> the package cannot be enabled" )
    endif

end sub

'*******************************************************************************

sub browsePackage

    printlog( " * Browse through the package")
    'set kontext to PackageManager

    kontext "packagemanager"
    'select the first entry in that package: It should be "Addons.xcu"
    BrowsePackages.typeKeys( "<RIGHT>" )
    wait( 500 )
    BrowsePackages.typeKeys( "<DOWN>" )
    wait( 500 )
    'check if the selected entry is "Addons.xcu"

    if ( BrowsePackages.getText() <> "Addons.xcu" ) then
        'in this case the first entry is wrong!
        warnlog( "Incorrect Package or package not imported" )
    else
        'in this case adding workde as expected
        printlog( "   * Addons.xcu  successfully added" )
    endif

    'select the second entry: it should be "MyLib"
    BrowsePackages.typeKeys( "<DOWN>" )
    wait( 500 )
    'check if the selected entry is "MyLib"

    if ( BrowsePackages.getText() <> "MyLib" ) then
        warnlog( "Incorrect Package or package not imported" )
    else
        printlog( "   * MyLib successfully added" )
    endif

end sub

'*******************************************************************************

sub exportPackage

    dim sOutPath as string
    dim iFileCount as integer          ' Count of ListItems
    dim iCurrentFile as integer        ' "running" variable starting with 1
    printlog( " * Try to export a package")
    'set kontext to PackageManager

    kontext "packagemanager"
    'select the Package itself...
    BrowsePackages.typeKeys( "<UP>" )
    wait( 500 )
    BrowsePackages.typeKeys( "<UP>" )
    wait( 500 )
    'export the package
    Export.click()
    sleep(2)

    kontext "speicherndlg"
    sOutPath = convertpath( gOfficePath & "user\work\AddOns.zip" )
    Dateiname.setText( sOutPath )
    sleep(2)
    printlog( "   * Exporting package" )
    Speichern.click()
    printlog( "   * Exporting package   ok" )

    kontext "active"

    if ( active.exists( 1 ) ) then
        warnlog( "Unexpected Active: " & active.gettext() )

        try
            active.yes()
        catch
            Active.ok()

            kontext "speicherndlg"
            SpeichernDlg.cancel()
        endcatch

    endif

    sleep(2)
    printlog( " * Try to delete the exported package")
    'delete the exported package
    'set kontext to PackageManager

    kontext "packagemanager"
    Export.click()
    sleep(2)
    'search the file to delete
    'use the export dialog to find the package and to delete it...

    kontext "speicherndlg"
    DateiAuswahl.select(1)
    iCurrentFile  = 1
    iFileCount = DateiAuswahl.getItemCount()
    DateiAuswahl.typekeys( "<UP>" )
    wait(500)

    while (DateiAuswahl.getText <> "AddOns.zip" and iCurrentFile <= iFileCount)
        DateiAuswahl.typekeys( "<DOWN>" )
        iCurrentFile = iCurrentFile + 1
        sleep(1)
    wend          'End of while...

    'delete the file AddOns.zip

    if (DateiAuswahl.getText = "AddOns.zip") then
        DateiAuswahl.typekeys( "<DELETE>" )

        kontext "confirmdelete"
        'a messagbox appears, click <DELETE> to delete the file
        Delete.click()
        sleep(3)
    else
        warnlog( " * Deleting exported package: File could not be found!!" )
    endif

    Kontext "SpeichernDlg"
    SpeichernDlg.cancel()
    ' TODO at some point we should make sure the file AddOns.zip is really deleted.

end sub

