'encoding UTF-8  Do not remove or change this line!
'*******************************************************************************
'*
'*  $RCSfile: f_updt_standardbar4.inc,v $
'*
'*  $Revision: 1.4 $
'*
'*  last change: $Author: jsk $ $Date: 2005/04/15 09:03:35 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/******************************************************************************
'*
'*  owner : joerg.skottke@sun.com
'*
'*  short description : invisible items on the standardbar
'*
'*******************************************************************************
'**
' #1 tStandardBar_4 ' invisible items on the standardbar
'**
'\******************************************************************************

testcase tStandardBar_4

    '///<h3>Count all items and activate the hidden items for Standardbar</h3>
    '///<ul>
   
    '///<li>reset the Standardbar to defaults. The toolbar should be docked</li>
    call StandardbarResetNow()
    
    '///<li>Check the number of items for the standarbar using the list in customize toolbars (30)</li>
    hStandardbarItemGetCount()
    
    '///</ul>

    '///<h3>Activate the hidden controls</h3>
    
    '///<ul>
    '///<li>Load URL: check absence, toggle it, check presence, remove it</li>
    hStandardbarLoadUrl()
    
    '///<li>New from Template: check absence, toggle it, use it, remove it</li>
    hStandardbarNewDialog()
    
    '///<li>Save As: check absence, toggle it, use it, remove it</li>
    hStandardbarSaveAs()
    
    '///</ul>
    call hCloseDocument()

        
endcase

'*******************************************************************************

function hStandardbarItemGetCount()

    dim iCounter as integer

    'open a new writer document
    gApplication = "Writer"
    call hNewDocument()
    
    printlog "Count all items and activate the hidden items:"

    'check the number of entries ( must be 30 )
    printlog " - count all items at the Standardbar"

    'open the context menu on the Standardbar
    Kontext "Standardbar"
    Standardbar.OpenContextmenu()

    'select the 1. entry
    hMenuselectNr( 1 )
    sleep (1)

    'count all entries ( there must be 23 entries )
    iCounter = 0
    iCounter = hMenuItemGetCount()
   
    if ( iCounter <> 30 ) then
        warnlog( "Expected: 30 entries at the Standardbar, found: " & iCounter )
    endif

    'close the context menu
    hMenuClose()
    sleep (1)
    
    ' close the document
    call hCloseDocument()
    
end function

'*******************************************************************************

function hToggleToolbarItem( iMenuPos as integer )

    ' this tiny function just adds or removes a control to/from the standardbar
    
    dim iItemsInMenu as integer

    Kontext "Standardbar"
    Standardbar.OpenContextmenu()
    iItemsInMenu = hMenuItemGetCount()
    
    ' in case the toolbar does not fit into the window we have more items
    ' (those that are invisible will be listed as context menu entries),
    ' the menuitem (invisible items) is placed at position nItems - 2
    hMenuselectNr( iItemsInMenu - 2 )
    sleep( 1 )
    
    hMenuselectNr( iMenuPos )        
    sleep( 1 )

end function

'*******************************************************************************

function hStandardbarLoadUrl() as boolean

    ' this function tries to write to the url-EntryField. This should fail,
    ' because the item is not visible. Then the item should be enabled,
    ' written to and disabled again (no use of reset toolbar here, this is
    ' done in another testcase
    
    dim iItemMenuPos as integer
    iItemMenuPos = 1
    
    printlog( "Load URL" )

    ' try to modify non existing object, if this fails, activate it
    try
        Kontext "Standardbar"
        URLEingabe.settext( "Should not work" )
        warnlog( "The Load URL EntryField is visible and active" )
    catch
        printlog( " - The Load URL EntryField is not visible. Good." )
    endcatch
    
    ' add the control to the standardbar
    printlog( " - activate load URL" )
    hToggleToolbarItem( iItemMenuPos )
    Kontext "Standardbar"
    
    ' verify its existence by entering some text
    try
        URLEingabe.settext( "Should work" )
        printlog( " - The Load URL REntryFiled is visible and active. Good." )
    catch
        warnlog( "Could not write to 'load url' control" )
    endcatch
        
    ' remove the control from the standardbar
    printlog( " - deactivate load URL" )
    hToggleToolbarItem( iItemMenuPos )
    Kontext "Standardbar"
    
    ' try to modify non existing object, failure expected
    try
        Kontext "Standardbar"
        URLEingabe.settext( "Should not work" )
        warnlog( "The Load URL EntryField is visible and active" )
    catch 
        printlog( " - The Load URL EntryField is not visible. Good." )
    endcatch
    
end function

'*******************************************************************************

function hStandardbarNewDialog()

    dim iItemMenuPos as integer
    iItemMenuPos = 3

    printlog( "New from Template" )

    ' trial and error: clicking this item should fail
    try
        NeuDialog.Click()
        sleep( 3 )
        warnlog( "The 'New from Template'-button should not be visible by default." )
    catch
        printlog( " - the control is not present or active." )
    endcatch
    
    ' add the control to the standardbar
    printlog( " - activate New from Template button" )
    hToggleToolbarItem( iItemMenuPos )
    Kontext "Standardbar"

    ' click the button
    NeuDialog.click()    
    
    ' handle possible dialogs (there should never be one)
    kontext "Active"
    if ( active.exists() ) then
        warnlog( "Unexpected active" )
        printlog( active.gettext() )
        try
            printlog( "Closing dialog" )
            active.ok()
        catch
        endcatch
    endif

    ' close the templates and samples dialog
    printlog( " - close templates and samples (cancel)" )
    Kontext "TemplateAndDocuments"
    if ( TemplateAndDocuments.Exists( 5 ) ) then
        TemplateAndDocuments.cancel()
    else
        warnlog( "The 'Template and Documents'-dialog was not activated" )
    endif
   
    ' finally remove the button from the toolbar
    printlog( " - deactivate New from Template button" )
    hToggleToolbarItem( iItemMenuPos )
    Kontext "Standardbar"
    
end function

'*******************************************************************************

function hStandardbarSaveAs()

    ' this function deactivates the save-as button, makes sure the button is
    ' disabled, activates it again and clicks on it ti see whether the dialog
    ' comes up or not. NOTE: With src680 this button is visible on the toolbar
    ' by default.

    dim bBreakOnError as boolean
    dim iItemMenuPos as integer
    iItemMenuPos = 6


    printlog( "Save As" )

    ' trial and error: clicking on this button should fail. A minimal error-
    ' handling is done as well though it will most likely fail
    
    try
        SpeichernAls.Click()
        sleep( 3 )
        warnlog( "#i46363# (?)The 'SaveAs'-button should be invisible but is displayed" )
        sleep( 2 )
        kontext "SpeichernDlg"
        SpeichernDlg.cancel()
        bBreakOnError = true
    catch
        printlog( " - the control is not present or active." )
        bBreakOnError = false
    endcatch
    
    ' only do this if the button is indeed disabled
    if ( not bBreakOnError ) then
    
        ' add the control to the standardbar
        printlog( " - activate 'Save As' button" )
        hToggleToolbarItem( iItemMenuPos )
        Kontext "Standardbar"

        ' click the button
        SpeichernAls.click()    
    
        ' close the save-as dialog
        printlog( " - close Save As (cancel)" )
        Kontext "SpeichernDlg"
        if ( SpeichernDlg.Exists( 5 ) ) then
            SpeichernDlg.cancel()
        else
            warnlog( "The 'Save As'-dialog was not activated" )
        endif
        
    endif
   
    ' remove the button from the toolbar
    printlog( " - deactivate 'Save as' button" )
    hToggleToolbarItem( iItemMenuPos )
    Kontext "Standardbar"
    
end function    
