'encoding UTF-8  Do not remove or change this line!
'*******************************************************************************
'*
'*  $RCSfile: f_updt_windowfuncs.inc,v $
'*
'*  $Revision: 1.6 $
'*
'*  last change: $Author: jsk $ $Date: 2005/04/14 13:54:38 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/******************************************************************************
'*
'*  owner : joerg.skottke@sun.com
'*
'*  short description : Window/Titlebar functionality
'*
'*******************************************************************************
'**
' #1 tWindowFunctions ' Window/Titlebar functionality
' #0 sAllWindowTitle  ' Control program for tCheckWindowTitle
' #1 tCheckWindowTitle ' Checks window titles
'**
'\******************************************************************************


testcase tWindowFunctions

    '///<h1>Verify the basic window-functionality works</h1>
    '///<ul>
    printlog( "New document" )
    call hNewDocument()

    if ( getDocumentCount() <> 2 ) then
        warnlog( "Two open documents were expected, found " & getDocumentCount() )
    endif


    kontext "documentwriter"
    printlog( "Close document" )
    DocumentWriter.close()

    if ( getDocumentCount() <> 1 ) then
        warnlog( "One open document was expected, found " & getDocumentCount() )
    endif

    printlog( "New document" )
    call hNewDocument()

    if ( getDocumentCount() <> 2 ) then
        warnlog( "Two open documents were expected, found " & getDocumentCount() )
    endif


    kontext "documentwriter"
    DocumentWriter.TypeKeys( "test" )
    DocumentWriter.close()

    kontext "active"

    if ( Active.exists() ) then
        Active.Cancel()
        printlog( "Overwrite warning is displayed. Good" )
    else
        warnlog( "No warning that data will be lost on close of this document" )
    endif

    call hCloseDocument()

    if ( getDocumentCount() <> 1 ) then
        warnlog( "One open document was expected, found " & getDocumentCount() )
    endif

    call hNewDocument()

    if ( getDocumentCount() <> 2 ) then
        warnlog( "Two open documents were expected, found " & getDocumentCount() )
    endif


    kontext "documentwriter"
    '///<li>Maximize Window</li>
    printlog( "Maximize window" )
    DocumentWriter.Maximize()
    sleep( 2 )
    

    if ( DocumentWriter.IsMax() ) then
        printlog( " * Window is maximized" )
    else
        warnlog( " * Window not maximized" )
    endif


    if ( DocumentWriter.IsMin() ) then
        warnlog( " * Window is minimized" )
    else
        printlog( " * Window not minimized" )
    endif


    if ( DocumentWriter.IsRestore() ) then
        warnlog( " * Window is Restored" )
    else
        printlog( " * Window not Restored" )
    endif

    '///<li>Minimize Window</li>
    printlog( "Minimize window" )
    DocumentWriter.Minimize()
    sleep( 2 )

    if ( DocumentWriter.IsMin() ) then
        printlog( " * Window is minimized" )
    else
        qaerrorlog( "#i32672# Window not minimized" )
    endif


    if ( DocumentWriter.IsMax() ) then
        warnlog( " * Window is maximized" )
    else
        printlog( " * Window not maximized" )
    endif


    if ( DocumentWriter.IsRestore() ) then
        qaerrorlog( "#i32672# Window is Restored" )
    else
        printlog( " * Window not Restored" )
    endif

    '///<li>Restore Window</li>
    printlog( "Restore window" )
    DocumentWriter.Restore()
    sleep( 2 )

    if ( DocumentWriter.IsRestore() ) then
        printlog( " * Window is Restored" )
    else
        warnlog( " * Window not Restored" )
    endif


    if ( DocumentWriter.IsMax() ) then
        warnlog( " * Window is maximized" )
    else
        printlog( " * Window not maximized" )
    endif


    if ( DocumentWriter.IsMin() ) then
        warnlog( " * Window is minimized" )
    else
        printlog( " * Window not minimized" )
    endif

    call hCloseDocument()

    if ( getDocumentCount() <> 1 ) then
        warnlog( "One open document was expected, found " & getDocumentCount() )
    endif
    
    '///</ul>

endcase

'*******************************************************************************

sub sAllWindowTitle

    ' go through all available applications
    gApplication = "WRITER"
    call tCheckWindowTitle("swriter","Writer")

    gApplication = "MASTERDOC"
    call tCheckWindowTitle("sglobal","Writer")

    gApplication = "HTMLDOKUMENT"
    call tCheckWindowTitle("sweb","Writer/Web")

    gApplication = "CALC"
    call tCheckWindowTitle("scalc","Calc")

    gApplication = "IMPRESS"
    call tCheckWindowTitle("simpress","Impress")

    gApplication = "DRAW"
    call tCheckWindowTitle("sdraw","Draw")

    gApplication = "MATH"
    call tCheckWindowTitle("smath","Math")

    qaerrorlog( "Excluded BASE and BACKINGWINDOW" )

    'gApplication = "INSIGHT"
    'call tCheckWindowTitle("insight","Base")

    'fileclose
    'call tCheckWindowTitle("soffice","")
end sub

'*******************************************************************************

testcase tCheckWindowTitle(sApplication as string, sReference as string)

    dim sTemp as string
    dim saTemp() as string
    gApplication = UCase (gApplication)
    printlog " - Application: " + sApplication + "; Title should be: " + sReference
    call hNewDocument()

    select case sApplication
        case"swriter":
        case"sglobal":
        case"sweb":
        case"scalc":
        case"simpress":
        case"sdraw":
        case"smath":
        case"basic":
            ToolsMacroMacro

            kontext "makro"

            if Makro.exists(5) then
                MakroAus.typeKeys "<end>"

                if (Neu.isEnabled) then
                    Neu.click

                    kontext "basicide"

                    if BasicIDE.exists(5) then
                        ' OK :-) here we want to stay
                        printlog "OK :-)"
                    else
                        ' qaErrorlog "Unexpected 2"
                    endif

                else
                    qaErrorlog "Unexpected 1"
                endif


                try

                    kontext "neuesmodul"

                    if NeuesModul.exists(5) then
                        NeuesModul.OK
                    else
                        qaErrorlog "Unexpected 3"
                    endif

                catch
                endcatch

            else
                qaErrorlog "Couldn't open Tools->Macros->Organize Macros...->StarOffice Basic..."
            endif

        case"chart":
        case"insight":
        case"soffice":
            call hCloseDocument()
    end select

    '    sTemp = hWindowGetText("")   ' was a wOrkAround until the next line worked
    sTemp = hGetWindowCaption(sApplication)
    '    printlog sTemp
    ' seperate each part of the title
    saTemp() = fSplitWindowTitle(sTemp)
    printlog "Filename/Untitled: '" + saTemp(0) + "'"

    if (ubound(saTemp()) > 0) then

        if (saTemp(1) <> sReference) then
            warnlog "Applicationname not as expected. Sould be: '" + sReference + "', is: '" + saTemp(1) + "'"
        endif

        printlog "Productname: '" + saTemp(2) + "'"
    else
        warnlog "#i36173# - Applicationname not as expected. Should be: '" + sReference + "', is: '"+"'"
    endif


    select case sApplication
        case"swriter":
        case"sglobal":
        case"sweb":
        case"scalc":
        case"simpress":
        case"sdraw":
        case"smath":
        case"basic":
            call hCloseDocument()
        case"chart":
        case"insight":
        case"soffice":
            call hNewDocument()
            call hNewDocument()
    end select

    call hCloseDocument()
endcase

'*******************************************************************************
