'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  $RCSfile: iniinfo.inc,v $
'*
'*  $Revision: 1.41 $
'*
'*  last change: $Author: jsi $ $Date: 2005/07/29 04:25:20 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/***********************************************************************
'*
'* owner : joerg.sievers@sun.com
'*
'* short description : get information for startup a test out of important ini-files
'*
'************************************************************************
' **
' #1 GetIniInformation          ' Set all important variables
' #1 GetOfficeInformation       '
' #1 ConvertPathSigne           '
' #1 ConvertPath                '
' #0 hDecode2                   '
' #1 GetLanguageInformation     '
' #1 ConvertLanguage            '
' #1 ConvertLanguage2           '
' #1 GetLanguageText            '
' #1 ConvertCodeToLanguage      '
' #1 GetTheInstallationType     '
' #1 GetItForMe                 '
' #1 FileURLToNormalFile        '
' #1 ReplaceCharacter           ' Replace a character with another
' #1 fgetL10Nvalue              '
' #1 sGetCrashreporterValues    ' Reading the crashreporter relevant values from testtool control file.
' #1 getSofficeNative
' #1 getSofficeSversion
' #1 getSofficeTesttool
' **
'\***********************************************************************

sub GetIniInformation
    '/// Set all important variables.
    '/// Some of them are get only out of the </i>testtool.ini</i>.
    '/// <b>gPathSigne</b>: Pathsign for the OfficePLatform Operating System
    '/// <b>gPort</b>: Portnummer for communication between testtool and StarOffice
    '/// <b>gSystemPath</b>: Systempath from where StarOffice executes.
    '/// <b>gOfficePath</b>: Path where StarOffice is installed.
    '/// <b>gTesttoolPath</b>: Root directory from the <i>TestTool environment</i>.
    '/// <b>oTesttoolPath</b>: Root directory from the <i>TestTool environment</i> (<u>Windows styleed only!</u>)
    '/// <b>gClient</b>: <b>1</b> when you run a Server/Client-Test (Sun&trade; ONE Webtop)
    '/// <b>gClientLaden</b>: <b>0</b> if Load/Save on Client-side, otherwise on Server-side (<u>UNIX only!</u>)
    '/// <b>gNetzInst</b>: <b>1</b> if you test a network- / workstation installaion.
    dim sSoffice(3) as string ' array, because they might all get evaluated sometime
    dim bOOo(3) as string
    dim iSoffice(3) as integer
    
    gPathSigne = hGetPathSigne(gPLatform)

    gTTProfileName = hfGetTTProfileName()
    gSystemPath = gtSystemPath
    oTesttoolPath = GetIniValue ( gTesttoolIni, gTTProfileName, "BaseDir" )
    if (right(oTesttoolPath,1) <> gPathSigne) then
        oTesttoolPath = oTesttoolPath + gPathSigne
    endif
    gTesttoolPath = oTesttoolPath
    if gSamePC = FALSE then
        gOfficePath = GetIniValue ( gTesttoolIni, "Office IniPath", "Current" ) + gPathSigne
        gRemotePath = GetIniValue ( gTesttoolIni, "RemoteBaseDir", "Current" ) + gPathSigne
    else
    ' The part of getting the location of the executable OOo is put into seperated functions.
        ' The first OOo executeable is used.
        ' 1. Entry in .testtoolrc/.ini
        ' 2. Entry in Win32-registry or either link exist: /usr/bin/soffice - $HOME/soffice (aka Native Installer (OOo > SRC680m49))
        ' 3. Entry in .sversionrc/.ini (OOo < SRC680m50)
        sSoffice(0) = getSofficeTesttool() : bOOO(0) = gOOO
        printlog "RESULT from TestTool: '" + sSoffice(0) + "' - OOo? " + bOOO(0)
        if (sSoffice(0) = "") then
            sSoffice(0) = getSofficeNative()   : bOOO(0) = gOOO
            if (sSoffice(0) <> "") then
                gOfficePath = sSoffice(0)
                gVersionsnummer = FindBuildID() 
                call hSetBuildVersionInformation(TRUE)
                iSoffice(0) = gBuild
            endif
            printlog "RESULT from Native  : '" + sSoffice(0) + "' - OOo? " + bOOO(0) + " - BuildID: " + iSoffice(0)
            if ((sSoffice(0) = "") OR (iSoffice(0) < 8800)) then
                sSoffice(0) = getSofficeSversion() : bOOO(0) = gOOO
                if (sSoffice(0) <> "") then
                    gOfficePath = sSoffice(0)
                    gVersionsnummer = FindBuildID() 
                    hSetBuildVersionInformation(TRUE)
                    iSoffice(0) = gBuild
                endif
                printlog "RESULT from Sversion: '" + sSoffice(0) + "' - OOo? " + bOOO(0) + " - BuildID: " + iSoffice(0)
                if (sSoffice(0) = "") then
                    warnlog "No OOo version found on this computer."
                endif
            endif
        endif
        gOfficePath = sSoffice(0)
        gOOO = bOOO(0)
    endif
   if ((gSamePC = TRUE) AND (gOfficePath = "")) then
        MsgBox ("The test ends, because no OOo version was found on this computer.", 1, "No OOo program installed")
        end
   endif

   gtHidLstPath =  GetIniValue ( gTesttoolIni, gTTProfileName, "HIDDir" ) + hGetPathSigne(gtPlatform)
   gPort = GetIniValue ( gTesttoolIni, "Communication", "TTPort" )
   '--------
   gPCName = environ ( "hostname" )
   if gPCName = "" then 
        gPCName = GetIniValue ( gTesttoolIni, "Others", "PCname" )
   endif
   '--------

   call GetTheInstallationType            ' gNetzInst and gNetzOfficePath will be set if StarOffice is a Network-Installation
end sub

'-------------------------------------------------------------------------

sub GetOfficeInformation
'/// Generates the path to the StarOffice executable.
'/// <u>Output</u>: <b>sAppExe</b> variable is the StarOffice executable or the client executable (StarOffice server, StarPortal&trade;, Sun&trade; ONE Webtop, ...)
   Dim sProgramNeu as String
   Dim iClient as Integer
      'if it's a client on the same PC
      if gClient = TRUE AND gClientUser <> "" then
         if gtPlatform <> "w95" AND gtPlatform <> "wnt" AND gPlatform <> "w2k" AND gtPlatform <> "os2" AND gtPlatform <> "os4" then
            sAppExe = gsClient + "/bin/sclient"
         else
            if right( lcase ( sAppExe ), 3 ) <> "exe" then sAppExe = gsClient + "\sclient.exe"
         endif
         sAppParameter = " -remote -connect=portal,service=soffice,host=" + gHost + ",port=8208,user=" + gClientUser + ",password=" + gClientUserPWD + ",type=compressed_secure"
      else
         if gNetzInst = TRUE then                              ' wenn es sich um eine Netzwerkinstallation handelt
            if gPlatGroup <> "unx" then
               select case UCase(gApplication)
                  case "WRITER",  "TEXTDOKUMENT"    : sAppExe = gNetzOfficePath + "program\soffice.exe" : sFactory = "-writer"
                  case "CALC", "TABELLENDOKUMENT"   : sAppExe = gNetzOfficePath + "program\soffice.exe" : sFactory = "-calc"
                  case "IMPRESS", "PRAESENTATION"   : sAppExe = gNetzOfficePath + "program\soffice.exe" : sFactory = "private:factory/simpress"
                  case "DRAW", "ZEICHNUNG"          : sAppExe = gNetzOfficePath + "program\soffice.exe" : sFactory = "-draw"
                  case "GLOBALDOC", "GLOBALDOKUMENT": sAppExe = gNetzOfficePath + "program\soffice.exe" : sFactory = "-global"
                  case "MATH", "FORMEL"             : sAppExe = gNetzOfficePath + "program\soffice.exe" : sFactory = "-math"
                  case "HTML", "HTMLDOKUMENT"       : sAppExe = gNetzOfficePath + "program\soffice.exe" : sFactory = "-web"
                  case "ETIKETTEN", "LABLE"         : sAppExe = gNetzOfficePath + "program\soffice.exe" : sFactory = "-writer"
                  case "VISITENKARTEN", "CARD"      : sAppExe = gNetzOfficePath + "program\soffice.exe" : sFactory = "-writer"
                  case else : sAppExe = gNetzOfficePath + "program\soffice.exe"
               end select
             else
               select case UCase(gApplication)
                  case "WRITER",  "TEXTDOKUMENT"    : sAppExe = gNetzOfficePath + "program/soffice" : sFactory = "-writer"
                  case "CALC", "TABELLENDOKUMENT"   : sAppExe = gNetzOfficePath + "program/soffice" : sFactory = "-calc"
                  case "IMPRESS", "PRAESENTATION"   : sAppExe = gNetzOfficePath + "program/soffice" : sFactory = "private:factory/simpress"
                  case "DRAW", "ZEICHNUNG"          : sAppExe = gNetzOfficePath + "program/soffice" : sFactory = "-draw"
                  case "GLOBALDOC", "GLOBALDOKUMENT": sAppExe = gNetzOfficePath + "program/soffice" : sFactory = "-global"
                  case "MATH", "FORMEL"             : sAppExe = gNetzOfficePath + "program/soffice" : sFactory = "-math"
                  case "HTML", "HTMLDOKUMENT"       : sAppExe = gNetzOfficePath + "program/soffice" : sFactory = "-web"
                  case "ETIKETTEN", "LABLE"         : sAppExe = gNetzOfficePath + "program/soffice" : sFactory = "-writer"
                  case "VISITENKARTEN", "CARD"      : sAppExe = gNetzOfficePath + "program/soffice" : sFactory = "-writer"
                  case else : sAppExe = gNetzOfficePath + "program/soffice"
               end select
            endif
         'If it's a normal (FAT) office
         else
            'If it's a RVP-Office
            if gClient = TRUE then
              if gPlatgroup <> "unx" then
                  sAppExe = gOfficePath + "client\sclient.exe"
               else
                  sAppExe = gOfficePath + "client/sclient"
              endif
            else
              if gPlatgroup <> "unx" then
                  select case UCase(gApplication)
                     case "WRITER",  "TEXTDOKUMENT"    : sAppExe = gOfficePath + "program\soffice.exe" : sFactory = "-writer"
                     case "CALC", "TABELLENDOKUMENT"   : sAppExe = gOfficePath + "program\soffice.exe" : sFactory = "-calc"
                     case "IMPRESS", "PRAESENTATION"   : sAppExe = gOfficePath + "program\soffice.exe" : sFactory = "private:factory/simpress"
                     case "DRAW", "ZEICHNUNG"          : sAppExe = gOfficePath + "program\soffice.exe" : sFactory = "-draw"
                     case "GLOBALDOC", "GLOBALDOKUMENT": sAppExe = gOfficePath + "program\soffice.exe" : sFactory = "-global"
                     case "MATH", "FORMEL"             : sAppExe = gOfficePath + "program\soffice.exe" : sFactory = "-math"
                     case "HTML", "HTMLDOKUMENT"       : sAppExe = gOfficePath + "program\soffice.exe" : sFactory = "-web"
                     case "ETIKETTEN", "LABLE"         : sAppExe = gOfficePath + "program\soffice.exe" : sFactory = "-writer"
                     case "VISITENKARTEN", "CARD"      : sAppExe = gOfficePath + "program\soffice.exe" : sFactory = "-writer"
                     case else : sAppExe = gOfficePath + "program\soffice.exe"
                  end select
               else
               select case UCase(gApplication)
                  case "WRITER",  "TEXTDOKUMENT"    : sAppExe = gOfficePath + "program/soffice" : sFactory = "-writer"
                  case "CALC", "TABELLENDOKUMENT"   : sAppExe = gOfficePath + "program/soffice" : sFactory = "-calc"
                  case "IMPRESS", "PRAESENTATION"   : sAppExe = gOfficePath + "program/soffice" : sFactory = "private:factory/simpress"
                  case "DRAW", "ZEICHNUNG"          : sAppExe = gOfficePath + "program/soffice" : sFactory = "-draw"
                  case "GLOBALDOC", "GLOBALDOKUMENT": sAppExe = gOfficePath + "program/soffice" : sFactory = "-global"
                  case "MATH", "FORMEL"             : sAppExe = gOfficePath + "program/soffice" : sFactory = "-math"
                  case "HTML", "HTMLDOKUMENT"       : sAppExe = gOfficePath + "program/soffice" : sFactory = "-web"
                  case "ETIKETTEN", "LABLE"         : sAppExe = gOfficePath + "program/soffice" : sFactory = "-writer"
                  case "VISITENKARTEN", "CARD"      : sAppExe = gOfficePath + "program/soffice" : sFactory = "-writer"
                  case else : sAppExe = gOfficePath + "program/soffice"
               end select
              endif
            endif
         endif
      endif
end sub

'-------------------------------------------------------------------------

function hGetPathSigne(sPlatform as string) as string
'/// Seperators for the different platforms.
'/// <u>Input</u>: string of class gPlatform
'/// <u>Output</u>: string which can be used as seperator in directories

    select case sPlatform
        case "w95" : hGetPathSigne = "\"
        case "w98" : hGetPathSigne = "\"
        case "wnt" : hGetPathSigne = "\"
        case "wme" : hGetPathSigne = "\"
        case "wse" : hGetPathSigne = "\"
        case "w2k" : hGetPathSigne = "\"
        case "wxp" : hGetPathSigne = "\"
        case "os2" : hGetPathSigne = "\"
        case "os4" : hGetPathSigne = "\"
        case "os5" : hGetPathSigne = "\"
        case "osx" : hGetPathSigne = "/"
        case "ppc" : hGetPathSigne = "/"
        case "sol" : hGetPathSigne = "/"
        case "lin" : hGetPathSigne = "/"
        case "x86" : hGetPathSigne = "/"
        case else  : hGetPathSigne = ""
                     qaErrorLog " No pathseperator is defined for this platform : " + sPlatform
    end select
end function

'-------------------------------------------------------------------------

function ConvertPath ( sDatei$, optional sPlatform as string ) as String
'/// Pathconversion
'/// <u>Input</u>: path as string; OPTIONAL: string of class gPlatform
'/// <u>Output</u>: converted path respected to gPlatform; if optional paramter: to that Platform
'/// Convert the <i>pathsigne</i> '\' to '/' when a test runs under UNIX
   Dim iW32 as Integer : Dim iUNX as Integer
   Dim i as Integer : Dim Ende as Integer
   Dim s1$ : Dim s2$ : Dim s3$
   dim sLocalPlatGroup as string
   dim sLocalPathSigne as string

   if (isMissing(sPlatform)) then
        sLocalPlatGroup = gPlatGroup
        sLocalPathSigne = gPathSigne
   else
        sLocalPlatGroup = hPlatformToGroup(sPlatform)
        sLocalPathSigne = hGetPathSigne(sPlatform)
   endif

   s3$ = "" : iW32 = 0 : iUNX = 0
   s1$ = sDatei$
   Ende = len ( s1$ )

'   convert all / to \ if WIN
   if sLocalPlatGroup <> "unx" then
      do
         i = InStr( s1$, "/" )
         if i = 0 then exit do
         s2$ = Left( s1$ , i-1 )
         s1$ = Mid( s1$ , i+1 )
         s3$ = s3$ + s2$ + "\"
      loop until s1$=""
      s1$ = s3$ + s1$
      s3$ = "" : s2$ = ""
   endif

   ' convert all \ to gPathSigne => WIN -> XXX
   do
      i = InStr( s1$, "\" )
      if i = 0 then exit do
      s2$ = Left( s1$ , i-1 )
      s1$ = Mid( s1$ , i+1 )
      s3$ = s3$ + s2$ + sLocalPathSigne
   loop until s1$=""

   ConvertPath = s3$ + s1$
end function

'-------------------------------------------------------------------------

function hDecode2 ( OrgText As String )
'/// Decode routine for password of client-user.
   Dim sText2, sDummy as String
   Dim i as Integer

   sDummy = ""
   for i=1 to len ( OrgText ) step 2
      sDummy = Mid ( OrgText, i, 2 )
      select case sDummy
         case "BQ" : sText2 = sText2 + "1"
         case "QD" : sText2 = sText2 + "2"
         case "AF" : sText2 = sText2 + "3"
         case "HS" : sText2 = sText2 + "4"
         case "HD" : sText2 = sText2 + "5"
         case "TZ" : sText2 = sText2 + "6"
         case "TP" : sText2 = sText2 + "7"
         case "FH" : sText2 = sText2 + "8"
         case "JS" : sText2 = sText2 + "9"
         case "EJ" : sText2 = sText2 + "0"
         case "IT" : sText2 = sText2 + "a"
         case "AE" : sText2 = sText2 + "b"
         case "TA" : sText2 = sText2 + "c"
         case "EA" : sText2 = sText2 + "d"
         case "NA" : sText2 = sText2 + "e"
         case "NT" : sText2 = sText2 + "f"
         case "IE" : sText2 = sText2 + "g"
         case "NN" : sText2 = sText2 + "h"
         case "TE" : sText2 = sText2 + "i"
         case "EI" : sText2 = sText2 + "j"
         case "TI" : sText2 = sText2 + "k"
         case "II" : sText2 = sText2 + "l"
         case "NE" : sText2 = sText2 + "m"
         case "AI" : sText2 = sText2 + "n"
         case "TN" : sText2 = sText2 + "o"
         case "AA" : sText2 = sText2 + "p"
         case "EN" : sText2 = sText2 + "q"
         case "IN" : sText2 = sText2 + "r"
         case "AT" : sText2 = sText2 + "s"
         case "AN" : sText2 = sText2 + "t"
         case "NI" : sText2 = sText2 + "u"
         case "EE" : sText2 = sText2 + "v"
         case "TT" : sText2 = sText2 + "w"
         case "XX" : sText2 = sText2 + "x"
         case "ET" : sText2 = sText2 + "y"
         case "IA" : sText2 = sText2 + "z"
         case else : warnlog "The routine can't decode the password! It has a undefined character : " + sDummy
      end select
   next i

   hDecode2 = sText2

end function

'-------------------------------------------------------------------------

sub GetLanguageInformation
'/// Extracts the language information from <i>Setup.xcu</i>.
'/// <u>note</u>: It uses the <b>fgetL10Nvalue</b>.
   Dim i as integer
   Dim sLanOutIni as string
   Dim SetupXML as String
   Dim ChildsOfSetupNodes as integer
   Dim ArtOfInst as string
   Dim SetupXMLNet as string
   Dim SetupXMLDefault as string

    if gNetzInst = TRUE then
        SetupXMLNet = gNetzOfficePath & ConvertPath("share\registry\data\org\openoffice\Setup.xcu")
        SetupXML = gOfficePath & ConvertPath("user\registry\data\org\openoffice\Setup.xcu")
        ArtOfInst = "NET- / Workstation Inst."
    else
        SetupXML = gOfficePath & ConvertPath("user\registry\data\org\openoffice\Setup.xcu")
        SetupXMLDefault = gOfficePath & ConvertPath("share\registry\data\org\openoffice\Setup.xcu")
        ArtOfInst = "FAT Inst."
    endif

    if app.Dir (SetupXML) = "" then
        warnlog "GetLanguageInformation(" & ArtOfInst & "): " & SetupXML & " not found => can't get the correct Office-Language! Default (01) will be used."
        iSprache = 01
        Exit sub
    else
        ' function 'fgetL10Nvalue' is also in this library
        sLanOutIni = fgetL10Nvalue(SetupXML)
        ' BugID 98315 -> looking in networkpath for the language until bug will be fixed.
        if sLanOutIni = "" and gNetzInst = TRUE then
            sLanOutIni = fgetL10Nvalue(SetupXMLNet)
        endif
        ' It is an English FAT version 645m9s2 or higher.
        if sLanOutIni = "" and gNetzInst = FALSE then
            sLanOutIni = fgetL10Nvalue(SetupXMLDefault)
        endif
    endif

    if sLanOutIni = "" then
        warnlog "=> default is now 01 = en_US"
    endif

     'language Code ISO 639 (and ISO 3166 for en language) is now gLangCode
     'http://staroffice-doc.germany.sun.com/Projects/Common/Documentation/Developer_Docs/all_supported_languages.html
     'ISO 639 http://www.oasis-open.org/cover/iso639a.html
     'ISO 3166: http://xml.coverpages.org/country3166.html

     gISOLang = sLanOutIni

     select case lcase ( sLanOutIni )
         case "en_us", "en-us", "en" : iSprache = 01        ' English (USA)
         case "pt_pt", "pt-pt", "pt" : iSprache = 03        ' Portuguese
         case "ru_ru", "ru-ru", "ru" : iSprache = 07        ' Russian
         case "el_gr", "el-gr", "el" : iSprache = 30        ' Greek
         case "nl_nl", "nl-nl", "nl" : iSprache = 31        ' Dutch
         case "fr_fr", "fr-fr", "fr" : iSprache = 33        ' French
         case "es_es", "es-es", "es" : iSprache = 34        ' Spanish
         case "fi_fi", "fi-fi", "fi" : iSprache = 35        ' Finnish
         case "hu_hu", "hu-hu", "hu" : iSprache = 36        ' Hungaria
         case "ca_ad", "ca-ad", "ca" : iSprache = 37        ' Catalan
         case "it_it", "it-it", "it" : iSprache = 39        ' Italian
         case "cs_cz", "cs-cz", "cs" : iSprache = 42        ' Czech
         case "sk_sk", "sk-sk", "sk" : iSprache = 43        ' Slowak
         case "en_gb", "en-gb"       : iSprache = 44        ' English (GB)
         case "da_dk", "da-dk", "da" : iSprache = 45        ' Danish
         case "sv_se", "sv-se", "sv" : iSprache = 46        ' Swedish
         case "no_no", "no-no", "no" : iSprache = 47        ' Norwegian
         case "pl_pl", "pl-pl", "pl" : iSprache = 48        ' Polish
         case "de_de", "de-de", "de" : iSprache = 49        ' German
         case "pt_br", "pt-br", "br" : iSprache = 55        ' Portuguese (Brazil)
         case "th_th", "th-th", "th" : iSprache = 66        ' Thai
         case "ja_jp", "ja-jp", "ja" : iSprache = 81        ' Japanese
         case "ko_kr", "ko-kr", "ko" : iSprache = 82        ' Korean
         case "zh_cn", "zh-cn", "zh" : iSprache = 86        ' Chinese (simplified)
         case "zh_tw", "zh-tw"       : iSprache = 88        ' Chinese (traditional)
         case "tr_tr", "tr-tr", "tr" : iSprache = 90        ' Turkish
         case "hi_in", "hi-in", "hi" : iSprache = 91        ' Hindi
         case "ar_ar", "ar-ar", "ar" : iSprache = 96        ' Arabic
         case "he_he", "he-he", "he" : iSprache = 97        ' Hebrew
         case "zz_zz", "zz-zz", "zz" : iSprache = 01        ' unknown
                                       warnlog "iniinfo.inc::GetLanguageInformation()"
                                       warnlog "- sLanOutIni = " & sLanOutIni & " (unknown language)"
                                       warnlog "- iSprache has been set 01!"
         case ""                     : iSprache = 01        ' empty
                                       warnlog "iniinfo.inc::GetLanguageInformation()"
                                       warnlog "- empty sLanOutIni = " & sLanOutIni
                                       warnlog "- iSprache has been set 01!"
         case else                   : iSprache = 01
                                       warnlog "iniinfo.inc::GetLanguageInformation()"
                                       warnlog "- sLanOutIni = " & sLanOutIni & " (fallback mode; unknown language)"
                                       warnlog "- iSprache has been set 01!"
     end select

    if iSprache = 81 OR iSprache = 82 OR iSprache = 86 OR iSprache = 88 then
        bAsianLan = TRUE
    else
        bAsianLan = FALSE
    endif
    if ((iSprache = 66) OR (iSprache = 91) OR (iSprache = 96) OR (iSprache = 97)) then
        bCTLLan = TRUE
    else
        bCTLLan = FALSE
    endif
    gLanguage = GetLanguageText ( iSprache )
end sub

'-------------------------------------------------------------------------

function ConvertLanguage ( Sprache as String ) as Integer
'/// Sets international language code for the whole language name.

   select case lCase ( Sprache )
      case "deutsch", "german"                              : ConvertLanguage = 49
      case "englisch", "english"                            : ConvertLanguage = 01
      case "portugisisch", "portugiesisch", "portuguese"    : ConvertLanguage = 03
      case "russisch", "russian"                            : ConvertLanguage = 07
      case "czech", "tschechisch"                           : ConvertLanguage = 29
      case "griechisch", "greek"                            : ConvertLanguage = 30
      case "niederlaendisch", "hollaendisch", "netherlands" : ConvertLanguage = 31
      case "franzoesisch", "french"                         : ConvertLanguage = 33
      case "spanisch", "spanish"                            : ConvertLanguage = 34
      case "finisch", "finnish"                             : ConvertLanguage = 35
      case "hungaria", "ungarisch"                          : ConvertLanguage = 36
      case "italienisch", "italian"                         : ConvertLanguage = 39
      case "daenisch", "danish"                             : ConvertLanguage = 45
      case "schwedisch", "swedish"                          : ConvertLanguage = 46
      case "norwegian", "norwegisch"                        : ConvertLanguage = 47
      case "polnisch", "polish"                             : ConvertLanguage = 48
      case "slowak", "slovakisch"                           : ConvertLanguage = 51
      case "japanisch", "japanese"                          : ConvertLanguage = 81
      case "koreanisch", "korean"                           : ConvertLanguage = 82
      case "chinesisch", "chinese"                          : ConvertLanguage = 86
      case "chinesisch trad.", "chinese trad."              : ConvertLanguage = 88
      case "tuerkisch", "turkish"                           : ConvertLanguage = 90
      case "arabisch", "arab"                               : ConvertLanguage = 96
      case "catalan", "katalanisch"                         : ConvertLanguage = 99
   end select
end function

'-------------------------------------------------------------------------

function GetLanguageText ( iLan ) as String
'/// Sets the language name for the international language-code.
   select case iLan
      case 01   : GetLanguageText = "English (USA)"
      case 03   : GetLanguageText = "Portuguese"
      case 07   : GetLanguageText = "Russian"
      case 30   : GetLanguageText = "Greek"
      case 31   : GetLanguageText = "Dutch"
      case 33   : GetLanguageText = "French"
      case 34   : GetLanguageText = "Spanish"
      case 35   : GetLanguageText = "Finnish"
      case 36   : GetLanguageText = "Hungarian"
      case 37   : GetLanguageText = "Catalan"
      case 39   : GetLanguageText = "Italian"
      case 42   : GetLanguageText = "Czech"
      case 43   : GetLanguageText = "Slowak"
      case 44   : GetLanguageText = "English (GB)"
      case 45   : GetLanguageText = "Danish"
      case 46   : GetLanguageText = "Swedish"
      case 47   : GetLanguageText = "Norwegian"
      case 48   : GetLanguageText = "Polnish"
      case 49   : GetLanguageText = "German"
      case 55   : GetLanguageText = "Portuguese (Brazil)"
      case 66   : GetLanguageText = "Thai"
      case 81   : GetLanguageText = "Japanese"
      case 82   : GetLanguageText = "Korean"
      case 86   : GetLanguageText = "Chinese (simplified)"
      case 88   : GetLanguageText = "Chinese (traditional)"
      case 90   : GetLanguageText = "Turkish"
      case 91   : GetLanguageText = "Hindi"
      case 96   : GetLanguageText = "Arabic"
      case 97   : GetLanguageText = "Hebrew"
      case 99   : GetLanguageText = "Unknown"
      case else : GetLanguageText = "detection failed"
   end select
end function

'-------------------------------------------------------------------------

function ConvertLanguage2 ( sSprache as String, optional bExact ) as Integer
'/// Sets the international language code for the international language shortcut.
'/// <i>optional <b>bExact</i></b>: If language not available, 'shut up' and return '0'
   select case lCase ( sSprache )
         case "en_us", "en-us", "en" : ConvertLanguage2 = 01        ' English (USA)
         case "pt_pt", "pt-pt", "pt" : ConvertLanguage2 = 03        ' Portuguese
         case "ru_ru", "ru-ru", "ru" : ConvertLanguage2 = 07        ' Russian
         case "el_gr", "el-gr", "el" : ConvertLanguage2 = 30        ' Greek
         case "nl_nl", "nl-nl", "nl" : ConvertLanguage2 = 31        ' Dutch
         case "fr_fr", "fr-fr", "fr" : ConvertLanguage2 = 33        ' French
         case "es_es", "es-es", "es" : ConvertLanguage2 = 34        ' Spanish
         case "fi_fi", "fi-fi", "fi" : ConvertLanguage2 = 35        ' Finnish
         case "hu_hu", "hu-hu", "hu" : ConvertLanguage2 = 36        ' Hungaria
         case "ca_ad", "ca-ad", "ca" : ConvertLanguage2 = 37        ' Catalan
         case "it_it", "it-it", "it" : ConvertLanguage2 = 39        ' Italian
         case "cs_cz", "cs-cz", "cs" : ConvertLanguage2 = 42        ' Czech
         case "sk_sk", "sk-sk", "sk" : ConvertLanguage2 = 43        ' Slowak
         case "en_gb", "en-gb"       : ConvertLanguage2 = 44        ' English (GB)
         case "da_dk", "da-dk", "da" : ConvertLanguage2 = 45        ' Danish
         case "sv_se", "sv-se", "sv" : ConvertLanguage2 = 46        ' Swedish
         case "no_no", "no-no", "no" : ConvertLanguage2 = 47        ' Norwegian
         case "pl_pl", "pl-pl", "pl" : ConvertLanguage2 = 48        ' Polish
         case "de_de", "de-de", "de" : ConvertLanguage2 = 49        ' German
         case "pt_br", "pt-br", "br" : ConvertLanguage2 = 55        ' Portuguese (Brazil)
         case "th_th", "th-th", "th" : ConvertLanguage2 = 66        ' Thai
         case "ja_jp", "ja-jp", "ja" : ConvertLanguage2 = 81        ' Japanese
         case "ko_kr", "ko-kr", "ko" : ConvertLanguage2 = 82        ' Korean
         case "zh_cn", "zh-cn", "zh" : ConvertLanguage2 = 86        ' Chinese (simplified)
         case "zh_tw", "zh-tw"       : ConvertLanguage2 = 88        ' Chinese (traditional)
         case "tr_tr", "tr-tr", "tr" : ConvertLanguage2 = 90        ' Turkish
         case "hi_in", "hi-in", "hi" : ConvertLanguage2 = 91        ' Hindi
         case "ar_ar", "ar-ar", "ar" : ConvertLanguage2 = 96        ' Arabic
         case "he_he", "he-he", "he" : ConvertLanguage2 = 97        ' Hebrew
         case "zz_zz", "zz-zz", "zz" : ConvertLanguage2 = 01        ' unknown
         case else                   : if isMissing (bExact) then
                                         printlog "iniinfo.inc::ConvertLanguage2(): Unknown systemlanguage '" & sSprache & "'!"
                                         printlog "Default will be set to 01!"
                                         ConvertLanguage2 = 01
                                        else
                                         printlog "iniinfo.inc::ConvertLanguage2(): Unknown systemlanguage '" & sSprache & "'!"
                                         if bExact = TRUE then
                                           printlog "Default will be set to 00!"
                                           ConvertLanguage2 = 00
                                         endif
                                       endif
   end select
end function

'-------------------------------------------------------------------------

function ConvertCodeToLanguage ( sSprache as String ) as Integer
'/// Converts the old language code to international language code
   select case lCase ( sSprache )
         case "1033" : ConvertCodeToLanguage = 01        ' English (USA)
         case "2070" : ConvertCodeToLanguage = 03        ' Portuguese
         case "1049" : ConvertCodeToLanguage = 07        ' Russian
         case "1032" : ConvertCodeToLanguage = 30        ' Greek
         case "1043" : ConvertCodeToLanguage = 31        ' Dutch
         case "1036" : ConvertCodeToLanguage = 33        ' French
         case "3082" : ConvertCodeToLanguage = 34        ' Spanish
         case "1035" : ConvertCodeToLanguage = 35        ' Finnish
         case "1038" : ConvertCodeToLanguage = 36        ' Hungaria
         case "2099" : ConvertCodeToLanguage = 37        ' Catalan
         case "1040" : ConvertCodeToLanguage = 39        ' Italian
         case "1029" : ConvertCodeToLanguage = 42        ' Czech
         case "1051" : ConvertCodeToLanguage = 43        ' Slowak
         case "2057" : ConvertCodeToLanguage = 44        ' English (GB)
         case "1030" : ConvertCodeToLanguage = 45        ' Danish
         case "1053" : ConvertCodeToLanguage = 46        ' Swedish
         case "2047" : ConvertCodeToLanguage = 47        ' Norwegian
         case "1045" : ConvertCodeToLanguage = 48        ' Polish
         case "1031" : ConvertCodeToLanguage = 49        ' German
         case "    " : ConvertCodeToLanguage = 55        ' Portuguese (Brazil)
         case "    " : ConvertCodeToLanguage = 66        ' Thai
         case "1041" : ConvertCodeToLanguage = 81        ' Japanese
         case "1042" : ConvertCodeToLanguage = 82        ' Korean
         case "2052" : ConvertCodeToLanguage = 86        ' Chinese (simplified)
         case "1028" : ConvertCodeToLanguage = 88        ' Chinese (traditional)
         case "1055" : ConvertCodeToLanguage = 90        ' Turkish
'         case "    " : ConvertCodeToLanguage = 91        ' Hindi
         case "1025" : ConvertCodeToLanguage = 96        ' Arabic
'         case "    " : ConvertCodeToLanguage = 97        ' Hebrew
         case else   : printlog "iniinfo.inc::ConvertCodeToLanguage(): Num. Code could not be detect or is unknown and will be set to 01 (English (USA))!"
                       ConvertCodeToLanguage = 01
   end select
end function

'-------------------------------------------------------------------------

sub GetTheInstallationType
    '/// If StarOffice is installed as a network installation the global variable 'gNetzInst' and 'gNetzOfficePath' will be set here.
    Dim sCommonXML as String, sDummy as String, sDestPath as String, sSourcePath as String, sMode as String
    Dim FileNum%
    dim sTemp as string
    dim sURL as string
    dim aTemp
    dim aTemp2
    dim aTemp3
    dim i,x as integer
    
    if gSamePC = TRUE then
        gNetzInst = TRUE
        gNetzOfficePath = gOfficePath
        if (gSamePC = TRUE) then
            if gPlatgroup = "unx" then
                sTemp = GetIniValue (gOfficePath + "program/bootstraprc", "Bootstrap", "UserInstallation")
            else
                sTemp = GetIniValue (gOfficePath+"program\bootstrap.ini", "Bootstrap", "UserInstallation")
            endif
        endif
        sURL = convertFromURL(sTemp) ' to get the % encoded chars decoded! and to remove "file://" if somebody provides a URL
        ' Formerly I had to fake the string with a starting "file://" to use the function; nowadays it works without it
        if inStr(sURL,"$SYSUSERCONFIG") > 0 then
            gOfficePath = gtSystemPath + right(sURL, len(sURL) - (inStr(sURL,"$SYSUSERCONFIG")+len("$SYSUSERCONFIG"))) + gPathSigne
        else
            if inStr(sURL,"$ORIGIN") > 0 then
                gOfficePath = gOfficePath + "program" + gPathSigne + right(sURL, len(sURL) - (inStr(sURL,"$ORIGIN")+len("$ORIGIN"))) + gPathSigne
            else
                if inStr(sTemp,"file://") > 0 then
                    ' file:// had to get removed on calling convertFromURL() sTemp -> sURL
                    gOfficePath = sURL + gPathSigne
                else
                    qaErrorLog "ininfo.inc::GetTheInstallationType:: Unexpected entry in bootstrap file.(Entry UserInstallation not starting with: $SYSUSERCONFIG or $ORIGIN or file://; Using entry as absolute path!)"
                    printlog "ininfo.inc::GetTheInstallationType:: original UserInstallation entry from 'bootstrap' file: '" + sTemp + "'"
                    printlog "ininfo.inc::GetTheInstallationType:: using now converted from URL for 'gOfficePath': '" + sURL + "'"
                    gOfficePath = sURL + gPathSigne
                endif
            endif
        endif
        ' make unique platform path seperators
        gOfficePath = convertPath(gOfficePath)
        ' to support some developer bootstraprc/ini's:
        gOfficePath = fRelativeToAbsolutePath(gOfficePath)
        gOfficePath = fRemoveDoubleCharacter(gOfficePath + gPathSigne, gPathSigne)
    else  
        gNetzInst = GetIniValue ( gTesttoolIni, "Network", "Net" )
        gNetzOfficePath = GetIniValue ( gTesttoolIni, "Network", "Current" )
        if Right ( gNetzOfficePath,1 ) <> gPathSigne then gNetzOfficePath = gNetzOfficePath + gPathSigne
    endif
end sub

'-------------------------------------------------------------------------

function GetItForMe ( CompleteString as String ) as String
   Dim sDum as String
   Dim iEqual as Integer, iLen as Integer

   iLen = Len ( CompleteString )
   iEqual = Instr ( CompleteString, "=" )
   sDum = Trim ( Right ( CompleteString, iLen - iEqual - 1 ) )

   iLen = Len ( sDum )
   if Right ( sDum, 1 ) = ";" then sDum = Left ( sDum, iLen - 1 )    ' delete the ; at the end of the text
   iLen = Len ( sDum )
   if Left ( sDum, 1 ) = Chr(34) then                                ' delete the "" out of text
      sDum = Right ( sDum, iLen - 1 )
      sDum = Left  ( sDum, iLen - 2 )
   endif
   GetItForMe = sDum
end function

'-------------------------------------------------------------------------

function ReplaceCharacter(stringToChange$, charToReplace$, replaceWith$) As String
'/// Replaces a specified character in a string with another character that you specify
'/// INPUT: &lt;string&gt; , &lt;which characterto replace&gt; , &lt;which caracter the old one should be replaced&gt;
    Dim ln, n As Long
    Dim NextLetter As String
    Dim FinalString As String
    Dim txt, char, rep As String
    txt = stringToChange$ 'store all arguments in
    char = charToReplace$ 'new variables
    rep = replaceWith$

    ln = Len(txt)

   For n = 1 To ln Step 1
    NextLetter = Mid(txt, n, 1)
    If NextLetter = char Then
     NextLetter = rep
    endif
    FinalString = FinalString & NextLetter
   Next n
  ReplaceCharacter = FinalString
End Function

'-------------------------------------------------------------------------

function FileURLToNormalFile ( sFileURL as String ) as String
    FileURLToNormalFile = convertFromURL( sFileURL )
end function

'-------------------------------------------------------------------------

function fgetL10Nvalue ( setupxcu as string) as string
'/// Gets the value of the child from
'///+ <ul><li>node: oor:name=&quot;L10N&quot;<ul><li>node: oor:name = &quot;ooLocale&quot;</li><ul><li>element: value</li></ul></ul></li></ul>
'///+ in a file (normaly <b>Setup.xcu</b> in network path or installation path).
'/// <u>Note</u>: The structure is hard coded and specified. A change must be announced by feature mail!
'/// <br>
'/// <u><i>Description</i></u>:
  Dim i as integer
  Dim ChildsOfSetupNodes as integer

  fgetL10Nvalue = ""

'/// Open the file given as parameter.
   SAXReadFile(setupxcu)
'/// Go to the DOM (Document Object Model) root.
   SAXSeekElement("/")
'/// Go <b>into</b> the first <b>node</b> of the tree.
   SAXSeekElement(1)
'/// Get the <b>count of children</b> (nodes/elements) in that node.
   ChildsOfSetupNodes = SAXGetChildCount
      for i = 1 to ChildsOfSetupNodes
'/// Run in a for next loop of going <b>into</b> the next node and existing it until ...
       SAXSeekElement(i)
'/// ...the <i>oor:name</i> attribute value is identical to &quot;L10N&quot;
       if SaxGetAttributeValue("oor:name") = "L10N" then
'/// Go <b>into</b> the next node (&quot;prop&quot;)
        SAXSeekElement("prop")
'/// If the attribute value of &quot;oor:name&quot; is identical to &quot;ooLocale&quot;...
         if SAXgetAttributeValue("oor:name") = "ooLocale" then
'/// go <b>into</b> that node and also into the next one, named &quot;value&quot;.
           SAXSeekElement("value")
'/// Go <b>into</b> the next node - a <i>node type</i> <b>character</b>...
           SAXSeekElement(1)
            if SAXGetNodeType = NodeTypeCharacter then
'/// ...and get the characters out in the string which will be returned from this function.
              fgetL10Nvalue = SAXGetChars
'/// <i>Release()</i> the DOM.
              SAXRelease()
'/// Exit the function.
              Exit function
            endif
          else
            SAXRelease()
'/// If the result is empty exit the function without warning.
            Exit function
           endif
         endif
         SAXSeekElement(0)
      next i
end function

function hPlatformToGroup(sPLatform as string) as string
'/// <u>Input</u>: string of class gPlatform
'/// <u>Output</u>: string of class gPlatGroup
    select case sPLatform
        case "w95":hPlatformToGroup = "w95"
        case "w98":hPlatformToGroup = "w95"
        case "wse":hPlatformToGroup = "w95"
        case "wme":hPlatformToGroup = "w95"
        case "wnt":hPlatformToGroup = "w95"
        case "w2k":hPlatformToGroup = "w95"
        case "wxp":hPlatformToGroup = "w95"
        case "mac":hPlatformToGroup = "mac"
        case "ppc":hPlatformToGroup = "unx"        
        case "sol":hPlatformToGroup = "unx"
        case "x86":hPlatformToGroup = "unx"
        case "lin":hPlatformToGroup = "unx"
    end select
end function

'-------------------------------------------------------------------------

sub sGetCrashreporterValues as boolean
    '/// This routine reads the values of the [Crashreporter] section
    '///+ in the TestTool control file (testtool.ini / .testtoolrc).
    '///It returns FALSE if one of the required
    '///+ information is missing in testtool.ini. 
        
    sGetCrashreporterValues = FALSE
    '/// <i>gUseProxy</i> should be TRUE if you need a proxy or FALSE
    '///+ if you have a direct connection to the (inter)net.     
    gUseProxy = GetIniValue ( gTesttoolIni, "Crashreporter" , "UseProxy" )    
    'If there's no value (=no entries at all...) exit the routine.
    'sGetCrashreporterValues = FALSE so the routine in master.inc
    'will stop testing.
    if gUseProxy = "" then        
        exit sub
    else
        'Making a boolean value from it.
        gUseProxy = cBool(gUseProxy) 
        '/// <i>gConnectiontype</i> has the value DIRECT or MANUALPROXY in dependency
        '///+ of <i>gUseProxy</i>. If <i>gUseProxy</i> = TRUE then the value of
        '///+ <i>gConnectiontype</i> is MANUALPROXY otherwiese DIRECT.
        if gUseProxy = FALSE then 
            gConnectionType = "DIRECT"        
            sGetCrashreporterValues = TRUE
        else 
            gConnectionType = "MANUALPROXY"
        endif
    
        '/// <i>gProxyServer</i> should be the proxy server which is needed to send
        '///+ the crashreporter data via the net.
        gProxyServer = GetIniValue ( gTesttoolIni, "Crashreporter" , "ProxyServer" )
        'Verifying that a proxy server has been entered if
        'gUseProxy has been set to TRUE.
        if gUseProxy = TRUE AND gProxyServer = "" then 
            warnlog "qatesttool::global::system::inc::iniinfo.inc::sGetCrashReporterValue: " _
                    & "In the [Crashreporter]-section of TestTool control file 'UseProxy=true' but 'ProxyServer=' (empty). Please correct it!"
            sGetCrashreporterValues = FALSE
        else
            sGetCrashreporterValues = TRUE
        endif

        '/// <i>gProxyPort</i> should be the proxy server port which is needed to send
        '///+ the crashreporter data via the net.
        gProxyPort = GetIniValue ( gTesttoolIni, "Crashreporter" , "ProxyPort" )
        'Verifying that a proxy server port has been entered if
        'gUseProxy has been set to TRUE.
        if gUseProxy = TRUE AND gProxyPort = "" then 
            sGetCrashreporterValues = FALSE
            warnlog "qatesttool::global::system::inc::iniinfo.inc::sGetCrashReporterValue: " _
                    & "In the [Crashreporter]-section of TestTool control file 'UseProxy=true' but 'ProxyPort=' (empty). Please correct it!"       
        endif
        
        '/// <i>gAllowContact</i> should be TRUE or FALSE
        gAllowContact = GetIniValue ( gTesttoolIni, "Crashreporter" , "AllowContact" )
        gAllowContact = cBool(gAllowContact)
    
        '/// <i>gReturnAddress</i> should be the E-Mail address which can be used 
        '///+ to contact the user who has run the test scripts for additional information .  
        gReturnAddress = GetIniValue ( gTesttoolIni, "Crashreporter" , "ReturnAddress" )
        'Verifying that a mail address has been entered if
        'gAllowContact has been set to TRUE.
        if gAllowContact = TRUE AND gReturnAddress = "" then
            warnlog "qatesttool::global::system::inc::iniinfo.inc::sGetCrashReporterValue: " _
                    & "In the [Crashreporter]-section of TestTool control file 'AllowContact=true' but 'ReturnAddress=' (empty). Please correct it!"           
            sGetCrashreporterValues = FALSE
        endif
    endif
end sub

'-------------------------------------------------------------------------

function getSofficeNative() as string
    '/// Entry in Win32-registry or either link exist: /usr/bin/soffice - $HOME/soffice (aka Native Installer (OOo > SRC680m49)) ///'
    dim sVendor(50) as string
    dim sOffice(50) as string
    dim sVersion(50) as string
    dim iVendorEntries as integer
    dim iVersionEntries as integer
    dim iOfficeEntries as integer
    dim iOOoVersionBorder as integer
    dim i,x,y,z,j as integer
    dim iVendor(2) as integer
    dim iVersion(2) as integer
    dim iOffice(2) as integer
    dim sOfficePath(2) as string
    dim sTemp, sTemp2 as string
    dim sSVersionIni(2) as string
    dim iSversion as integer
    dim sCandidates(2) as string
    dim sKey as string
    dim sPath(2) as string
    dim iBuildId(2) as string
    dim slVersion() as string
    dim ilVersion as integer
    dim sLastVersion as string
    dim iPosA, iPosB as integer
    dim bError as boolean

    bError = false
    
    '/// separated handling between Linux/Unix and Win32 platforms ///'
    if ("unx" = gPlatGroup) then
        '/// on Linux/Unix systems we need to check/resolv 2 possible links which point to the directory with the 'soffice' executable ///'
        try
            '/// created by an installation from the root user: //usr//bin//soffice ///'
            sCandidates(1) = getLinkDestination("/usr/bin/soffice") ' command fails, if link doesn't exist
            if (left(sCandidates(1),2)="..") then
                ' If the link is relative, make it absolute
                sCandidates(1) = "/usr/bin/" + sCandidates(1)
                sCandidates(1) = fRelativeToAbsolutePath(sCandidates(1))
                sCandidates(1) = fRemoveDoubleCharacter(sCandidates(1), gPathSigne)
            endif
 printlog "getSofficeNative() - : /usr/bin/soffice: '" + sCandidates(1) + "' destination exists?: " +fileExists(sCandidates(1))
        catch
 printlog "getSofficeNative() - : /usr/bin/soffice: NOT AVAILABLE"
            sCandidates(1) = ""
        endcatch
        try
            '/// HAS TO GET created by installation from NON root user: $HOME/soffice ///'
            sTemp = Environ("HOME")
            sCandidates(2) = getLinkDestination(sTemp+"/soffice")
            if (left(sCandidates(2),1) <> "/") then
                ' relative path in $HOME directory!
                sCandidates(2) = sTemp + "/" + sCandidates(2)
            endif
 printlog "getSofficeNative() - : $HOME/soffice   : '" + sCandidates(2) + "' destination exists?: " +fileExists(sCandidates(2))
        catch
 printlog "getSofficeNative() - : $HOME/soffice   : NOT AVAILABLE"
            sCandidates(2) = ""
        endcatch
            for i = 1 to 2
                if fileExists(sCandidates(i)) then
                    '/// cut off program//soffice from link destination ///'
                    y = instr(sCandidates(i), "program/soffice")
                    if (y > 0) then
                        sCandidates(i) = left(sCandidates(i), y-1)
                    else
                        qaErrorLog "master.inc::getSofficeNative():: expected 'program/soffice' at end of link destination: '" + sCandidates(i) + "'"
                        sCandidates(i) = ""
                    endif
                endif
            next i
        if (("" = sCandidates(1)) or ("" = sCandidates(2))) then
            ' if one candidate doesn't exist
            '/// If only one candidate exist, take him. ///'
            gOfficePath = sCandidates(1) + sCandidates(2)
        else
            ' both candidates exist
            '/// If both candidates exits... ///'
            for i = 1 to 2
                '/// - Check if link destination exists; No: drop candidate ///'
                if fileExists(sCandidates(i)) then
                    iBuildId(i) = i
                else
                    ' link destination doesn't exist: drop candidate
                    sCandidates(i) = ""
                    iBuildId(i) = 0
                endif
            next i
 printlog "getSofficeNative() - : BildId (1): " + iBuildId(1) + " (2): " + iBuildId(2)
            '/// - Take the candidate which exists and comes from $HOME ///'
            if (iBuildId(1) > iBuildId(2)) then 
                gOfficePath = sCandidates(1)
            else
                '/// - If BuildIds are equal, the candidate from $HOME wins ///'
                gOfficePath = sCandidates(2)
            endif
        endif
        if (not fileExists(gOfficePath)) then 
            '/// - check if resulting candidate exist; No: error ///'
            bError = true
        endif
    else
        '/// On win32 systems we need to check the registry for two paths with the key 'Path': ///'
        sKey = "Path"
        '                    "--K--\Software\--Vendor--\--Product--\--Version--"
        '/// If User installs, the path 'HKEY_CURRENT_USER\\Software\\' got set.///'
        sPath(1) = "HKEY_CURRENT_USER\Software\"
        '/// If Administrator installs, the path 'HKEY_LOCAL_MACHINE\\Software\\' got set.///'
        sPath(2) = "HKEY_LOCAL_MACHINE\Software\"

        '/// An entry in the registry consists of 2 parts: 1st the Office, 2nd the version-number ///'
        '/// There may be several entries, but only the newest version is used.  ///'
        '/// There may exist both Paths HKCU and HKLM///'
        '/// Which version is used? ///'
        '/// From both Paths the newest version is chosen:  from the lowest sOffice() the lowest sVersion() ///'
        '/// If in both paths the entries are equal, the HKCU wins. ///'
        iVendorEntries = 1
        sVendor(iVendorEntries) = "Sun Microsystems": inc (iVendorEntries)
        sVendor(iVendorEntries) = "OpenOffice.org"  : inc (iVendorEntries)
        
        iOfficeEntries = 1
        sOffice(iOfficeEntries) = "StarOffice"    : inc (iOfficeEntries)
        sOffice(iOfficeEntries) = "StarSuite"     : inc (iOfficeEntries)
        sOffice(iOfficeEntries) = "OpenOffice.org": inc (iOfficeEntries)
    
        iVersionEntries = 1
        sVersion(iVersionEntries) = "8"      : inc (iVersionEntries)
        iOOoVersionBorder = iVersionEntries
        sVersion(iVersionEntries) = "2.0.0"  : inc (iVersionEntries)
        sVersion(iVersionEntries) = "680"    : inc (iVersionEntries)
        
        ' put new versions ABOVE THIS LINE! ^^^^^^^^^^^
        sVersion(iVersionEntries) ="NotFound": inc (iVersionEntries) ' HAS TO Stay at LAST
        
        ' I have to walk over both sPath(z),
        '   over all sOffice(y)-1
        '       over all sVersion(x)-2
        ' the first one found in each sPath(z) wins.
        for z = 1 to 2
            sOfficePath(z) = ""
            for j =1 to iVendorEntries-1
                for y =1 to iOfficeEntries-1
                    for x =1 to iVersionEntries-2
                        'collect all entries != "" (empty string)
                        if sOfficePath(z) = "" then ' if no version found right now, set it
                            sTemp = sPath(z) + sVendor(j) + "\" + sOffice(y) + "\" + sVersion(x)
                            sOfficePath(z) = getRegistryValue(sTemp, sKey)
     if (sOfficePath(z) <> "") then
         printlog "getSofficeNative() - : A " + z + ":" + j + ":" + y + ":" + x + " " + sTemp +  " +++++++++++ " + sOfficePath(z) 
     endif
                            iOffice(z) = j*100 + y*10 + x
                        else
                            sTemp = sPath(z) + sVendor(j) + "\" + sOffice(y) + "\" + sVersion(x)
                            if sTemp <> "" then
                                sTemp2 = getRegistryValue(sTemp, sKey)
     if (sTemp2 <> "") then
         printlog "getSofficeNative() - : B " + z + ":" + j + ":" + y + ":" + x + " " + sTemp +  " +++++++++++ "+sTemp2
     endif
                            endif
                        endif
                    next x
                next y
            next j
        next z

        ' remove path, if destination doesn't exist
        if (NOT fileExists(sOfficePath(1))) then
            sOfficePath(1) = ""
        endif
        if (NOT fileExists(sOfficePath(2))) then
            sOfficePath(2) = ""
        endif
        ' compute version to be used
        if (sOfficePath(1) = "") or (sOfficePath(2) = "") then
            gOfficePath = sOfficePath(1) + sOfficePath(2)
        else
            if (iOffice(1) > iOffice(2)) then
                gOfficePath = sOfficePath(2)
            else
                gOfficePath = sOfficePath(1)
            endif
        endif

        if (gOfficePath = "" or not fileExists(gOfficePath)) then
            ' Error of no office is found
            bError = true
        else
            ' cut of the executable name
            i = instr(gOfficePath, "program\soffice.exe")
            if i > 0 then
                gOfficePath = left(gOfficePath, i-1)
            else
                qaErrorLog "master.inc::getSofficeNative():: expected 'program/soffice.exe' at end of link destination: '" + gOfficePath + "'"
            endif
        endif
    endif
    ' now we have gOfficePath set.
    
    if (not bError) then
        ' needed input for function: fGetProductName()
        '/// Look, if we got an OpenOffice.org version ///'
        gNetzOfficePath = gOfficePath
        sTemp = fGetProductName
        if (instr(sTemp, "OpenOffice.org") > 0) then
            gOOO = TRUE
        else
            gOOO = FALSE
        endif
        getSofficeNative = gOfficePath  ' set return value
    else
        '/// If error occured, set returnvalue to "" - empty srting ///'
        getSofficeNative = ""           ' set return value
    endif
end function

'-------------------------------------------------------------------------

function getSofficeSversion() as string
        ' 3. Entry in .sversionrc/.ini (OOo < SRC680m50)
    dim sOffice(50) as string
    dim sVersion(50) as string
    dim iVersionEntries as integer
    dim iOfficeEntries as integer
    dim iOOoVersionBorder as integer
    dim i,x,y,z as integer
    dim iVersion(2) as integer
    dim iOffice(2) as integer
    dim sOfficePath(2) as string
    dim sTemp as string
    dim sSVersionIni(2) as string
    dim sSVersion as string
    dim iSversion as integer
    dim sCandidates(2) as string
    dim bError as boolean

    bError = false
    if ("unx" = gPlatGroup) then
        sSVersion = ".sversionrc"
    else
        sSVersion = "sversion.ini"
    endif
    sCandidates(1) = gtSystemPath
    sCandidates(2) = gtCommonSystemPath
    sSVersionIni(1)= sCandidates(1) + sSVersion
    sSVersionIni(2)= sCandidates(2) + sSVersion
    
    if (dir(sSVersionIni(1))="") then
        sSVersionIni(1) = sSVersionIni(2)
        if (dir(sSVersionIni(1))="") then
            if (gSamePC = TRUE) then
                'MsgBox ("The test ends, because " + sSVersionIni(1) + " or " + sSVersionIni(2) + " is missing ", 1, "'sversion' of OOo is missing")
                'iSversion = 0
                getSofficeSversion = ""
                bError = true
            endif
        else
            iSversion = 1
        endif
    else
        if (dir(sSVersionIni(2))="") then
            iSversion = 1
        else
            iSversion = 2
        endif
    endif
if not bError then 
    'DEBUG: If you need debug information about sversion file detection
    'DEBUG: remove the comment sign in front of the next three lines.
    'printlog "Number of sVersion files: (" + iSversion + "/2)"
    'printlog "1st candidate: (" + sSVersionIni(1) + ") exists?: " + dir(sSVersionIni(1))
    'printlog "2nd candidate: (" + sSVersionIni(2) + ") exists?: " + dir(sSVersionIni(2))

    '/// An entry in the sversion.ini/rc consists of 2 parts: 1st the Office, 2nd the version-number ///'
    '/// There may be several entries in the file, but only the newest version is used.  ///'
    '/// There may exist 2 files, one in your homedirectory and one in a global directory ///'
    '/// Which version is used? ///'
    '/// From both files the newest version is chosen:  from the lowest sOffice() the lowest sVersion() ///'
    '/// If in both files the entries are equal, the homedirectory wins. ///'
    iOfficeEntries = 1
    sOffice(iOfficeEntries) = "StarOffice"    : inc (iOfficeEntries)
    sOffice(iOfficeEntries) = "StarSuite"     : inc (iOfficeEntries)
    sOffice(iOfficeEntries) = "OpenOffice.org": inc (iOfficeEntries)

    iVersionEntries = 1
    sVersion(iVersionEntries) = "8"      : inc (iVersionEntries)
    iOOoVersionBorder = iVersionEntries
    sVersion(iVersionEntries) = "2.0.0"  : inc (iVersionEntries)
    sVersion(iVersionEntries) = "1.1.1a" : inc (iVersionEntries)
    sVersion(iVersionEntries) = "680"    : inc (iVersionEntries)
    
    ' put new versions ABOVE THIS LINE! ^^^^^^^^^^^
    sVersion(iVersionEntries) ="NotFound": inc (iVersionEntries) ' HAS TO Stay at LAST
    
    ' limit: offices < 10 !!!
        for y =1 to iSversion
            gOOO = FALSE
            i = 1
            do
                x = 1
                do
                    gOfficePath = GetIniValue ( sSVersionIni(y), "Versions", sOffice(x)+" "+sVersion(i) )
                    inc x
                loop while ((x<iOfficeEntries) AND ("" = gOfficePath))
                inc i
            loop while ((i < iVersionEntries) AND ("" = gOfficePath))
            sOfficePath(y) = gOfficePath
            iVersion(y) = i
            iOffice(y) = x
            'DEBUG: If you need debug information about sversion file detection
            'DEBUG: remove the comment sign in front of the next line. 
            'printlog "available from: "+ y+". Entry: "+ sOffice(x-1) + " " +sVersion(i-1) + " :" + gOfficePath+ ":"
        next y
        if (iSversion > 1) then
            if (((iVersion(2)*100)+iOffice(2)) < ((iVersion(1)*100)+iOffice(1))) then
                z = 2
            else
                z = 1
            endif
        else
            z = iSversion
        endif
        gSVersionIni = sSVersionIni(z)
        if ("" = sOfficePath(z)) then ' Error of no office is found
            'warnlog "There is no valid entry in section 'Versions' in file '" + gSVersionIni + "'" +Chr(10)+ "Testtool doesn't know where your StarOffice installation is!" + Chr(10) + "Please insert the string into the file: /qatesttool/global/system/inc/iniinfio.inc::GetIniInformation."
            'if MsgBox ("There is no valid entry in section 'Versions' in file '" + gSVersionIni + "'" +Chr(10)+ "Testtool doesn't know where your StarOffice installation is!" + Chr(10) + "Please insert the string into the file: /qatesttool/global/system/inc/iniinfio.inc::GetIniInformation.", 17, "Error at startup") = 2 then
                getSofficeSversion = ""
                bError=true
        else
            gOfficePath = sOfficePath(z)
            if (3=(iOffice(z)-1)) then
                gOOO = TRUE
            endif
        endif

    if not bError then
        gOfficePath = FileURLToNormalFile ( gOfficePath )
        getSofficeSversion = gOfficePath + gPathSigne     ' usually there is no path sign in the sversion at the end
        'DEBUG: If you need debug information about sversion file detection
        'DEBUG: remove the comment sign in front of the next line.
        'printlog "chosen and assigned to gOffice: " + gOfficePath + " is OOo? " + gOOO
    else
    printlog "error"
    endif
endif
end function

'-------------------------------------------------------------------------

function getSofficeTesttool() as string
        ' 1. Entry in .testtoolrc/.ini
    dim sTemp as string
    dim sPName as string
    
    sTemp = ""
    ' first look into the current profile
    sTemp = GetIniValue ( gTesttoolIni, gTTProfileName, "OOoProgramDir" )
    if (sTemp = "") then
        ' second look into OOoProgramDir section
        sTemp = GetIniValue ( gTesttoolIni, "OOoProgramDir", "Current" )
    endif
    ' If the Path exists, then it is valid...
    if fileExists(sTemp) then
        if (right(sTemp,1) <> gPathSigne) then
            sTemp = sTemp + gPathSigne
        endif
        getSofficeTesttool = sTemp
        gOfficePath = sTemp
        gNetzOfficePath = gOfficePath ' initialisation for fGetProductName
        sPName = fGetProductName
        if (instr(sPName, "OpenOffice.org") > 0) then
            gOOO = TRUE
        else
            gOOO = FALSE
        endif
        getSofficeTesttool = sTemp
    else
        ' no valid path, will return nothing, next method will get evaluated in calling function...
        getSofficeTesttool = ""
    endif
end function

'-------------------------------------------------------------------------

sub setValgrindState
    dim sTemp as string

    sTemp = GetIniValue ( gTesttoolIni, gTTProfileName, "Valgrind.kde.org" )
    if ((sTemp = "") or (LCase(sTemp)="false")) then
        gValgrind = false
    else
        gValgrind = true
    endif
end sub

