'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  $RCSfile: w_formatpage1.inc,v $
'*
'*  $Revision: 1.6 $
'*
'*  last change: $Author: hli $ $Date: 2005/01/27 07:27:08 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'/***********************************************************************
'*
'* owner : hercule.li@sun.com
'*
'* short description : Test the functionality of Page Formatting / Page Styles - 1
'*
'************************************************************************
'*
' #1 tFormatPage_1       'Open format/page dialog
' #1 tFormatPage_2       'Test Portrait in tabpage Page
' #1 tFormatPage_3       'Test Landscape in tabpage Page
' #1 tFormatPage_4       'Width and Height boxes must change after changing between Portrait and Landscape
' #1 tFormatPage_5       'The sum of "Left margin" and "Right margin" must always stay below the Paper width.(Same for top/bottom and height)
' #1 tFormatPage_6       'Test predefined formats
' #1 tFormatPage_7       'Test user defined formats
' #1 tFormatPage_8       'Check Listbox Text Direction when Asian language support is enabled
' #1 tFormatPage_9       'Check Listbox Text Direction when CTL is enabled
' #1 tFormatPage_10      'when Asian support and CTL are all enabled , 3 entries should be in Text Direction listbox
' #1 TFormatPage_11      'Test Page layout - Right and left
' #1 tFormatPage_12      'Test Page layout - Mirrored
' #1 tFormatPage_13      'Test Page layout - Only right
' #1 tFormatPage_14      'Test Page layout - Only left
' #1 tFormatPage_15      'Insertfields / other / Document / Type/Page -> As page Style must be set
' #0 CheckAsianLanguageSupport
' #0 CheckCTLSupport
'*
'\***********************************************************************

testcase tFormatPage_1

  PrintLog "- Open format/page dialog"
  '/// <b> Open format/page dialog </b> ///

   Call hNewDocument

   '/// 1. via Mouse clicks in Menu: Format-Page
    try
        fFormatPageWriter("TabSeite")
        TabSeite.Cancel
    catch
    endcatch

   '/// 2. via shortcuts in menu  (manual test is needed)

   '/// 3. via Context menu when Cursor is in the document
    try
        hMenuSelectNr(5)
        Sleep 2
        hMenuSelectNr(5)
        Sleep 2
        Kontext
        Active.SetPage TabSeite
        Kontext "TabSeite"
        TabSeite.Cancel
    catch
    endcatch

   Call hCloseDocument

endcase

'-------------------------------------------------------------------------------------------

testcase tFormatPage_2

  Dim sTestString              as String
  Dim iRepectLength , iFormat  as Integer

  sTestString   =  "ABCDEFGHIJKLMNOPQRSTUVWXYZABCDEFGHIJKLMNOPQRSTUVWXYZABCDEFGHIJKLMNOPQRSTUVWXYZABCDEFGHIJKLMNOPQ"
  iRepectLength =  26
  iFormat       =  2   'A4 paper

  PrintLog "- Test Portrait in tabpage Page"
  '/// <b> Test Portrait in tabpage Page </b> ///

   Call hNewDocument

   '/// Input a long test string
    Call wDokSchreiben sTestString

   '/// Format/Page , tabpage page , check 'Portrait'
    fFormatPageWriter("TabSeite")
      Papierformat.Select iFormat
      Wait 500
      Hoch.Check
      Wait 500
    TabSeite.OK

   '/// Check if Checkbox -- Portrait works fine
    Call wDokSchreiben "<Shift Home>"
    EditCopy
    wait 500
    if Len(GetClipboardText) < iRepectLength then Warnlog "Checkbox Portrait doesn't work fine!"

   Call hCloseDocument

endcase

'-------------------------------------------------------------------------------------------

testcase tFormatPage_3

  Dim sTestString              as String
  Dim iRepectLength , iFormat  as Integer

  sTestString   =  "ABCDEFGHIJKLMNOPQRSTUVWXYZABCDEFGHIJKLMNOPQRSTUVWXYZABCDEFGHIJKLMNOPQRSTUVWXYZABCDEFGHIJKLMNOPQ"
  iRepectLength =  15
  iFormat       =  2   'A4 paper

  PrintLog "- Test Landscape in tabpage Page"
  '/// Test Landscape in tabpage Page

   Call hNewDocument

   '/// Input a long test string
    Call wDokSchreiben sTestString

   '/// Format/Page , tabpage page , check 'Landscape'
    fFormatPageWriter("TabSeite")
     Papierformat.Select iFormat
     Wait 500
     Quer.Check
     Wait 500
    TabSeite.OK

   '/// Check if Checkbox -- Landscape works fine
    Call wDokSchreiben "<Shift Home>"
    EditCopy
    wait 500
    if Len(GetClipboardText) > iRepectLength then Warnlog "Checkbox Landscape doesn't work fine!"

   Call hCloseDocument

endcase

'-------------------------------------------------------------------------------------------

testcase tFormatPage_4

  Dim  iFormat            as Integer
  Dim  sWidth   , sHeight as String

  iFormat = 2   'A4 paper

  PrintLog "- Width and Height boxes must change after changing between Portrait and Landscape"
  '/// Width and Height boxes must change after changing between Portrait and Landscape

   Call hNewDocument

   '/// Format/Page  tabpage page ,
   '/// + check 'Portrait' first and get width and height ,
   '/// + then change from Portrait to Landscape
   '/// + check if the change is effective
    fFormatPageWriter("TabSeite")
      Papierformat.Select iFormat
      Wait 500
      Hoch.Check
      Sleep 1
      sWidth  = Breite.GetText
      sHeight = Hoehe.GetText

      Quer.Check
      Sleep 1
      if Breite.GetText <> sHeight  then Warnlog "Width isn't changed when changing from Portrait to Landscape !"
      if Hoehe.GetText  <> sWidth   then Warnlog "Height isn't changed when changing from Portrait to Landscape !"
    TabSeite.Cancel

   '/// Format/Page  tabpage page ,
   '/// + check 'Landscape' first and get width and height ,
   '/// + then change from Landscape to Portrait
   '/// + check if the change is effective
    fFormatPageWriter("TabSeite")
      Papierformat.Select iFormat
      Wait 500
      Quer.Check
      Sleep 1
      sWidth  = Breite.GetText
      sHeight = Hoehe.GetText

      Hoch.Check
      Sleep 1
      if Breite.GetText <> sHeight  then Warnlog "Width isn't changed when changing from Landscape to Portrait !"
      if Hoehe.GetText  <> sWidth   then Warnlog "Height isn't changed when changing from Landscape to Portrait !"
    TabSeite.Cancel

   Call hCloseDocument

endcase

'-------------------------------------------------------------------------------------------

testcase tFormatPage_5

  Dim iFormat                                   as Integer
  Dim sWidth   , sHeight                        as String
  Dim sLeft    , sRight    , sUp   , sBottom    as String  ' set page size
  Dim sLeft1   , sRight1   , sUp1  , sBottom1   as String  ' get page size

  iFormat    = 2   'A4 paper
  sWidth     = "20" + seperator + "00" + measurementUnit
  sHeight    = "25" + seperator + "00" + measurementUnit

  sLeft      = "15" + seperator + "00" + measurementUnit
  sRight     = "15" + seperator + "00" + measurementUnit
  sUp        = "15" + seperator + "00" + measurementUnit
  sBottom    = "15" + seperator + "00" + measurementUnit

  sLeft1     = "15" + seperator + "00" + measurementUnit
  sRight1    = "4"  + seperator + "50" + measurementUnit
  sUp1       = "15" + seperator + "00" + measurementUnit
  sBottom1   = "9"  + seperator + "50" + measurementUnit

  PrintLog "- The sum of 'Left margin' and 'Right margin' must always stay below the Paper width."
  PrintLog "  (Same for top/bottom and height)"
  '/// The sum of "Left margin" and "Right margin" must always stay below the Paper width.
  '/// (Same for top/bottom and height)

   Call hNewDocument

   '/// Format/Page , tabpage Page , set width and height , close the dialog
    fFormatPageWriter("TabSeite")
      Papierformat.Select iFormat
      Wait 500
      Hoch.Check
      Sleep 1
      Breite.SetText  sWidth
      Wait 500
      Hoehe.SetText   sHeight
      Wait 500
    TabSeite.OK

   '/// Format/Page , tabpage Page ,
   '/// + Set the sum of "Left margin" and "Right margin" more than Width
    fFormatPageWriter("TabSeite")
      Links.SetText   sLeft
      Wait 500
      Rechts.SetText  sRight
      Wait 500
    TabSeite.OK

   '/// Check if the setting is OK
    fFormatPageWriter("TabSeite")
      if Links.GetText   <>  sLeft1   then Warnlog "The Margin(left) is wrong!"
      if Rechts.GetText  <>  sRight1  then Warnlog "The Margin(right) is wrong!"
    TabSeite.Cancel

   '/// Format/Page , tabpage Page ,
   '/// + Set the sum of "Up margin" and "Bottom margin" more than Heigth
    fFormatPageWriter("TabSeite")
      Oben.SetText   sUp
      Wait 500
      Unten.SetText  sBottom
      Wait 500
    TabSeite.OK

   '/// Check if the setting is OK
    fFormatPageWriter("TabSeite")
      if Oben.GetText   <>  sUp1      then Warnlog "The Margin(Up) is wrong!"
      if Unten.GetText  <>  sBottom1  then Warnlog "The Margin(Bottom) is wrong!"
    TabSeite.Cancel

   Call hCloseDocument

endcase

'-------------------------------------------------------------------------------------------

testcase tFormatPage_6

  Dim iPaperTray     , iPageLayout                       as Integer
  Dim iFormatLayout  , iReferenceStyle                   as Integer
  Dim sWidth         , sHeight                           as String
  Dim sLeft          , sRight         , sUp  , sBottom   as String

  Dim sTestFile                                          as String

  iPaperTray    = 1 :  iPageLayout     = 2
  iFormatLayout = 2 :  iReferenceStyle = 5

  sWidth        = "20" + seperator + "00" + measurementUnit
  sHeight       = "25" + seperator + "00" + measurementUnit
  sLeft         = "2"  + seperator + "00" + measurementUnit
  sRight        = "2"  + seperator + "00" + measurementUnit
  sUp           = "2"  + seperator + "00" + measurementUnit
  sBottom       = "2"  + seperator + "00" + measurementUnit

  sTestFile     = ConvertPath(gOfficepath + "user\work\tFormatPage_6.sxw")
  if hFileExists ( sTestFile ) then app.kill ( sTestFile )

  PrintLog "- Test Pre-defined formats"
  '/// Test Pre-defined formats

   Call hNewDocument

   '/// Format/Page , tabpage page , do some configuration
    fFormatPageWriter("TabSeite")
     Hoch.Check
     Wait 500
     Breite.SetText       sWidth
     Wait 500
     Hoehe.SetText        sHeight
     Wait 500
     Schacht.Select       iPaperTray
     Wait 500
     Links.SetText        sLeft
     Wait 500
     Rechts.SetText       sRight
     Wait 500
     Oben.SetText         sUp
     Wait 500
     Unten.SetText        sBottom
     Wait 500
     Seitenlayout.Select  iPageLayout
     Wait 500
     Numerierung.Select   iFormatLayout
     Wait 500
     Einschalten.Check
     Sleep 1
     AbsatzVorlage.Select iReferenceStyle
     Wait 500
    TabSeite.OK

   '/// Save the file  , close the file and reload the file
    Call hSpeichernUnter(sTestFile)
   Call hCloseDocument

   Call hNewDocument

    Call hDateiOeffnen(sTestFile)

   '/// Check if Pre-defined formats are correct
    fFormatPageWriter("TabSeite")
     if Hoch.IsChecked            <> TRUE            then Warnlog "Portrait should be checked!"
     if Breite.GetText            <> sWidth          then Warnlog "The width is wrong!"
     if Hoehe.GetText             <> sHeight         then Warnlog "The height is wrong!"
     if Schacht.GetSelIndex       <> iPaperTray      then Warnlog "The Paper tray is wrong!"
     if Links.GetText             <> sLeft           then Warnlog "The Margin(left) is wrong!"
     if Rechts.GetText            <> sRight          then Warnlog "The Margin(right) is wrong!"
     if Oben.GetText              <> sUp             then Warnlog "The Margin(top) is wrong!"
     if Unten.GetText             <> sBottom         then Warnlog "The Margin(bottom) is wrong!"
     if Seitenlayout.GetSelIndex  <> iPageLayout     then Warnlog "The paper layout is wrong!"
     if Numerierung.GetSelIndex   <> iFormatLayout   then Warnlog "The layout settings(format) is wrong!"
     if Einschalten.IsChecked     <> TRUE            then Warnlog "Portrait should be checked!"
     if AbsatzVorlage.GetSelIndex <> iReferenceStyle then Warnlog "The reference style is wrong!"
    TabSeite.Cancel

   Call hCloseDocument

endcase

'-------------------------------------------------------------------------------------------

testcase tFormatPage_7

  Dim iPaperTray     , iPageLayout                       as Integer
  Dim iFormatLayout  , iReferenceStyle                   as Integer
  Dim sWidth         , sHeight                           as String
  Dim sLeft          , sRight         , sUp  , sBottom   as String

  iPaperTray    = 1 :  iPageLayout     = 2
  iFormatLayout = 2 :  iReferenceStyle = 5

  sWidth        = "20" + seperator + "00" + measurementUnit
  sHeight       = "25" + seperator + "00" + measurementUnit
  sLeft         = "2"  + seperator + "00" + measurementUnit
  sRight        = "2"  + seperator + "00" + measurementUnit
  sUp           = "2"  + seperator + "00" + measurementUnit
  sBottom       = "2"  + seperator + "00" + measurementUnit

  PrintLog "- Test user defined formats"
  '/// Test user defined formats

   Call hNewDocument

   '/// Format/Page , tabpage page , do some configuration
    fFormatPageWriter("TabSeite")
     Hoch.Check
     Wait 500
     Breite.SetText       sWidth
     Wait 500
     Hoehe.SetText        sHeight
     Wait 500
     Schacht.Select       iPaperTray
     Wait 500
     Links.SetText        sLeft
     Wait 500
     Rechts.SetText       sRight
     Wait 500
     Oben.SetText         sUp
     Wait 500
     Unten.SetText        sBottom
     Wait 500
     Seitenlayout.Select  iPageLayout
     Wait 500
     Numerierung.Select   iFormatLayout
     Wait 500
     Einschalten.Check
     Sleep 1
     AbsatzVorlage.Select iReferenceStyle
     Wait 500
    TabSeite.OK

   '/// Check if user defined formats are correct
    fFormatPageWriter("TabSeite")
     if Hoch.IsChecked            <> TRUE            then Warnlog "Portrait should be checked!"
     if Breite.GetText            <> sWidth          then Warnlog "The width is wrong!"
     if Hoehe.GetText             <> sHeight         then Warnlog "The height is wrong!"
     if Schacht.GetSelIndex       <> iPaperTray      then Warnlog "The Paper tray is wrong!"
     if Links.GetText             <> sLeft           then Warnlog "The Margin(left) is wrong!"
     if Rechts.GetText            <> sRight          then Warnlog "The Margin(right) is wrong!"
     if Oben.GetText              <> sUp             then Warnlog "The Margin(top) is wrong!"
     if Unten.GetText             <> sBottom         then Warnlog "The Margin(bottom) is wrong!"
     if Seitenlayout.GetSelIndex  <> iPageLayout     then Warnlog "The paper layout is wrong!"
     if Numerierung.GetSelIndex   <> iFormatLayout   then Warnlog "The layout settings(format) is wrong!"
     if Einschalten.IsChecked     <> TRUE            then Warnlog "Portrait should be checked!"
     if AbsatzVorlage.GetSelIndex <> iReferenceStyle then Warnlog "The reference style is wrong!"
    TabSeite.Cancel

   Call hCloseDocument

endcase

'-------------------------------------------------------------------------------------------

testcase tFormatPage_8

    Dim sLToRHorizontal , sRToLvertical as String
    Dim iFlag , i                       as Integer

    Select case iSprache
        case 01   : sLToRHorizontal = "Left-to-right (horizontal)"
                    sRToLvertical   = "Right-to-left (vertical)"
        case 33   : sLToRHorizontal = "De gauche à droite (horizontal)"
                    sRToLvertical   = "De droite à gauche (vertical)"
        case 34   : sLToRHorizontal = "De izquierda a derecha (horizontal)"
                    sRToLvertical   = "De derecha a izquierda (vertical)"
        case 39   : sLToRHorizontal = "Da sinistra a destra (orizzontale)"
                    sRToLvertical   = "Da destra a sinistra (verticale)"
        case 46   : sLToRHorizontal = "Vänster-till-höger (horisontellt)"
                    sRToLvertical   = "Höger-till-vänster (vertikalt)"
        case 49   : sLToRHorizontal = "Links-nach-rechts (horizontal)"
                    sRToLvertical   = "Rechts-nach-links (vertikal)"
        case 55   : sLToRHorizontal = "Da esquerda para a direita (horizontal)"
                    sRToLvertical   = "Da direita para a esquerda (vertical)"
        case 81   : sLToRHorizontal = "左から右へ(横書き)"
                    sRToLvertical   = "右から左へ(縦書き)"
        case 82   : sLToRHorizontal = "왼쪽에서 오른쪽으로 (가로)"
                    sRToLvertical   = "오른쪽에서 왼쪽으로 (세로)"
        case 86   : sLToRHorizontal = "从左向右(横写)"
                    sRToLvertical   = "从右向左(竖写)"
        case 88   : sLToRHorizontal = "從左向右(橫書)"
                    sRToLvertical   = "從右向左(直書)"
        case else : QAErrorLog "The test does not support the language " + iSprache
                    Goto endsub
    end select

   PrintLog "- Check Listbox Text Direction when Asian language support is enabled"
   '/// Check Listbox Text Direction when Asian language support is enabled

   Call hNewDocument

   '/// Set CTL unable
    Call CheckCTLSupport("Off")

   '/// 1) If system language is 81,82,86,88 ,
   '/// +  Default :the Listbox Text Direction should be visible default
   '/// 2) If system language isn't 81,82,86,88 ,
   '///     - the Listbox Text Direction should be invisible when Asian language support is unabled
   '///     - the Listbox Text Direction should be visible when Asian language support is enabled

    if iSystemSprache = 81 or iSystemSprache = 82 or iSystemSprache = 86 or iSystemSprache = 88 then
       Goto GoON
    else
       Call CheckAsianLanguageSupport("Off")
       fFormatPageWriter("TabSeite")
         if Textfluss.IsVisible =  TRUE then Warnlog "Listbox Text Direction shouldn't be visible"
       TabSeite.Cancel

       Call CheckAsianLanguageSupport("On")
GoON:
       fFormatPageWriter("TabSeite")
         if Textfluss.IsVisible = TRUE then
             iFlag = 0
             for i = 1 to Textfluss.GetItemCount
                 Textfluss.Select i
                 if Textfluss.GetSelText = sLToRHorizontal then iFlag = iFlag + 1
                 if Textfluss.GetSelText = sRToLvertical   then iFlag = iFlag + 1
             next i
             if iFlag <> Textfluss.GetItemCount then Warnlog "The content in Text Direction list box is wrong! "
         else
             Warnlog "Listbox Text Direction isn't visible."
         end if
       TabSeite.Cancel
   end if

   Call hCloseDocument

endcase

'-------------------------------------------------------------------------------------------

testcase tFormatPage_9

    Dim sLToRHorizontal , sRToLHorizontal as String
    Dim iFlag , i                         as Integer

    Select case iSprache
        case 01   : sLToRHorizontal = "Left-to-right (horizontal)"
                    sRToLHorizontal = "Right-to-left (horizontal)"
        case 33   : sLToRHorizontal = "De gauche à droite (horizontal)"
                    sRToLHorizontal = "De droite à gauche (horizontal)"
        case 34   : sLToRHorizontal = "De izquierda a derecha (horizontal)"
                    sRToLHorizontal = "De derecha a izquierda (horizontal)"
        case 39   : sLToRHorizontal = "Da sinistra a destra (orizzontale)"
                    sRToLHorizontal = "Da destra a sinistra (orizzontale)"
        case 46   : sLToRHorizontal = "Vänster-till-höger (horisontellt)"
                    sRToLHorizontal = "Höger-till-vänster (horisontellt)"
        case 49   : sLToRHorizontal = "Links-nach-rechts (horizontal)"
                    sRToLHorizontal = "Rechts-nach-links (horizontal)"
        case 55   : sLToRHorizontal = "Da esquerda para a direita (horizontal)"
                    sRToLHorizontal = "Da direita para a esquerda (horizontal)"
        case 81   : sLToRHorizontal = "左から右へ(横書き)"
                    sRToLHorizontal = "右から左へ(横書き)"
        case 82   : sLToRHorizontal = "왼쪽에서 오른쪽으로 (가로)"
                    sRToLHorizontal = "s오른쪽에서 왼쪽으로 (가로)"
        case 86   : sLToRHorizontal = "从左向右(横写)"
                    sRToLHorizontal = "从右向左(横写)"
        case 88   : sLToRHorizontal = "從左向右(橫書)"
                    sRToLHorizontal = "從右向左(橫書)"
        case else : QAErrorLog "The test does not support the language " + iSprache
                    Goto endsub
    end select

  PrintLog "- Check Listbox Text Direction when CTL is enabled"
  '/// Check Listbox Text Direction when CTL is enabled

   Call hNewDocument

   '/// Set CTL enabled
    Call CheckCTLSupport("On")

   '/// Check if 'Right to Lefe (horizontal)' appear
    fFormatPageWriter("TabSeite")
      if Textfluss.IsVisible = TRUE then
          iFlag = 0
          for i = 1 to Textfluss.GetItemCount
              Textfluss.Select i
              if Textfluss.GetSelText = sLToRHorizontal then iFlag = iFlag + 1
              if Textfluss.GetSelText = sRToLHorizontal then iFlag = iFlag + 1
          next i
          if iFlag <> 2 then Warnlog "Right to Lefe (horizontal) should appear when CTL is checked!"
      else
          Warnlog "Listbox Text Direction isn't visible."
      end if
    TabSeite.Cancel

   '/// Set CTL unable
    Call CheckCTLSupport("Off")

   '/// Check if 'Right to Lefe (horizontal)' appear
    fFormatPageWriter("TabSeite")
      if Textfluss.IsVisible = TRUE then
          iFlag = 0
          for i = 1 to Textfluss.GetItemCount
              Textfluss.Select i
              if Textfluss.GetSelText = sRToLHorizontal then Warnlog "Right to Lefe (horizontal) should not appear when CTL is unchecked!"
              if Textfluss.GetSelText = sLToRHorizontal then iFlag = 1
          next i
          if iFlag <> 1 then Warnlog "Left to Right (horizontal) should appear!"
      end if
    TabSeite.Cancel

   Call hCloseDocument

endcase

'-------------------------------------------------------------------------------------------

testcase tFormatPage_10

   PrintLog "- when Asian support and CTL are all enabled , 3 entries should be in Text Direction listbox"
   '/// when Asian support and CTL are all enabled , 3 entries should be in Text Direction listbox

   Call hNewDocument

   '/// Set Asian support enabled and Set CTL enabled
    Call CheckAsianLanguageSupport("On")
    Call CheckCTLSupport("On")

   '/// Check if there are 3 entires in Text Direction listbox
    fFormatPageWriter("TabSeite")
      if Textfluss.GetItemCount <> 3 then
          Warnlog "There should be 3 entries in Text direction listbox , but get " & Textfluss.GetItemCount
      end if
    TabSeite.Cancel

   Call hCloseDocument

endcase

'-------------------------------------------------------------------------------------------

testcase tFormatPage_11

    Dim sTestFile     as String
    Dim sMarginsLeft  as String
    Dim iPageLayout   as Integer

    sTestFile    = Convertpath (gTesttoolpath + "writer\level1\input\formatpage\pageLayout.sxw")
    sMarginsLeft = "10" + seperator + "00" + measurementUnit
    iPageLayout  = 1

    PrintLog "- Test Page layout - Right and left"
    '/// Test Page layout - Right and left

     Call hNewDocument

    '/// Open a test file ,
    '/// + There are 2 pictures in 2 pages separately ,
    '/// + and they are anchored as character
     Call hDateiOeffnen(sTestFile)

    '/// FormatPage / tabpage Page , Set left margins to 10cm ,
    '/// + and set page layout to "Right to left"
     fFormatPageWriter("TabSeite")
       Links.SetText  sMarginsLeft
       Sleep 1
       Seitenlayout.Select iPageLayout
       Sleep 1
     TabSeite.OK

    '/// Set focus to first picture , format/anchor to Page
     Call wDokSchreiben "<Shift F5>"
     Call wDokSchreiben "<Tab>"

     FormatAnchorToPage
     Sleep 1

    '/// Check its position
     fPositionAndSize("TabPositionAndSizeWriter")
       if Horizontalby.Gettext <> sMarginsLeft then  Warnlog "1-The position X isn't right , should be " &sMarginsLeft & " but get " & Horizontalby.Gettext
     TabPositionAndSizeWriter.Cancel

    '/// Set focus to second picture , format/anchor to Page
     Call wDokSchreiben "<Tab>"

     FormatAnchorToPage
     Sleep 1

    '/// Check its position
     fPositionAndSize("TabPositionAndSizeWriter")
       if Horizontalby.Gettext <> sMarginsLeft then  Warnlog "2-The position X isn't right , should be " &sMarginsLeft & " but get " & Horizontalby.Gettext
     TabPositionAndSizeWriter.Cancel

   Call hCloseDocument

endcase

'-------------------------------------------------------------------------------------------

testcase tFormatPage_12

    Dim sTestFile                     as String
    Dim sMarginsLeft  , sMarginsRight as String
    Dim iPageLayout                   as Integer

    sTestFile     = Convertpath (gTesttoolpath + "writer\level1\input\formatpage\pageLayout.sxw")
    sMarginsLeft  = "10" + seperator + "00" + measurementUnit
    sMarginsRight = "4"  + seperator + "00" + measurementUnit
    iPageLayout   = 2

    PrintLog "- Test Page layout - Mirrored"
    '/// Test Page layout - Mirrored

     Call hNewDocument

    '/// Open a test file ,
    '/// + there are 2 pictures in 2 pages separately , and they are anchored as character
     Call hDateiOeffnen(sTestFile)

    '/// FormatPage / tabpage Page , Set left margins to 10cm ,
    '/// + and set page layout to "Mirrored"
     fFormatPageWriter("TabSeite")
       Links.SetText  sMarginsLeft
       Sleep 1
       Rechts.SetText sMarginsRight
       Sleep 1
       Seitenlayout.Select iPageLayout
       Sleep 1
     TabSeite.OK

    '/// Set focus to first picture , format/anchor to Page
     Call wDokSchreiben "<Shift F5>"
     Call wDokSchreiben "<Tab>"

     FormatAnchorToPage
     Sleep 1

    '/// Check its position
     fPositionAndSize("TabPositionAndSizeWriter")
       if Horizontalby.Gettext <> sMarginsLeft then  Warnlog "1-The position X isn't right , should be " &sMarginsLeft & " but get " & Horizontalby.Gettext
     TabPositionAndSizeWriter.Cancel

    '/// Set focus to second picture , format/anchor to Page
     Call wDokSchreiben "<Tab>"

     FormatAnchorToPage
     Sleep 1

    '/// Check its position
     fPositionAndSize("TabPositionAndSizeWriter")
       if Horizontalby.Gettext <> sMarginsRight then  Warnlog "2-The position X isn't right , should be " &sMarginsRight & " but get " & Horizontalby.Gettext
     TabPositionAndSizeWriter.Cancel

   Call hCloseDocument

endcase

'-------------------------------------------------------------------------------------------

testcase tFormatPage_13

    Dim sTestFile          as String
    Dim sPage1 , sPage2    as String
    Dim iPageLayout        as Integer

    sTestFile     = Convertpath (gTesttoolpath + "writer\level1\input\formatpage\pageLayout.sxw")
    sPage1        = "1"
    sPage2        = "3"
    iPageLayout   = 3

    PrintLog "- Test Page layout - Only right"
    '/// Test Page layout - Only right

     Call hNewDocument

    '/// Open a test file ,
    '/// + there are 2 pictures in 2 pages separately
     Call hDateiOeffnen(sTestFile)

    '/// FormatPage / tabpage Page , Set left margins to 10cm ,
    '/// + and set page layout to "Only right"
     fFormatPageWriter("TabSeite")
       Seitenlayout.Select iPageLayout
       Sleep 1
     TabSeite.OK

    '/// Set focus to first picture , Check if the picture is in first page
     Call wDokSchreiben "<Shift F5>"
     Call wDokSchreiben "<Tab>"

     Kontext "Navigator"
     if Not Navigator.Exists then EditNavigator
     Kontext "NavigatorWriter"
     Sleep 1
     if Seitennummer.GetText <> sPage1 then Warnlog "1st pic isn't in page 1 !"
     fCloseNavigator
     Wait 500

    '/// Set focus to second picture , Check if the picture is in third page
     Call wDokSchreiben "<Tab>"

     Kontext "Navigator"
     if Not Navigator.Exists then EditNavigator
     Kontext "NavigatorWriter"
     Sleep 1
     if Seitennummer.GetText <> sPage2 then Warnlog "#i40333# 2nd pic isn't in page 3 !"
     fCloseNavigator
     Wait 500

   Call hCloseDocument

endcase

'-------------------------------------------------------------------------------------------

testcase tFormatPage_14

    Dim sTestFile          as String
    Dim sPage1 , sPage2    as String
    Dim iPageLayout        as Integer

    sTestFile     = Convertpath (gTesttoolpath + "writer\level1\input\formatpage\pageLayout.sxw")
    sPage1        = "2"
    sPage2        = "4"
    iPageLayout   = 4

    PrintLog "- Test Page layout - Only left"
    '/// Test Page layout - Only left

     Call hNewDocument

    '/// Open a test file ,
    '/// + there are 2 pictures in 2 pages separately
     Call hDateiOeffnen(sTestFile)

    '/// FormatPage / tabpage Page , Set left margins to 10cm ,
    '/// + and set page layout to "Only left"
     fFormatPageWriter("TabSeite")
       Seitenlayout.Select iPageLayout
       Sleep 1
     TabSeite.OK

    '/// Set focus to first picture , Check if the picture is in first page
     Call wDokSchreiben "<Shift F5>"
     Call wDokSchreiben "<Tab>"

     Kontext "Navigator"
     if Not Navigator.Exists then EditNavigator
     Kontext "NavigatorWriter"
     Sleep 1
     if Seitennummer.GetText <> sPage1 then Warnlog "1st pic isn't in page 2 !"
     fCloseNavigator
     Wait 500

    '/// Set focus to second picture , Check if the picture is in third page
     Call wDokSchreiben "<Tab>"

     Kontext "Navigator"
     if Not Navigator.Exists then EditNavigator
     Kontext "NavigatorWriter"
     Sleep 1
     if Seitennummer.GetText <> sPage2 then Warnlog "#i40333# 2nd pic isn't in page 4 !"
     fCloseNavigator
     Wait 500

   Call hCloseDocument

endcase

'-------------------------------------------------------------------------------------------

testcase tFormatPage_15

    Dim sType , sFormat  as String

    Select case iSprache
        case 01   : sType   = "Page"
                    sFormat = "As Page Style"
        case 33   : sType   = "Page"
                    sFormat = "D'après le style de page"
        case 34   : sType   = "Página"
                    sFormat = "Como estilo de página"
        case 39   : sType   = "Pagina"
                    sFormat = "Come modello di pagina"
        case 46   : sType   = "Sida"
                    sFormat = "Som sidformatmall"
        case 49   : sType   = "Seite"
                    sFormat = "Wie Seitenvorlage"
        case 55   : sType   = "Estatísticas"
                    sFormat = "Como Estilo de Página"
        case 81   : sType   = "ページ"
                    sFormat = "ページスタイルの設定"
        case 82   : sType   = "통계"
                    sFormat = "페이지 스타일 설정"
        case 86   : sType   = "页"
                    sFormat = "和页面样式相同"
        case 88   : sType   = "頁"
                    sFormat = "和頁面樣式相同"
        case else : QAErrorLog "The test does not support the language " + iSprache
                    Goto endsub
    end select

    PrintLog "- Insertfields / other / Document / Type/Page -> As page Style must be set."
    '/// Insertfield / other / Document / Type/Page -> As page Style must be set.

    Call hNewDocument

    '/// InsertFields / other , tabpage document , select page ,
    '/// + check if Page format is right
     Call fInsertFieldsOther("TabDokumentFeldbefehle")
         Feldtyp.Select sType
         Sleep 3
          if Formatliste.GetSelText <> sFormat then
             Warnlog "the format setting should be " & sFormat & " but get " &Formatliste.GetSelText
         end if
     TabDokumentFeldbefehle.Close

    Call hCloseDocument

endcase

'-------------------------------------------------------------------------------------------

function CheckCTLSupport( sSupport as String )  as String

'/// This function will check Complex text Layout (CTL) Support on/off based on the parameter

   ToolsOptions
   Call hToolsOptions("LANGUAGESETTINGS","LANGUAGES")

    if sSupport = "On" then
       ComplexScriptEnabled.Check
    else
       ComplexScriptEnabled.UnCheck
    end if
    Sleep 1

    Kontext "ExtrasOptionenDlg"
   ExtrasOptionenDlg.OK

end function

'-------------------------------------------------------------------------------------------

function CheckAsianLanguageSupport( sSupport as String )  as String

'/// This function will check Asina Language Support on/off based on the parameter

   ToolsOptions
   Call hToolsOptions("LANGUAGESETTINGS","LANGUAGES")
    if sSupport = "On" then
       printlog "framework/level1/CJK/inc/tools.inc::CheckAsianLanguageSupport: 'Asian Language Support' has been enabled."
       try
          Aktivieren.Check
       catch
       endcatch
    else
      if sSupport = "Off" then
         Aktivieren.UnCheck
         printlog "framework/level1/CJK/inc/tools.inc::CheckAsianLanguageSupport: 'Asian Language Support' has been disabled."
      else
         if Aktivieren.IsChecked = TRUE then CheckAsianLanguageSupport = "On" else CheckAsianLanguageSupport = "Off"
      end if
    end if
   Kontext "ExtrasOptionenDlg"
   ExtrasOptionenDlg.OK

end function
