'*************************************************************************
'*
'*  $RCSfile: wr_o_a.inc,v $
'*
'*  $Revision: 1.6 $
'*
'*  last change: $Author: hde $ $Date: 2005/05/24 13:29:17 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/***********************************************************************
'*
'* owner : helge.delfs@sun.com
'*
'* short description : Put description here
'*
'************************************************************************
'*
' #1 tToolsOptionsWriterPrint
' #1 tToolsOptionsWriterTableMove
' #1 tToolsOptionsWriterTableInsert
' #1 tToolsOptionsWriterTableEffects
' #1 tToolsOptionsWriterTableEffects2
' #1 tToolsOptionsWriterDirectCursor1
' #1 tToolsOptionsWriterDirectCursor2
' #1 tToolsOptionsWriterDirectCursor3
' #1 tToolsOptionsWriterDirectCursor4
'*
'\***********************************************************************


testcase tToolsOptionsWriterPrint
    ' called after my save/restart testing
    ' The real print with paper to touch - and to get from the printer :-(

    Dim i
    printlog "- Tools/Options/Writer: PrintWriter (real print)"
    Call hDateiOeffnen ( gTesttoolPath + "writer\level1\input\st1_11.sxw" )

    Printlog "  - check all (real print)"
    ToolsOptions
    Call hToolsOptions("TEXTDOCUMENT","PRINT")

    Grafiken.Check
    Tabellen.Check
    Zeichnungen.Check
    Kontrollfelder.Check
    Hintergrund.Check
    SchwarzDrucken.Check
    LinkeSeiten.Check
    RechteSeiten.Check
    Umgekehrt.Check

    Prospekt.UnCheck

    Seitenende.Check
    AusDruckereinstellung.Check

    Kontext "ExtrasOptionenDlg"
    ExtrasOptionenDlg.OK

    if (NO_REAL_PRINT = False) Then
        Printlog "   - print 1"
        kontext "funktionsleiste"
        Drucken
        for i=1 to 10
            Kontext "Druckbestaetigung"
            if Druckbestaetigung.Exists then
                sleep 1
            else
                i=100
            end if
        next i
        Sleep 3
    end if

    ToolsOptions
    Call hToolsOptions("TEXTDOCUMENT","PRINT")

    Printlog "  - uncheck everything"

    Grafiken.UnCheck
    Tabellen.UnCheck
    Zeichnungen.UnCheck
    Kontrollfelder.UnCheck
    Hintergrund.UnCheck
    SchwarzDrucken.UnCheck
    LinkeSeiten.Check               ' that's so, otherwise there will be no printing
    RechteSeiten.Check              ' that's so, otherwise there will be no printing
    Umgekehrt.UnCheck
    Prospekt.UnCheck
    Keine.Check
    AusDruckereinstellung.UnCheck

    Kontext "ExtrasOptionenDlg"
    ExtrasOptionenDlg.OK
    Sleep 10

    if (NO_REAL_PRINT = False) Then
        Printlog "   - print 2"
        kontext "funktionsleiste"
        Drucken
        for i=1 to 10
            Kontext "Druckbestaetigung"
            if Druckbestaetigung.Exists then
                sleep 1
            else
                i=100
            end if
        next i
        Sleep 3
    end if

    'If this testcase runs alone next line has to be integrated
    Call hCloseDocument
    Call wOptionenUndo ( "Drucken" )
endcase

'------------------------------------------------------------------------------

testcase tToolsOptionsWriterTableMove
    Dim sLager$
    Dim Spalte1 as Double : Dim Spalte2 as Double : Dim Zeile1 as Double : Dim Zeile2 as Double
    Dim Abstaende(3) as Double : Dim AbLi as Double : Dim AbRe as Double
    Dim VerschubZeile as Double : Dim VerschubSpalte as Double
    Dim sSeparator as string

    Dim sRow1 as string

    ' Hints if there are some errors:
    ' win2000: Start::Systemsteuerung::Laendereinstellungen::Gebietsschema
    ' winXP  : Sart::ControlPanel::Regional and Language Options:: Region Options:: Standards&formats

    Call hNewDocument
    ToolsOptions     ' Vorraussetzung : Masseinheit auf Zentimeter !
    Call hToolsOptions("TEXTDOCUMENT","GENERAL")
    Masseinheit.Select 2
    sSeparator = GetDecimalSeperator ( Tabulatorenabstand.GetText )
    Kontext "ExtrasOptionenDlg"
    ExtrasOptionenDlg.OK
    printlog "'///- Tools / Options / Table: Move"
    ToolsOptions
    Call hToolsOptions("TEXTDOCUMENT","TABLE")

    Printlog "'///  - check minimum settings"
    if gPlatform="solaris" then
        sLager$ = sSeparator + "25" + mUnit
    else
        sLager$ = "0" + sSeparator + "25" + mUnit
    end if
    VerschiebenZeile.ToMin
    if sLager$ <> VerschiebenZeile.GetText then Warnlog "Zeile verschieben ist nicht auf Minimum ( " + sLager$ + " ) eingestellt, sondern auf " +VerschiebenZeile.GetText
    VerschiebenSpalte.ToMin
    if sLager$ <> VerschiebenSpalte.GetText then Warnlog "Spalte verschieben ist nicht auf Minimum ( " + sLager$ + " ) eingestellt, sondern auf " +VerschiebenZeile.GetText

    Printlog "'///  - Einstellungen vornehmen ///"
    VerschiebenZeile.SetText "1" + sSeparator + "00"
    VerschiebenSpalte.SetText "1" + sSeparator + "25"
    VerschubZeile = 1.00
    VerschubSpalte = 1.25

    Variabel.Check
    Sleep 1
    Kontext "ExtrasOptionenDlg"
    ExtrasOptionenDlg.OK

    Printlog "'///  - Tabelle einf?gen ///"
    InsertTableWriter
    Kontext "TabelleEinfuegenWriter"
    Spalten.SetText "2"
    Zeilen.SetText "2"
    TabelleEinfuegenWriter.OK

    Printlog "'///  - Die Normalhoehe der Zeilen einlesen ///"
    Call wDokSchreiben "<Left><Mod2 Down>"
    Call wDokSchreiben "<Left><Mod2 Up>"

    ' **   Grundwerte der Tabelle holen ( alles schon in Double und rechenbar ) since 05.02.2001 ;-)
    Spalte1 = SpaltenBreiteHolen

    FormatRowHeight
    Kontext "Zellenhoehe"
    sRow1 = Hoehe.GetText
    Zellenhoehe.OK

    Zeile1  = ZeilenHoeheHolen
    Call wDokSchreiben "<Right>"
    Spalte2 = SpaltenBreiteHolen
    Call wDokSchreiben "<Down>"
    Zeile2  = Zeile1
    Call wDokSchreiben "<Up><Left>"
    SeitenAbstaendeHolen ( Abstaende() )
    AbLi = Abstaende(1)
    AbRe = Abstaende(2)

    Printlog "Startwerte"
    Printlog "Breiten    :   Spalte 1: "+ Spalte1+"      Spalte 2: "+ Spalte2
    Printlog "Hhen      :   Zeile  1: "+ Zeile1 +"      Zeile  2: "+ Zeile2 + Chr(13)

    Printlog "'///  - per <Alt Left> die 1. Spalte von rechts verkleinern ///"
    Call wDokSchreiben "<Mod2 Left>"
    SpaltenBreiteTesten ( ( Spalte1-VerschubZeile ) )
    SeitenAbstaendeTesten ( 0.00, VerschubZeile )

    Printlog "'///  - per <Shift Alt Right> die 1. Spalte von links verkleinern ///"
    Call wDokSchreiben "<Shift Mod2 Right>"
    SpaltenBreiteTesten ( (Spalte1 - VerschubZeile *2) )
    SeitenAbstaendeTesten ( VerschubZeile, VerschubZeile )

    Printlog "'///  - per <Alt Right> die 1. Spalte 2 mal nach rechts vergrern ///"
    Call wDokSchreiben "<Mod2 Right>"
    Call wDokSchreiben "<Mod2 Right>"
    SpaltenBreiteTesten ( Spalte1 )
    SeitenAbstaendeTesten ( VerschubZeile, 0 )

    Printlog "'///  - die Daten der 2. Spalte ?berpr?fen ///"
    Call wDokSchreiben "<Right>"
    SpaltenBreiteTesten ( (Spalte2 - VerschubZeile) )
    SeitenAbstaendeTesten ( VerschubZeile, 0 )

    Printlog " '/// - per <Alt Left> die 2. Spalte von rechts verkleinern ///"
    Call wDokSchreiben "<Mod2 Left>"
    wait 100
    SpaltenBreiteTesten ( (Spalte2 - VerschubZeile*2) )
    SeitenAbstaendeTesten ( VerschubZeile, VerschubZeile )

    Printlog "'///  - per <Shift Alt Right> die 2. Spalte von links verkleinern ///"
    Call wDokSchreiben "<Shift Mod2 Right>"
    SpaltenBreiteTesten ( (Spalte2 - VerschubZeile*3) )
    SeitenAbstaendeTesten ( VerschubZeile*2, VerschubZeile )

    Printlog "'///  - per <Shift Alt Left> die 2. Spalte 2 mal nach links vergrern ///"
    Call wDokSchreiben "<Shift Mod2 Left>"
    Call wDokSchreiben "<Shift Mod2 Left>"
    SpaltenBreiteTesten ( (Spalte2-VerschubZeile) )
    SeitenAbstaendeTesten ( 0, VerschubZeile )

    Printlog "'///  - per <Shift Alt Left> die 2. Spalte nach rechts vergrern ///"
    Call wDokSchreiben "<Mod2 Right>"
    SpaltenBreiteTesten ( (Spalte2) )
    SeitenAbstaendeTesten ( 0, 0 )

    Printlog "'///  - per <Alt Down> die 1. Spalte nach unten vergrern ///"
    Call wDokSchreiben "<Left><Mod2 Down>"
    ZeilenHoeheTesten ( Zeile1+VerschubSpalte )
    SeitenAbstaendeTesten ( 0, 0 )

    Printlog "'///  - per <Shift Alt Up> die 1. Spalte nach unten vergrern ///"
    Call wDokSchreiben "<Mod2 Down>"
    ZeilenHoeheTesten ( Zeile1+VerschubSpalte*2 )
    SeitenAbstaendeTesten ( 0, 0 )

    Printlog "'///  - per <Shift Alt Down> die 1. Spalte nach oben verkleinern ///"
    Call wDokSchreiben "<Shift Mod2 Down>"
    ZeilenHoeheTesten ( Zeile1+VerschubSpalte )
    SeitenAbstaendeTesten ( 0, 0 )

    Printlog "'///  - per <Alt Up> die 1. Spalte nach oben verkleinern /// -------------------------"
    Call wDokSchreiben "<Mod2 Up>"
    ZeilenHoeheTesten ( ( Zeile1 ) )
    SeitenAbstaendeTesten ( 0, 0 )


    FormatRowHeight
    Kontext "Zellenhoehe"
    if (StrToDouble ( Hoehe.Gettext ) <> Zeile1 ) then
        Hoehe.More
        printlog " tbo:  Have To Get BugId :-)... think it's 'wrong cutted' internaly since 5.2 :-<"
        printlog "  from now on, there is an offset to the original of 10mm"
        Zeile2 = Zeile2 + ( StrToDouble ( Hoehe.Gettext ) - Zeile2 )
    end if
    Zellenhoehe.OK

    Printlog "'///  - per <Alt Down> die 2. Spalte nach unten vergrern ///"
    Call wDokSchreiben "<Right><Mod2 Down>"
    ZeilenHoeheTesten ( ( Zeile2+VerschubSpalte*2/2 ) )
    SeitenAbstaendeTesten ( 0, 0 )

    Printlog "'///  - per <Shift Alt Up> die 2. Spalte nach unten vergrern ///"
    Call wDokSchreiben "<Mod2 Down>"
    ZeilenHoeheTesten ( ( Zeile2+VerschubSpalte*2 ) )
    SeitenAbstaendeTesten ( 0, 0 )

    Printlog "'///  - per <Shift Alt Down> die 2. Spalte nach oben verkleinern ///"
    Call wDokSchreiben "<Shift Mod2 Down>"
    ZeilenHoeheTesten ( ( Zeile2+VerschubSpalte*2/2 ) )
    SeitenAbstaendeTesten ( 0, 0 )

    Printlog "'///  - per <Alt Up> die 2. Spalte nach oben verkleinern ///"
    Call wDokSchreiben "<Mod2 Up>"
    ZeilenHoeheTesten ( ( Zeile2 ) )
    SeitenAbstaendeTesten ( 0, 0 )

    Call hCloseDocument
    Call wOptionenUndo "Tabelle"
endcase

'------------------------------------------------------------------------------

testcase tToolsOptionsWriterTableInsert
    Dim sLager$
    Dim Spalte1 as Double : Dim Spalte2 as Double : Dim Zeile as Double
    Dim VerschubZeile as Double : Dim VerschubSpalte as Double
    Dim sSeparator as string

    printlog "'///- Extras/Optionen/Tabelle: Einf?gen ///"
    ToolsOptions
    Call hToolsOptions("TEXTDOCUMENT","TABLE")

    Printlog "'///  - Einstellungen vornehmen ///"
    sSeparator = GetDecimalSeperator(EinfuegenZeile.GetText)
    EinfuegenZeile.SetText "0" + sSeparator + "73"
    VerschubZeile = 0.73
    EinfuegenSpalte.SetText "3" + sSeparator + "15"
    VerschubSpalte = 3.15
    Variabel.Check
    Sleep 1
    Kontext "ExtrasOptionenDlg"
    ExtrasOptionenDlg.OK

    Printlog "'///  - Tabelle einf?gen ///"
    Call hNewDocument
    InsertTableWriter
    Kontext "TabelleEinfuegenWriter"
    Spalten.SetText "2"
    Zeilen.SetText "2"
    TabelleEinfuegenWriter.OK

    ' **   Grundwerte der Tabelle holen ( alles schon in Double und rechenbar )
    Spalte1 = SpaltenBreiteHolen
    Zeile  = ZeilenHoeheHolen
    Call wDokSchreiben "<Right>"
    Spalte2 = SpaltenBreiteHolen
    ' **

    Printlog "'///  - per <Alt Insert><Up> eine Zeile von oben einf?gen ///"
    Call wDokSchreiben "<Mod2 Insert><Up>"
    ZeilenHoeheTesten ( VerschubZeile )
    SeitenAbstaendeTesten ( 0.00, 0.00 )
    ZeilenTesten ( 3 )
    SpaltenTesten ( 2 )

    Printlog "'///  - per <Alt Insert><Down> eine Zeile von unten einf?gen ///"
    Call wDokSchreiben "<Down><Mod2 Insert><Down>"
    ZeilenHoeheTesten ( VerschubZeile )
    ZeilenTesten ( 4 )
    SpaltenTesten ( 2 )

    Printlog "'///  - per <Alt Delete><Up> die 1. Zeile von oben lschen ///"
    Call wDokSchreiben "<Mod2 Delete><Up>"
    ZeilenHoeheTesten ( 0.01 )
    ZeilenTesten ( 3 )
    SpaltenTesten ( 2 )

    Printlog "'///  - per <Alt Delete><Down> die 1. Zeile von unten lschen ///"
    Call wDokSchreiben "<Mod2 Delete><Down>"
    ZeilenHoeheTesten ( VerschubZeile )
    ZeilenTesten ( 2 )
    SpaltenTesten ( 2 )

    Printlog "'///  - per <Alt Insert><Left> eine Spalte von links einf?gen ///"
    Call wDokSchreiben "<Mod2 Insert><Left>"
    SpaltenBreiteTesten ( VerschubSpalte )
    SeitenAbstaendeTesten ( 0.00, 0.00 )
    ZeilenTesten ( 2 )
    SpaltenTesten ( 3 )

    Printlog "'///  - per <Alt Insert><Right> eine Spalte von rechts einf?gen ///"
    Call wDokSchreiben "<Right><Right><Mod2 Insert><Right>"
    SpaltenBreiteTesten ( VerschubSpalte )
    ZeilenTesten ( 2 )
    SpaltenTesten ( 4 )

    Printlog "'///  - per <Alt Delete><Left> die 1. Spalte von links lschen ///"
    Call wDokSchreiben "<Mod2 Delete><Left>"
    DocumentWriter.TypeKeys "<Up>"
    SpaltenBreiteTesten ( Spalte1-VerschubSpalte )
    ZeilenTesten ( 2 )
    SpaltenTesten ( 3 )
    Call wDokSchreiben "<Right>"
    SeitenAbstaendeTesten ( VerschubSpalte, 0.00 )

    Printlog "'///  - per <Alt Delete><Right> die letzte Spalte von rechts lschen ///"
    Call wDokSchreiben "<Right><Right><Mod2 Delete><Right>"
    SpaltenBreiteTesten ( Spalte2-VerschubSpalte )
    ZeilenTesten ( 2 )
    SpaltenTesten ( 2 )
    SeitenAbstaendeTesten ( VerschubSpalte, Spalte2 -VerschubSpalte )

    Call hCloseDocument
    Call wOptionenUndo "Tabelle"
endcase
' ************************************************************************
testcase tToolsOptionsWriterTableEffects
    Dim Spalte1 as Double : Dim Spalte2 as Double : Dim Spalte3 as Double
    Dim VerschubZeile as Double

    printlog "'///- Extras/Optionen/Tabelle: Einf?gen ///"
    ToolsOptions
    Call hToolsOptions("TEXTDOCUMENT","TABLE")
    VerschubZeile = ZahlAusSpinnfield ( VerschiebenZeile.GetText )
    VerhaltenFix.Check
    Kontext "ExtrasOptionenDlg"
    ExtrasOptionenDlg.OK

    printlog "'///  - Fix: nderungen nur auf den direkten Nachbarn ///"
    Call hNewDocument
    InsertTableWriter
    Kontext "TabelleEinfuegenWriter"
    Spalten.SetText "3"
    Zeilen.SetText "2"
    TabelleEinfuegenWriter.OK

    Spalte1 = SpaltenBreiteHolen
    Call wDokSchreiben "<Right>"
    Spalte2 = SpaltenBreiteHolen
    Call wDokSchreiben "<Right>"
    Spalte3 = SpaltenBreiteHolen
    Kontext "DocumentWriter"
    DocumentWriter.TypeKeys "<Left>", 3

    Printlog "'///    - per <Alt Left> die 1. Spalte von rechts verkleinern ///"
    Call wDokSchreiben "<Mod2 Left>"
    SpaltenBreiteTesten ( ( Spalte1-VerschubZeile ) )
    Call wDokSchreiben "<Right>"
    SpaltenBreiteTesten ( ( Spalte2+VerschubZeile ) )
    Call wDokSchreiben "<Right>"
    SpaltenBreiteTesten ( ( Spalte3 ) )
    SeitenAbstaendeTesten ( 0.00, 0.00 )

    Kontext "DocumentWriter"
    DocumentWriter.TypeKeys "<Left>", 3
    Printlog "'///    - per <Alt Shift Right> darf nichts passieren ///"
    Call wDokSchreiben "<Mod2 Shift Left>"
    SpaltenBreiteTesten ( ( Spalte1-VerschubZeile ) )
    Call wDokSchreiben "<Right>"
    SpaltenBreiteTesten ( ( Spalte2+VerschubZeile ) )
    Call wDokSchreiben "<Right>"
    SpaltenBreiteTesten ( ( Spalte3 ) )
    SeitenAbstaendeTesten ( 0.00, 0.00 )

    Kontext "DocumentWriter"
    DocumentWriter.TypeKeys "<Left>", 3
    Printlog "'///    - per <Alt Right> Grundzustand wieder herstellen ///"
    Call wDokSchreiben "<Mod2 Right>"
    SpaltenBreiteTesten ( ( Spalte1 ) )
    Call wDokSchreiben "<Right>"
    SpaltenBreiteTesten ( ( Spalte2 ) )
    Call wDokSchreiben "<Right>"
    SpaltenBreiteTesten ( ( Spalte3 ) )
    SeitenAbstaendeTesten ( 0.00, 0.00 )

    Printlog "'///    - per <Alt Down> wird die Zeile nach unten grer ///"
    Call wDokSchreiben "<Mod2 Down>"
    ZeilenHoeheTesten ( 1.17 )
    SeitenAbstaendeTesten ( 0.00, 0.00 )

    if iSprache <> 01 then
        Printlog "'///    - per <Alt Up> wird die Zeile wieder normal ///"
        Call wDokSchreiben "<Mod2 Up>"
        ZeilenHoeheTesten ( 0.7 )
        SeitenAbstaendeTesten ( 0.00, 0.00 )

        Printlog "'///    - per <Alt Shift Up> wird die Zeile nach unten grer ///"
        Call wDokSchreiben "<Mod2 Shift Up>"
        ZeilenHoeheTesten ( 1.17 )
        SeitenAbstaendeTesten ( 0.00, 0.00 )

        Printlog "'///    - per <Alt Shift Down> wird die Zeile wieder normal ///"
        Call wDokSchreiben "<Mod2 Shift Down>"
        ZeilenHoeheTesten ( 0.7 )
        SeitenAbstaendeTesten ( 0.00, 0.00 )
    end if
    Call hCloseDocument
    Call hNewDocument
    printlog "'///  - Fix, Proportional: nderungen proportional zur ganzen Tabelle ///"
    ToolsOptions
    Call hToolsOptions("TEXTDOCUMENT","TABLE"
    FixProportional.Check
    Kontext "ExtrasOptionenDlg"
    ExtrasOptionenDlg.OK

    InsertTableWriter
    Kontext "TabelleEinfuegenWriter"
    Spalten.SetText "3"
    Zeilen.SetText "2"
    TabelleEinfuegenWriter.OK

    Printlog "'///    - per <Alt Left> die 1. Spalte von rechts verkleinern ///"
    Call wDokSchreiben "<Mod2 Left>"
    SpaltenBreiteTesten ( ( Spalte1-VerschubZeile ) )
    Call wDokSchreiben "<Right>"
    SpaltenBreiteTesten ( ( Spalte2+VerschubZeile/2 ) )
    Call wDokSchreiben "<Right>"
    SpaltenBreiteTesten ( ( Spalte3+VerschubZeile/2 ) )
    SeitenAbstaendeTesten ( 0.00, 0.00 )

    Kontext "DocumentWriter"
    DocumentWriter.TypeKeys "<Left>", 3
    Printlog "'///    - per <Alt Shift Right> darf nichts passieren ///"
    Call wDokSchreiben "<Mod2 Shift Left>"
    SpaltenBreiteTesten ( ( Spalte1-VerschubZeile ) )
    Call wDokSchreiben "<Right>"
    SpaltenBreiteTesten ( ( Spalte2+VerschubZeile/2 ) )
    Call wDokSchreiben "<Right>"
    SpaltenBreiteTesten ( ( Spalte3+VerschubZeile/2 ) )
    SeitenAbstaendeTesten ( 0.00, 0.00 )

    Kontext "DocumentWriter"
    DocumentWriter.TypeKeys "<Left>", 3
    Printlog "'///    - per <Alt Right> Grundzustand wieder herstellen ///"
    Call wDokSchreiben "<Mod2 Right>"
    SpaltenBreiteTesten ( ( Spalte1 ) )
    Call wDokSchreiben "<Right>"
    SpaltenBreiteTesten ( ( Spalte2 ) )
    Call wDokSchreiben "<Right>"
    SpaltenBreiteTesten ( ( Spalte3 ) )
    SeitenAbstaendeTesten ( 0.00, 0.00 )

    if iSprache <> 01 then
        Printlog "'///    - per <Alt Down> wird die Zeile nach unten grer ///"
        Call wDokSchreiben "<Mod2 Down>"
        ZeilenHoeheTesten ( 1.2 )
        SeitenAbstaendeTesten ( 0.00, 0.00 )

        Printlog "'///    - per <Alt Up> wird die Zeile wieder normal ///"
        Call wDokSchreiben "<Mod2 Up>"
        ZeilenHoeheTesten ( 0.7 )
        SeitenAbstaendeTesten ( 0.00, 0.00 )

        Printlog "'///    - per <Alt Shift Up> wird die Zeile nach unten grer ///"
        Call wDokSchreiben "<Mod2 Shift Up>"
        ZeilenHoeheTesten ( 1.2 )
        SeitenAbstaendeTesten ( 0.00, 0.00 )

        Printlog "'///    - per <Alt Shift Down> wird die Zeile wieder normal ///"
        Call wDokSchreiben "<Mod2 Shift Down>"
        ZeilenHoeheTesten ( 0.7 )
        SeitenAbstaendeTesten ( 0.00, 0.00 )
    end if
    Call wOptionenUndo "Tabelle"

    Call hCloseDocument
endcase

'------------------------------------------------------------------------------

testcase tToolsOptionsWriterTableEffects2
    Dim Spalte1 as Double, vSeparator as string
    Dim VerschubZeile as Double
  
    vSeparator = GetDecimalSeperator
    
    printlog "'///- Tools/Options/Table: Einf?gen ///"
    printlog "'///  - Werden die Effekteinstellungen sofort aktualisiert? ///"

    Call hNewDocument

    InsertTableWriter
    Kontext "TabelleEinfuegenWriter"
    Spalten.SetText "3"
    Zeilen.SetText "2"
    TabelleEinfuegenWriter.OK

    Spalte1 = SpaltenBreiteHolen

    ToolsOptions
    Call hToolsOptions("TEXTDOCUMENT","TABLE")
    VerschubZeile = ZahlAusSpinnfield ( VerschiebenZeile.GetText )
    if NOT Variabel.IsChecked then
        Warnlog "Variable is not checked so test will be interrupted here"
        goto endsub
    else
        printlog "'///    - change 'Behaviour of columns/rows to 'Fix' ///"
        VerhaltenFix.Check
    end if
    Kontext "ExtrasOptionenDlg"
    ExtrasOptionenDlg.OK

    printlog " '///   - resize cell with <Alt Left> ///"
    Call wDokSchreiben "<Mod2 Left>"
    SpaltenBreiteTesten ( ( Spalte1-VerschubZeile ) )

    FormatTable
    Kontext
    Active.SetPage TabTabelle
    Kontext "TabTabelle"
    if ZahlAusSpinnfield ( NachRechts.GetText ) <> "0" then
        Warnlog "Table size has been changed though 'Behaviour of rows/columns has been set to 'Fix'"
    end if
    TabTabelle.Cancel

    Call hCloseDocument
    Call wOptionenUndo "Tabelle"
endcase

'------------------------------------------------------------------------------

testcase tToolsOptionsWriterDirectCursor1
    printlog "'///- Extras/Optionen/Direkt Cursor      Absatzausrichtung ///"

    Call hNewDocument
    ViewZoom
    Kontext "Massstab"
    Optimal.Check
    Massstab.OK

    Printlog "'///   - Absatzausrichtung einstellen und ?berpr?fen ///"
    ToolsOptions
    Call hToolsOptions("TEXTDOCUMENT","FORMATTINGAIDS")
    if DirektCursor.IsChecked then
        Warnlog "Der Direktcursor war schon an"
    else
        DirektCursor.Check
    end if
    AbsatzAusrichtung.Check
    Farbe.Select 8
    Kontext "ExtrasOptionenDlg"
    ExtrasOptionenDlg.OK

    Printlog " '///     - Einstellungen im Dialog ?berpr?fen ///"
    ToolsOptions
    Call hToolsOptions("TEXTDOCUMENT","FORMATTINGAIDS")
    if NOT DirektCursor.IsChecked then Warnlog "Der Direkt-Cursor ist nicht mehr gecheckt"
    if NOT AbsatzAusrichtung.IsChecked then Warnlog "Absatzausrichtung ist nicht mehr gecheckt"
    if Farbe.GetSelIndex <> 8 then Warnlog "Die Farbeinstellung wurde nicht behalten, soll 8 ist " +  Farbe.GetSelIndex
    Kontext "ExtrasOptionenDlg"
    ExtrasOptionenDlg.OK

    Printlog " '///     - mittig ansetzen ///"
    Kontext "DocumentWriter"
    DocumentWriter.MouseDoubleClick 50, 50
    DocumentWriter.TypeKeys "Mittig angesetzt"
    FormatParagraph
    Kontext
    Active.SetPage TabAusrichtungAbsatz
    Kontext "TabAusrichtungAbsatz"
    if NOT Zentriert.IsChecked then Warnlog "Cursor in der Mitte angesetzt, aber keine zentrierte Ausrichtung"
    TabAusrichtungAbsatz.Cancel
    Printlog " '///     - links ansetzen ///"
    Kontext "DocumentWriter"
    DocumentWriter.MouseDoubleClick 20, 75
    DocumentWriter.TypeKeys "Links angesetzt"
    FormatParagraph
    Kontext
    Active.SetPage TabAusrichtungAbsatz
    Kontext "TabAusrichtungAbsatz"
    if NOT Links.IsChecked then Warnlog "Cursor Links angesetzt, aber keine linke Ausrichtung"
    TabAusrichtungAbsatz.Cancel
    Printlog "      - rechts ansetzen"
    Kontext "DocumentWriter"
    DocumentWriter.MouseDoubleClick 80, 95
    DocumentWriter.Mousemove 20, 50
    DocumentWriter.TypeKeys "Rechts angesetzt"
    FormatParagraph
    Kontext
    Active.SetPage TabAusrichtungAbsatz
    Kontext "TabAusrichtungAbsatz"
    if NOT Rechts.IsChecked then Warnlog "Cursor Rechts angesetzt, aber keine rechte Ausrichtung"
    TabAusrichtungAbsatz.Cancel

    ViewZoom
    Kontext "Massstab"
    Vergroesserung100.Check
    Massstab.OK

    Call hCloseDocument
    Call wOptionenUndo "Cursor"
endcase

'------------------------------------------------------------------------------

testcase tToolsOptionsWriterDirectCursor2
    printlog "'///- Extras/Optionen/Direkt Cursor      Linker Absatzrand ///"

    Call hNewDocument
    ViewZoom
    Kontext "Massstab"
    Optimal.Check
    Massstab.OK

    Printlog "'///   - Linker Absatzrand einstellen und ?berpr?fen ///"
    ToolsOptions
    Call hToolsOptions("TEXTDOCUMENT","FORMATTINGAIDS")
    DirektCursor.Check
    LinkerAbsatzrand.Check
    Farbe.Select 10
    Kontext "ExtrasOptionenDlg"
    ExtrasOptionenDlg.OK
    Printlog "      - rechts ansetzen"
    Kontext "DocumentWriter"
    DocumentWriter.MouseDoubleClick 80, 60
    DocumentWriter.Mousemove 20, 50
    DocumentWriter.TypeKeys "Rechts"
    FormatParagraph
    Kontext
    Active.SetPage TabAusrichtungAbsatz
    Kontext "TabAusrichtungAbsatz"
    if NOT Links.IsChecked then Warnlog "Cursor Rechts angesetzt, es ist aber nicht linker Rand als Ausrichtung gewhlt."
    TabAusrichtungAbsatz.Cancel
    Kontext "DocumentWriter"
    DocumentWriter.TypeKeys "<Shift Home>"
    Sleep 1
    EditCopy
    if GetClipboardText = "" then Warnlog "Vielleicht sind Tabulatoren oder Leerzeichen eingef?gt worden."

    ViewZoom
    Kontext "Massstab"
    Vergroesserung100.Check
    Massstab.OK

    Call hCloseDocument
    Call wOptionenUndo "Cursor"
endcase

'------------------------------------------------------------------------------

testcase tToolsOptionsWriterDirectCursor3
    printlog "'///- Extras/Optionen/Direkt Cursor      Tabulatoren ///"

    Call hNewDocument
    ViewZoom
    Kontext "Massstab"
    Optimal.Check
    Massstab.OK

    Printlog "'///   - Tabulatoren einstellen und ?berpr?fen ///"
    ToolsOptions
    Call hToolsOptions("TEXTDOCUMENT","FORMATTINGAIDS")
    DirektCursor.Check
    Tabulator.Check
    Farbe.Select 15
    Kontext "ExtrasOptionenDlg"
    ExtrasOptionenDlg.OK

    Printlog " '///     - rechts ansetzen ///"
    Kontext "DocumentWriter"
    DocumentWriter.MouseDoubleClick 80, 60
    DocumentWriter.Mousemove 20, 50
    DocumentWriter.TypeKeys "Rechts"
    FormatParagraph
    Kontext
    Active.SetPage TabAusrichtungAbsatz
    Kontext "TabAusrichtungAbsatz"
    if NOT Links.IsChecked then Warnlog "Cursor Rechts angesetzt, es ist aber nicht linker Rand als Ausrichtung gewhlt."
    TabAusrichtungAbsatz.Cancel
    Kontext "DocumentWriter"
    DocumentWriter.TypeKeys "<Up>", 10
    DocumentWriter.TypeKeys "<Right>", 10
    DocumentWriter.TypeKeys "<Shift End>"
    Sleep 1
    EditCopy
    if GetClipboardText = "" then Warnlog "Vielleicht sind Leerzeichen eingef?gt worden."

    ViewZoom
    Kontext "Massstab"
    Vergroesserung100.Check
    Massstab.OK

    Call hCloseDocument
    Call wOptionenUndo "Cursor"
endcase

'------------------------------------------------------------------------------

testcase tToolsOptionsWriterDirectCursor4
    printlog "'///- Extras/Optionen/Direkt Cursor      Tabulatoren und Leerzeichen ///"

    Call hNewDocument
    ViewZoom
    Kontext "Massstab"
    Optimal.Check
    Massstab.OK

    Printlog "'///   - Tabulatoren und Leerzeichen einstellen und ?berpr?fen ///"
    ToolsOptions
    Call hToolsOptions("TEXTDOCUMENT","FORMATTINGAIDS")
    DirektCursor.Check
    TabulatorUndLeerzeichen.Check
    Farbe.Select 35
    Kontext "ExtrasOptionenDlg"
    ExtrasOptionenDlg.OK

    Printlog " '///     - rechts ansetzen ///"
    Kontext "DocumentWriter"
    DocumentWriter.MouseDoubleClick 80, 70
    DocumentWriter.Mousemove 20, 50
    Sleep 1
    DocumentWriter.TypeKeys "Rechts"
    FormatParagraph
    Kontext
    Active.SetPage TabAusrichtungAbsatz
    Kontext "TabAusrichtungAbsatz"
    if NOT Links.IsChecked then Warnlog "Cursor Rechts angesetzt, es ist aber nicht linker Rand als Ausrichtung gewhlt."
    TabAusrichtungAbsatz.Cancel
    Kontext "DocumentWriter"
    DocumentWriter.TypeKeys "<Home>"
    DocumentWriter.TypeKeys "<Up>", 10
    DocumentWriter.TypeKeys "<Right>", 14
    DocumentWriter.TypeKeys "<Shift End>"
    Sleep 1
    EditCopy
    if GetClipboardText = "" then Warnlog "Vielleicht sind Leerzeichen eingef?gt worden."

    ViewZoom
    Kontext "Massstab"
    Vergroesserung100.Check
    Massstab.OK

    Call hCloseDocument
    Call wOptionenUndo "Cursor"
endcase


