'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  $RCSfile: oasis_graphics_update.bas,v $
'*
'*  $Revision: 1.3 $
'*
'*  last change: $Author: jsi $ $Date: 2005/07/04 10:08:15 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/**********************************************************************************
'*
'* owner : joerg.sievers@sun.com
'*
'* short description : OASIS OpenDocument Fileformat Test (Presentation and Drawing)
'*
'\***********************************************************************************

Dim gPresentationFilter as string
Dim gDrawingFilter as string

sub main   
    printlog "-------------------------------------------------------------------"
    printlog "- OASIS OpenDocument file format Test (Presentation and Drawing)  -"
    printlog "-------------------------------------------------------------------"
       
    use "xml\update\inc\oasis_graphics_01.inc"
    Call sSoftwareConfiguration
       
    call hStatusIn ("XML" , "oasis_graphics_update.bas")
        call talien_attributes
        call t_all_header_footer
        call t_no_header_footer
        call t_no_header_footer_master_elements
        call t_some_header_footer              
    call hStatusOut
end sub

'-------------------------------------------------------------------------

sub LoadIncludeFiles
   use "global\system\inc\master.inc"
   use "global\system\inc\gvariabl.inc"
   use "global\tools\inc\t_xml2.inc"
   Call GetUseFiles   
end sub

'-------------------------------------------------------------------------

sub sSoftwareConfiguration
'/// Setting the software into a defined state.
    Dim sUIFilternamePresentation as string    
    Dim vExtensionPresentation(10) as string
    Dim sPresentationFilterReference as string

    Dim sUIFilternameDrawing as string    
    Dim vExtensionDrawing(10) as string
    Dim sDrawingFilterReference as string

    'Needed lib for the call to 'CreateWorkXMLExportDir'
    use "xml\tools\xmltool1.inc"    
    
    'Creating the directory for the exported files.
    call CreateWorkXMLExportDir ( "user\work\xml\graphics\update\" )
                   
    '/// Get the OASIS OpenDocument filter names for the application
    '///+ and verify it with a reference file.
    
    '-------------------------------------------------------------------------
    'Presentation
    '-------------------------------------------------------------------------

    gApplication   = "IMPRESS"    
    sUIFilternamePresentation = hGetUIFiltername("impress8")
    vExtensionPresentation() = hGetFilternameExtension("impress8")
    'gPresentationFilter has to be set GLOBALY for the WHOLE TEST SCRIPT!
    gPresentationFilter = sUIFilternamePresentation & " (." & vExtensionPresentation(0) & ")"              
    sPresentationFilterReference = hGetFilter()    
    
    if sPresentationFilterReference <> gPresentationFilter then        
        warnlog "Reference file for current OASIS filter (presentation) and real filter name in UI are not the same!"
        printlog "Reference file: " & sPresentationFilterReference
        printlog "UI Name in Office: " & gPresentationFilter
    end if

    '-------------------------------------------------------------------------    
    'Drawing
    '-------------------------------------------------------------------------

    gApplication   = "DRAW"
    sUIFilternameDrawing = hGetUIFiltername("draw8")
    vExtensionDrawing() = hGetFilternameExtension("draw8")
    'gDrawingFilter has to be set GLOBALY for the WHOLE TEST SCRIPT!
    gDrawingFilter = sUIFilternameDrawing & " (." & vExtensionDrawing(0) & ")"              
    sDrawingFilterReference = hGetFilter()    
    
    if sDrawingFilterReference <> gDrawingFilter then        
        warnlog "Reference file for current OASIS filter (Drawing) and real filter name in UI are not the same!"
        printlog "Reference file: " & sDrawingFilterReference
        printlog "UI Name in Office: " & gDrawingFilter
    end if        
end sub
